{$B-}
unit Editor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Menus, ImgList, BricxccSynEdit, SynEdit, ExtCtrls;

type
  TEditorForm = class(TForm)
    TheErrors: TListBox;
    ImageList1: TImageList;
    pmnuEditor: TPopupMenu;
    lmiEditUndo: TMenuItem;
    lmiEditRedo: TMenuItem;
    N2: TMenuItem;
    lmiEditCut: TMenuItem;
    lmiEditCopy: TMenuItem;
    lmiEditPaste: TMenuItem;
    lmiEditDelete: TMenuItem;
    N1: TMenuItem;
    lmiEditSelectAll: TMenuItem;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    SaveAll1: TMenuItem;
    Close1: TMenuItem;
    CloseAll1: TMenuItem;
    N11: TMenuItem;
    InsertFile1: TMenuItem;
    MenuItem1: TMenuItem;
    PageSetup1: TMenuItem;
    PrinterSetup1: TMenuItem;
    PrintPreview1: TMenuItem;
    Print1: TMenuItem;
    RecentSep: TMenuItem;
    Recent1: TMenuItem;
    Recent2: TMenuItem;
    Recent3: TMenuItem;
    Recent4: TMenuItem;
    MenuItem2: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    N12: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    SelectAll1: TMenuItem;
    N8: TMenuItem;
    Translate1xto201: TMenuItem;
    N17: TMenuItem;
    NextField1: TMenuItem;
    N16: TMenuItem;
    RefreshScreen1: TMenuItem;
    N6: TMenuItem;
    Preferences1: TMenuItem;
    Search1: TMenuItem;
    Find1: TMenuItem;
    FindNext1: TMenuItem;
    FindPrevious1: TMenuItem;
    Replace1: TMenuItem;
    N13: TMenuItem;
    GotoLineNumber1: TMenuItem;
    Compile: TMenuItem;
    mniCompileProgram: TMenuItem;
    Download1: TMenuItem;
    DownloadandRun1: TMenuItem;
    ProgramNumber1: TMenuItem;
    Program11: TMenuItem;
    Program21: TMenuItem;
    Program31: TMenuItem;
    Program41: TMenuItem;
    Program51: TMenuItem;
    N15: TMenuItem;
    Run1: TMenuItem;
    Stop1: TMenuItem;
    OpenDialog3: TOpenDialog;
    splErrors: TSplitter;
    TheEditor: TBricxccSynEdit;
    procedure TheErrorsClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure TheEditorKeyPress(Sender: TObject; var Key: Char);
    procedure TheEditorKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure TheEditorReplaceText(Sender: TObject; const ASearch,
      AReplace: String; Line, Column: Integer;
      var Action: TSynReplaceAction);
    procedure TheEditorStatusChange(Sender: TObject;
      Changes: TSynStatusChanges);
    procedure TheEditorGutterClick(Sender: TObject; X, Y, Line: Integer;
      mark: TSynEditMark);
    procedure TheEditorPlaceBookmark(Sender: TObject;
      var Mark: TSynEditMark);
    procedure TheEditorClearBookmark(Sender: TObject;
      var Mark: TSynEditMark);
    procedure pmnuEditorPopup(Sender: TObject);
    procedure lmiEditUndoClick(Sender: TObject);
    procedure lmiEditRedoClick(Sender: TObject);
    procedure lmiEditCutClick(Sender: TObject);
    procedure lmiEditCopyClick(Sender: TObject);
    procedure lmiEditDeleteClick(Sender: TObject);
    procedure lmiEditSelectAllClick(Sender: TObject);
    procedure lmiEditPasteClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Preferences1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure FindNext1Click(Sender: TObject);
    procedure FindPrevious1Click(Sender: TObject);
    procedure GotoLineNumber1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Redo1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure Translate1xto201Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure NextField1Click(Sender: TObject);
    procedure RefreshScreen1Click(Sender: TObject);
    procedure Search1Click(Sender: TObject);
    procedure Find1Click(Sender: TObject);
    procedure Replace1Click(Sender: TObject);
    procedure mniCompileProgramClick(Sender: TObject);
    procedure Download1Click(Sender: TObject);
    procedure CompileClick(Sender: TObject);
    procedure DownloadandRun1Click(Sender: TObject);
    procedure Run1Click(Sender: TObject);
    procedure Stop1Click(Sender: TObject);
    procedure Program11Click(Sender: TObject);
    procedure File1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure SaveAll1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure CloseAll1Click(Sender: TObject);
    procedure InsertFile1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure PrinterSetup1Click(Sender: TObject);
    procedure PageSetup1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Recent1Click(Sender: TObject);
    procedure PrintPreview1Click(Sender: TObject);
    procedure TheEditorContextHelp(Sender: TObject; word: String);
    procedure TheEditorChange(Sender: TObject);
  private
    { Private declarations }
    fSearchFromCaret: boolean;
    fFileName : string;
    fIsNQCFile : boolean;
    procedure DoSearchReplaceText(AReplace: boolean; ABackwards: boolean);
    procedure ShowSearchReplaceDialog(AReplace: boolean);
    procedure UpdatePositionOnStatusBar;
    procedure UpdateModeOnStatusBar;
    procedure UpdateModifiedOnStatusBar;
    procedure UpdateStatusBar;
    procedure GetContextHelp;
//    procedure InsertOptionInfo;
    procedure WMMDIActivate(var Message: TWMMDIActivate); message WM_MDIACTIVATE;
    procedure SetFilename(const Value: string);
  protected
    function MDI : Boolean;
    procedure CreateParams(var Params: TCreateParams); override;
    function IsNQCFile : boolean;
    procedure HookCompProp;
  public
    {File handling}
    IsNew:boolean;                     // Whether it is a new file
    procedure NewFile(fname:string);   // Create a new file in the editor
    procedure OpenFile(fname:string);  // Open an existing file
    procedure SaveFile;                // Saves the file
    procedure SaveFileAs(fname:string);// Saves the file as fname
    procedure InsertFile(fname:string);// Insert file at cursor
    {Editing}
    function  CanUndo:boolean;         // Whether you can undo something
    function  CanRedo:boolean;         // Whether you can redo something
    function  Selected:boolean;        // Whether something is selected
    function  CanFind : boolean;
    function  CanFindNext : boolean;
    function  CanReplace : boolean;
    procedure Undo;
    procedure Redo;
    procedure CutSel;
    procedure CopySel;
    procedure Paste;
    procedure DeleteSel;
    procedure SelectAll;
    procedure GotoLine;
    procedure NextField;
    procedure RefreshScreen;
    procedure AddConstructString(constr:string);
    procedure AddConstruct(numb:integer);
    procedure SetSyntaxHighlighter;
    procedure SetValuesFromPreferences;
    procedure ExecFind;
    procedure ExecFindNext;
    procedure ExecFindPrev;
    procedure ExecReplace;
    property Filename : string read fFilename write SetFilename;
  end;

var
  EditorForm: TEditorForm;

function HelpALink(const keyword: string): Boolean;

resourcestring
  sUntitled = 'Untitled';


implementation

{$R *.DFM}

uses
  MainUnit, Preferences, GotoLine, ConstructUnit, dlgSearchText,
  dlgReplaceText, dlgConfirmReplace, DTestPrintPreview, Translate, ClipBrd,
  CodeUnit, ExecProgram, SearchRCX, FakeSpirit, uCodeExplorer, uMacroForm;

resourcestring
  S_Overwrite = 'Overwrite';
  S_Insert = 'Insert';
  S_ReadOnly = 'ReadOnly';
  S_FileChanged = 'File %s has been modified. Save changes?';
  S_Modified = 'Modified';
  sErrors          = 'Errors';
  sFullErrors      = 'Full errors in';
  sCodeListing     = 'Code listing of';
  sCompileSuccess  = 'Program compiled successfully.';
  sCompileErrors   = 'Errors found on program compile.';
  sCompileDownloadSuccess  = 'Program compiled and downloaded successfully.';
  sCompileDownloadErrors   = 'Errors found on program compile and download.';
  sProgramLocked   = 'Program is locked.';

var
  bCtrlOMode : Boolean = False;

function HelpALink(const keyword: string): Boolean;
var
  QControl: array[0..255] of Char;
  Command: array[0..255] of Char;
  MacroStr: array[0..255] of Char;
  AltCmd: PChar;
begin
  Result := False;
  if Application.HelpCommand(HELP_CONTENTS, 0) then
  begin
    StrLFmt(QControl, SizeOf(QControl) - 1, 'AL("%s", 4)', [keyword]);
    StrLFmt(Command, SizeOf(Command) - 1, Chr(96) + 'AL("%s", 1)' + Chr(39), [keyword]);
    AltCmd := PChar(Chr(96) + 'JK("", "' + keyword + '")' + Chr(39));
    StrLFmt(MacroStr, SizeOf(MacroStr) - 1, 'IE( %s, %s, %s )', [QControl, Command, AltCmd]);
    Result := Application.HelpCommand(HELP_COMMAND, Longint(@MacroStr));
  end;
end;

{File Handling routines}

procedure TEditorForm.NewFile(fname:string);
begin
  IsNew    := True;
  FileName := fname;
  Caption  := ExtractFileName(fname);
  TheEditor.Modified := False;
  MainForm.SaveBtn.Enabled := false;
  UpdateStatusBar;
  SetSyntaxHighlighter;
  HookCompProp;
end;

procedure TEditorForm.OpenFile(fname:string);
begin
  if FileExists(fname) then
  begin
    IsNew    := False;
    FileName := fname;
    Caption  := ExtractFileName(fname);
    TheEditor.Lines.LoadFromFile(fname);
    TheEditor.ReadOnly := ((FileGetAttr(fname) and faReadOnly) = faReadOnly);
    TheEditor.Modified := False;
    MainForm.SaveBtn.Enabled := False;
    MainForm.LoadDesktop(fname);
    UpdateStatusBar;
    SetSyntaxHighlighter;
    HookCompProp;
    frmCodeExplorer.ProcessFile(fname);
  end;
end;

procedure TEditorForm.SaveFile;
begin
  SaveFileAs(FileName);
end;

procedure TEditorForm.SaveFileAs(fname:string);
var
  backfname : string;
begin
  FileName := fname;
  IsNew    := false;
  Caption  := ExtractFileName(fname);
  if SaveBackup and FileExists(fname) then
  begin
    backfname := ChangeFileExt(fname,'.bak');
    DeleteFile(backfname);
    RenameFile(fname,backfname);
  end;
  TheEditor.Lines.SaveToFile(fname);
  TheEditor.Modified := False;
  MainForm.SaveBtn.Enabled := False;
  if AutoSaveDesktop then
    MainForm.SaveDesktop(FileName);
  SetSyntaxHighlighter;
  HookCompProp;
end;

procedure TEditorForm.InsertFile(fname:string);
var
  tmpSL : TStringlist;
begin
  tmpSL := TStringList.Create;
  try
    tmpSL.LoadFromFile(fname);
    TheEditor.SelText := tmpSL.Text;
  finally
    tmpSL.Free;
  end;
end;

{Edit routines}

function TEditorForm.CanUndo:boolean;
begin
  Result := TheEditor.CanUndo;
end;

function TEditorForm.Selected:boolean;
begin
  Result := TheEditor.SelAvail;
end;

procedure TEditorForm.Undo;
begin
  TheEditor.Undo();
end;

procedure TEditorForm.Redo;
begin
  TheEditor.Redo();
end;

procedure TEditorForm.CutSel;
begin
  TheEditor.CutToClipboard();
end;

procedure TEditorForm.CopySel;
begin
  TheEditor.CopyToClipboard();
end;

procedure TEditorForm.Paste;
begin
  TheEditor.PasteFromClipboard();
end;

procedure TEditorForm.DeleteSel;
begin
  TheEditor.ClearSelection();
end;

procedure TEditorForm.SelectAll;
begin
  TheEditor.SelectAll();
end;

procedure TEditorForm.GotoLine;
var
  G : TGotoForm;
begin
  G := TGotoForm.Create(nil);
  try
    if G.ShowModal() = mrOK then
    begin
      with TheEditor do begin
        SetFocus;
        CaretXY := Point(0, G.theLine);
        BlockBegin := CaretXY;
        BlockEnd   := BlockBegin;
        EnsureCursorPosVisible;
      end;
    end;
  finally
    G.Free;
  end;
end;

procedure TEditorForm.NextField;
begin
  TheEditor.SelectDelimited();
end;

procedure TEditorForm.RefreshScreen;
begin
  TheEditor.Refresh;
end;

procedure TEditorForm.AddConstructString(constr:string);
var str:string;
    i,j,tt,curpos:integer;
    escaped,fieldexists:boolean;
begin
  if TheEditor.ReadOnly then Exit;
  if TheEditor.SelAvail then
    tt := TheEditor.BlockBegin.x - 1
  else
    tt := TheEditor.CaretXY.x - 1; // make it a zero-based column number
  fieldexists:=false;
  escaped:=false;
  str:='';
  for i:=1 to Length(constr) do
  begin
    if escaped then
    begin
      if constr[i] = '\' then str := str + '\';
      if constr[i] = '<' then tt := tt - TheEditor.TabWidth;
      if constr[i] = '>' then tt := tt + TheEditor.TabWidth;
      if constr[i] in ['=','<','>'] then
      begin
        str := str + #13#10;
        for j:= 1 to tt do str := str + ' ';
      end;
      escaped := false;
    end else begin
      if constr[i] = '"' then fieldexists := true;
      if constr[i] = '\' then
        escaped := true
      else
        str:=str+constr[i];
    end;
  end;
  MainForm.SetFocus;
  TheEditor.SetFocus;
  curpos := TheEditor.CaretXY.y;
  TheEditor.SelText := str;
  if fieldexists then
  begin
    TheEditor.CaretXY := Point(TheEditor.CaretXY.x, curpos);
    NextField;
  end;
end;

procedure TEditorForm.AddConstruct(numb:integer);
begin
  AddConstructString(templates[numb]);
end;


{Event Handlers}

procedure TEditorForm.TheErrorsClick(Sender: TObject);
var i,epos,lnumb,c:integer;
    str:string;
begin
  lnumb := 0;
  for i := TheErrors.ItemIndex downto 0 do
  begin
    epos := Pos('line ',TheErrors.Items[i]);
    if epos >0 then
    begin
     str := Copy(TheErrors.Items[i],epos+4,5);
     Val(str,lnumb,c);
     break;
    end;
  end;
  if lnumb > 0 then
  begin
    TheEditor.BlockBegin := Point(1, lnumb);
    TheEditor.BlockEnd   := Point(Length(TheEditor.Lines[lnumb-1])+1, lnumb);
    TheEditor.CaretXY    := TheEditor.BlockBegin;
  end;
  TheEditor.SetFocus;
end;

procedure TEditorForm.TheEditorKeyPress(Sender: TObject; var Key: Char);
begin
  {Ignore <Ctr><Alt> combinations when a macro was added}
  if Key = Chr(27) then
    GlobalAbort := True;
end;

procedure TEditorForm.TheEditorKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var ctrldown,altdown,shiftdown:boolean;
    ch:char;
    i:integer;
    str,constr:string;
begin
  ctrldown := (ssCtrl in Shift);
  altdown := (ssAlt in Shift);
  shiftdown := (ssShift in Shift);
  {Handle <Ctr><Alt> Combinations as macro's}
  ch:=Char(MapVirtualKey(Key,2));
  if MacrosOn and ctrldown and altdown and
     (((ch>='A') and (ch<='Z')) or ((ch>='0') and (ch<='9'))) then
  begin
    str:='';
    if ctrldown then str:=str+'<Ctrl>';
    if altdown then str:=str+'<Alt>';
    if shiftdown then str:=str+'<Shift>';
    str:=str+ch;
    for i:=1 to macronumb do
    begin
      if Pos(str,Macros[i]) = 1 then
      begin
        constr:=Copy(Macros[i],Length(str)+2,1000);
        AddConstructString(constr);
        Key:=0;
        break;
      end;
    end;
  end;
end;


procedure TEditorForm.FormActivate(Sender: TObject);
begin
  UpdateStatusBar;
  if TheErrors.Visible then
    MainForm.barStatus.Panels[1].Text := sErrors
  else
    MainForm.barStatus.Panels[1].Text := '';
  MainForm.SetToolBar(true, true);
  MainForm.ChangeActiveEditor;
end;

procedure TEditorForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  // 9/13/2001 JCH added id_No case to fix problems when closing main form
  // while files are modified.  Added check for assigned(MainForm) to protect
  // against access violations
  if TheEditor.Modified then
  begin
    BringToFront;
    case MessageDlg(Format(S_FileChanged, [Caption]),
            mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
      id_Yes: if Assigned(MainForm) then MainForm.DoSave(Self);
      id_No: TheEditor.Modified := False;
      id_Cancel: CanClose:=false;
    end;
  end;
  if AppIsClosing and not CanClose then
    AppIsClosing := False;
end;

procedure TEditorForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Assigned(MainForm) then
  begin
    MainForm.barStatus.Panels[0].Text := '';
    MainForm.barStatus.Panels[4].Text := '';
    MainForm.barStatus.Panels[5].Text := '';
    MainForm.SetToolBar(true, false);
  end;
  Action := caFree;
end;

procedure TEditorForm.FormShow(Sender: TObject);
begin
  PopupMenu := ConstructForm.ConstructMenu;
  TheEditor.Font.Name := FontName;
  TheEditor.Font.Size := FontSize;
end;

procedure TEditorForm.FormCreate(Sender: TObject);
begin
  SetValuesFromPreferences;
  SetSyntaxHighlighter;
  MainForm.SynAutoComp.AddEditor(TheEditor);
  MainForm.SynMacroRec.AddEditor(TheEditor);
end;

procedure TEditorForm.SetSyntaxHighlighter;
begin
  if ColorCoding then
  begin
    if IsNew then
      TheEditor.Highlighter := MainForm.SynNQCSyn
    else
      TheEditor.Highlighter := GetHighlighterForFile(Filename);
  end
  else
    TheEditor.Highlighter := nil;
end;

procedure TEditorForm.DoSearchReplaceText(AReplace, ABackwards: boolean);
var
  Options: TSynSearchOptions;
begin
  if AReplace then
    Options := [ssoPrompt, ssoReplace, ssoReplaceAll]
  else
    Options := [];
  if ABackwards then
    Include(Options, ssoBackwards);
  if gbSearchCaseSensitive then
    Include(Options, ssoMatchCase);
  if not fSearchFromCaret then
    Include(Options, ssoEntireScope);
  if gbSearchSelectionOnly then
    Include(Options, ssoSelectedOnly);
  if gbSearchWholeWords then
    Include(Options, ssoWholeWord);
  if TheEditor.SearchReplace(gsSearchText, gsReplaceText, Options) = 0 then
  begin
    MessageBeep(MB_ICONASTERISK);
    if ssoBackwards in Options then
      TheEditor.BlockEnd := TheEditor.BlockBegin
    else
      TheEditor.BlockBegin := TheEditor.BlockEnd;
    TheEditor.CaretXY := TheEditor.BlockBegin;
  end;

  if ConfirmReplaceDialog <> nil then
    ConfirmReplaceDialog.Free;
end;

procedure TEditorForm.ShowSearchReplaceDialog(AReplace: boolean);
var
  dlg: TTextSearchDialog;
begin
  if AReplace then
    dlg := TTextReplaceDialog.Create(Self)
  else
    dlg := TTextSearchDialog.Create(Self);
  with dlg do try
    // assign search options
    SearchBackwards := gbSearchBackwards;
    SearchCaseSensitive := gbSearchCaseSensitive;
    SearchFromCursor := gbSearchFromCaret;
    SearchInSelectionOnly := gbSearchSelectionOnly;
    // start with last search text
    SearchText := gsSearchText;
    if gbSearchTextAtCaret then begin
      // if something is selected search for that text
      if TheEditor.SelAvail and (TheEditor.BlockBegin.Y = TheEditor.BlockEnd.Y)
      then
        SearchText := TheEditor.SelText
      else
        SearchText := TheEditor.GetWordAtRowCol(TheEditor.CaretXY);
    end;
    SearchTextHistory := gsSearchTextHistory;
    if AReplace then with dlg as TTextReplaceDialog do begin
      ReplaceText := gsReplaceText;
      ReplaceTextHistory := gsReplaceTextHistory;
    end;
    SearchWholeWords := gbSearchWholeWords;
    if ShowModal = mrOK then begin
      gbSearchBackwards := SearchBackwards;
      gbSearchCaseSensitive := SearchCaseSensitive;
      gbSearchFromCaret := SearchFromCursor;
      gbSearchSelectionOnly := SearchInSelectionOnly;
      gbSearchWholeWords := SearchWholeWords;
      gsSearchText := SearchText;
      gsSearchTextHistory := SearchTextHistory;
      if AReplace then with dlg as TTextReplaceDialog do begin
        gsReplaceText := ReplaceText;
        gsReplaceTextHistory := ReplaceTextHistory;
      end;
      fSearchFromCaret := gbSearchFromCaret;
      if gsSearchText <> '' then begin
        DoSearchReplaceText(AReplace, gbSearchBackwards);
        fSearchFromCaret := TRUE;
      end;
    end;
  finally
    dlg.Free;
  end;
end;

procedure TEditorForm.ExecFind;
begin
  ShowSearchReplaceDialog(FALSE);
end;

procedure TEditorForm.ExecFindNext;
begin
  DoSearchReplaceText(FALSE, FALSE);
End;

procedure TEditorForm.ExecFindPrev;
begin
  DoSearchReplaceText(FALSE, TRUE);
end;

procedure TEditorForm.ExecReplace;
begin
  ShowSearchReplaceDialog(TRUE);
end;

procedure TEditorForm.TheEditorReplaceText(Sender: TObject; const ASearch,
  AReplace: String; Line, Column: Integer; var Action: TSynReplaceAction);
var
  APos: TPoint;
  EditRect: TRect;
begin
  if ASearch = AReplace then
    Action := raSkip
  else begin
    APos := Point(Column, Line);
    APos := TheEditor.ClientToScreen(TheEditor.RowColumnToPixels(APos));
    EditRect := ClientRect;
    EditRect.TopLeft := ClientToScreen(EditRect.TopLeft);
    EditRect.BottomRight := ClientToScreen(EditRect.BottomRight);

    if ConfirmReplaceDialog = nil then
      ConfirmReplaceDialog := TConfirmReplaceDialog.Create(Application);
    ConfirmReplaceDialog.PrepareShow(EditRect, APos.X, APos.Y,
      APos.Y + TheEditor.LineHeight, ASearch);
    case ConfirmReplaceDialog.ShowModal of
      mrYes: Action := raReplace;
      mrYesToAll: Action := raReplaceAll;
      mrNo: Action := raSkip;
      else Action := raCancel;
    end;
  end;
end;

procedure TEditorForm.TheEditorStatusChange(Sender: TObject;
  Changes: TSynStatusChanges);
begin
  // Note: scAll for new file loaded
  // caret position has changed
  if Changes * [scAll, scCaretX, scCaretY] <> [] then begin
    UpdatePositionOnStatusBar;
  end;
  // InsertMode property has changed
  if Changes * [scAll, scInsertMode, scReadOnly] <> [] then begin
    UpdateModeOnStatusBar;
  end;
  // Modified property has changed
  if Changes * [scAll, scModified] <> [] then
    UpdateModifiedOnStatusBar;
end;

procedure TEditorForm.UpdateStatusBar;
begin
  UpdatePositionOnStatusBar;
  UpdateModeOnStatusBar;
  UpdateModifiedOnStatusBar;
end;

procedure TEditorForm.UpdatePositionOnStatusBar;
var
  p: TPoint;
begin
  p := TheEditor.CaretXY;
  MainForm.barStatus.Panels[0].Text := Format('%6d:%3d', [p.Y, p.X]);
end;

procedure TEditorForm.UpdateModeOnStatusBar;
const
  InsertModeStrs: array[boolean] of string = (S_Overwrite, S_Insert);
begin
  if TheEditor.ReadOnly then
    MainForm.barStatus.Panels[4].Text := S_ReadOnly
  else
    MainForm.barStatus.Panels[4].Text := InsertModeStrs[TheEditor.InsertMode];
end;

procedure TEditorForm.UpdateModifiedOnStatusBar;
const
  ModifiedStrs: array[boolean] of string = ('', S_Modified);
begin
  MainForm.SetToolBar(true, true);
  MainForm.barStatus.Panels[5].Text := ModifiedStrs[TheEditor.Modified];
end;

function TEditorForm.CanRedo: boolean;
begin
  Result := TheEditor.CanRedo;
end;

function TEditorForm.CanFind: boolean;
begin
  Result := Length(TheEditor.Lines.Text) > 0;
end;

function TEditorForm.CanFindNext: boolean;
begin
  Result := CanFind and (gsSearchText <> '');
end;

function TEditorForm.CanReplace: boolean;
begin
  Result := CanFind and not TheEditor.ReadOnly;
end;

procedure TEditorForm.SetValuesFromPreferences;
begin
  with TheEditor do
  begin
    Font.Name := FontName;
    Font.Size := FontSize;
    if AutoIndentCode then
      Options := Options + [eoAutoIndent]
    else
      Options := Options - [eoAutoIndent];
    if ScrollPastEOL then
      Options := Options + [eoScrollPastEol]
    else
      Options := Options - [eoScrollPastEol];
    if HalfPageScroll then
      Options := Options + [eoHalfPageScroll]
    else
      Options := Options - [eoHalfPageScroll];
    if DragAndDropEditing then
      Options := Options + [eoDragDropEditing]
    else
      Options := Options - [eoDragDropEditing];
    if AltSetsSelMode then
      Options := Options + [eoAltSetsColumnMode]
    else
      Options := Options - [eoAltSetsColumnMode];
    if MoveCursorRight then
      Options := Options + [eoRightMouseMovesCursor]
    else
      Options := Options - [eoRightMouseMovesCursor];
    if UseSmartTabs then
      Options := Options + [eoSmartTabs, eoSmartTabDelete]
    else
      Options := Options - [eoSmartTabs, eoSmartTabDelete];
    if not KeepBlanks then
      Options := Options + [eoTrimTrailingSpaces]
    else
      Options := Options - [eoTrimTrailingSpaces];
    if EnhanceHomeKey then
      Options := Options + [eoEnhanceHomeKey]
    else
      Options := Options - [eoEnhanceHomeKey];
    if GroupUndo then
      Options := Options + [eoGroupUndo]
    else
      Options := Options - [eoGroupUndo];
  end;
  TheEditor.HideSelection    := HideSelection;
  TheEditor.TabWidth         := TabWidth;
  TheEditor.MaxUndo          := MaxUndo;
  TheEditor.ExtraLineSpacing := ExtraLineSpacing;
  TheEditor.RightEdge        := RightEdgePosition;
  TheEditor.RightEdgeColor   := RightEdgeColor;
  case ScrollBars of
    0 : TheEditor.ScrollBars := ssBoth;
    1 : TheEditor.ScrollBars := ssHorizontal;
    2 : TheEditor.ScrollBars := ssNone;
  else
    TheEditor.ScrollBars := ssVertical;
  end;
  TheEditor.Color            := EditorColor;
  TheEditor.SelectedColor.Foreground := SelectionForeground;
  TheEditor.SelectedColor.Background := SelectionBackground;
  with TheEditor.Gutter do
  begin
    Color := GutterColor;
    Width := GutterWidth;
    AutoSize := AutoSizeGutter;
    Visible  := GutterVisible;
    LeadingZeros := ShowLeadingZeros;
  end;
  TheEditor.Gutter.DigitCount      := DigitCount;
  TheEditor.Gutter.LeftOffset      := LeftOffset;
  TheEditor.Gutter.RightOffset     := RightOffset;
  TheEditor.Gutter.ShowLineNumbers := ShowLineNumbers;
  TheEditor.Gutter.ZeroStart       := ZeroStart;
  TheEditor.Gutter.UseFontStyle    := UseFontStyle;
  TheEditor.Keystrokes.Assign(PrefForm.Keystrokes);
end;

procedure TEditorForm.TheEditorGutterClick(Sender: TObject; X, Y,
  Line: Integer; mark: TSynEditMark);
begin
  if mark <> nil then
    TheEditor.ClearBookMark(mark.BookmarkNumber);
end;

procedure TEditorForm.TheEditorPlaceBookmark(Sender: TObject;
  var Mark: TSynEditMark);
begin
//
end;

procedure TEditorForm.TheEditorClearBookmark(Sender: TObject;
  var Mark: TSynEditMark);
begin
// 
end;

procedure TEditorForm.pmnuEditorPopup(Sender: TObject);
begin
  lmiEditUndo.Enabled      := CanUndo;
  lmiEditRedo.Enabled      := CanRedo;
  lmiEditCut.Enabled       := Selected and not TheEditor.ReadOnly;
  lmiEditCopy.Enabled      := Selected;
  lmiEditPaste.Enabled     := TheEditor.CanPaste;
  lmiEditDelete.Enabled    := Selected and not TheEditor.ReadOnly;
  lmiEditSelectAll.Enabled := true;
end;

procedure TEditorForm.lmiEditUndoClick(Sender: TObject);
begin
  Undo;
end;

procedure TEditorForm.lmiEditRedoClick(Sender: TObject);
begin
  Redo;
end;

procedure TEditorForm.lmiEditCutClick(Sender: TObject);
begin
  CutSel;
end;

procedure TEditorForm.lmiEditCopyClick(Sender: TObject);
begin
  CopySel;
end;

procedure TEditorForm.lmiEditPasteClick(Sender: TObject);
begin
  Paste;
end;

procedure TEditorForm.lmiEditDeleteClick(Sender: TObject);
begin
  DeleteSel;
end;

procedure TEditorForm.lmiEditSelectAllClick(Sender: TObject);
begin
  SelectAll;
end;

procedure TEditorForm.FormDestroy(Sender: TObject);
begin
  if MainForm <> nil then
    MainForm.SetToolBar(true, false);
  if Assigned(frmCodeExplorer) then
  begin
    frmCodeExplorer.ClearTree;
  end;
  if Assigned(frmMacroManager) then
    frmMacroManager.MacroLibrary.ActiveEditor := nil;
end;

procedure TEditorForm.Edit1Click(Sender: TObject);
begin
  // requires short-circuit boolean evaluation
  SelectAll1.Enabled       := True;
  NextField1.Enabled       := True;
  RefreshScreen1.Enabled   := True;
  Undo1.Enabled            := CanUndo;
  Redo1.Enabled            := CanRedo;
  Paste1.Enabled           := TheEditor.CanPaste;
  Translate1xto201.Enabled := not TheEditor.ReadOnly;
  Copy1.Enabled            := Selected;
  Cut1.Enabled             := Selected and not TheEditor.ReadOnly;
  Delete1.Enabled          := Cut1.Enabled;
end;

procedure TEditorForm.Undo1Click(Sender: TObject);
begin
  Undo;
end;

procedure TEditorForm.Redo1Click(Sender: TObject);
begin
  Redo;
end;

procedure TEditorForm.Cut1Click(Sender: TObject);
begin
  CutSel;
end;

procedure TEditorForm.Copy1Click(Sender: TObject);
begin
  CopySel;
end;

procedure TEditorForm.Paste1Click(Sender: TObject);
begin
  Paste;
end;

procedure TEditorForm.Delete1Click(Sender: TObject);
begin
  DeleteSel;
end;

procedure TEditorForm.SelectAll1Click(Sender: TObject);
begin
  SelectAll;
end;

procedure TEditorForm.GotoLineNumber1Click(Sender: TObject);
begin
  GotoLine;
end;

procedure TEditorForm.FindNext1Click(Sender: TObject);
begin
  ExecFindNext;
end;

procedure TEditorForm.FindPrevious1Click(Sender: TObject);
begin
  ExecFindPrev;
end;

procedure TEditorForm.Translate1xto201Click(Sender: TObject);
begin
  TranslateIt(TheEditor);
  RefreshScreen;
end;

procedure TEditorForm.Preferences1Click(Sender: TObject);
begin
  MainForm.Preferences1Click(Sender);
end;

procedure TEditorForm.NextField1Click(Sender: TObject);
begin
  NextField;
end;

procedure TEditorForm.RefreshScreen1Click(Sender: TObject);
begin
  RefreshScreen;
end;

procedure TEditorForm.Search1Click(Sender: TObject);
begin
  GotoLineNumber1.Enabled := True;
  Find1.Enabled           := CanFind;
  FindNext1.Enabled       := CanFindNext;
  FindPrevious1.Enabled   := CanFindNext;
  Replace1.Enabled        := CanReplace;
end;

procedure TEditorForm.Find1Click(Sender: TObject);
begin
  ExecFind;
end;

procedure TEditorForm.Replace1Click(Sender: TObject);
begin
  ExecReplace;
end;

function GetPortParam : string;
begin
  Result := '-S';
  if UseUSB then
    Result := Result + 'usb'
  else
    Result := Result + 'COM' + IntToStr(LocalPortNum);
end;

{$IFDEF VER120}
function IsPathDelimiter(const S: string; Index: Integer): Boolean;
begin
  Result := (Index > 0) and (Index <= Length(S)) and (S[Index] = '\')
    and (ByteType(S, Index) = mbSingleByte);
end;

function IncludeTrailingBackslash(const S: string): string;
begin
  Result := S;
  if not IsPathDelimiter(Result, Length(Result)) then Result := Result + '\';
end;
{$ENDIF}

function TempPath: string;
var
  i: integer;
begin
  SetLength(Result, MAX_PATH);
  i := GetTempPath(Length(Result), PChar(Result));
  SetLength(Result, i);
  IncludeTrailingBackSlash(Result);
end;

function GetNQCCommandLine(bDownload : Boolean; sTempdir, sSavedir, sFilename : string) : string;
var
  commandstr : string;
begin
  {Create the command}
  commandstr := 'nqc.exe';
  if IncludeSrcInList then
    commandstr := commandstr + ' -s';
  commandstr := commandstr + ' -E"' + sTempdir + 'temp.log" -L"' + sTempdir + 'temp.lst" -I"'+sSavedir+'"';
  if CompatibilityMode then
    commandstr := commandstr + ' -1';
  if NQCSwitches <> '' then
    commandstr := commandstr + ' ' + NQCSwitches + ' ';
  commandstr := commandstr + GetTarget;

  if SaveBinaryOutput then
    commandstr := commandstr + ' -O"' + ChangeFileExt(sFilename, '.rcx') + '"';
  if bDownload then
    commandstr := commandstr + ' -d ' + GetPortParam;
  commandstr := commandstr + ' "' + sTempdir + 'temp.nqc"';
  result := commandstr;
end;

function CompileIt(download:boolean): boolean;
var
  SaveCursor : TCursor;
  SaveDir, tempDir, commandstr, errMsg, str, statusStr, {errStr, }outStr : string;
  i : Integer;
  NQC_Result : Longint;
  execError : Boolean;
  tmpErrors : TStrings;
  EdFrm : TEditorForm;
begin
  outStr := '';
  Result := False;
  EdFrm := MainForm.ActiveEditorForm;
  if not Assigned(EdFrm) then Exit;
// switch to modal form to prevent doing other things in
// the GUI while downloading/compiling
  tempDir := TempPath;
  {Save cursor}
  SaveCursor := Screen.Cursor;
  Screen.Cursor := crHourglass;
  {Save current directory}
  SaveDir:= GetCurrentDir();
  SetCurrentDir(ProgramDir);
  try
    // check for auto save
    if AutoSaveFiles then
      MainForm.SaveModifiedFiles;
    if AutoSaveDesktop then
      MainForm.SaveDesktop(EdFrm.FileName);

    {Save the file}
    EdFrm.TheEditor.Lines.SaveToFile(tempDir + 'temp.nqc');

    commandstr := GetNQCCommandLine(download, tempDir, SaveDir, EdFrm.FileName);

    if NQCDebug then
      ShowMessage('DEBUG: launching NQC with commandline = ' + commandstr);
    {Execute the command, and wait}
    FakeRCX.Close;
    try
      NQC_Result := ExecuteAndWait(PChar(commandstr), SW_SHOWMINNOACTIVE, LocalNQCTimeout);
//      NQC_Result := ExecuteAndWait(PChar(commandstr), SW_SHOWMINNOACTIVE, LocalNQCTimeout, outStr, errStr, False); // don't use pipes (yet)
      execError := NQC_Result < 0;
    finally
      FakeRCX.Open;
      // make sure the toolbar refreshes no matter what
      MainForm.HandleOpenStateChanged(nil);
    end;

    {Read the error file and show it}
    if FileExists(tempDir + 'temp.log') then
    begin
      tmpErrors := TStringList.Create;
      try
        tmpErrors.LoadFromFile(tempDir + 'temp.log');
        if (tmpErrors.Count > 0) then
        begin
          {Show the error listing}
          if FileExists(tempDir + 'temp.log') then
          begin
            CodeForm.CodeEdit.Lines.LoadFromFile(tempDir + 'temp.log');
            CodeForm.Caption := sFullErrors + ' ' + EdFrm.Caption;
          end;
          {Show the short errors}
          EdFrm.TheErrors.Items.Clear;
          for i:=0 to tmpErrors.Count-1 do
          begin
            if (Pos('# Error:',tmpErrors[i])>0) or
               (Pos('# Warning:',tmpErrors[i])>0) then begin
              str:= Copy(tmpErrors[i],2,100);
              if (i < (tmpErrors.Count - 1)) and
                 (Pos('File "' + tempDir + 'temp.nqc" ; line',tmpErrors[i+1])>0) then
              begin
                errMsg := Copy(tmpErrors[i+1], Length(tempDir) + 19, Length(tmpErrors[i+1]))+':'+str;
                if EdFrm.TheErrors.Items.IndexOf(errMsg) = -1 then
                  EdFrm.TheErrors.Items.Append(errMsg);
              end
              else begin
                if EdFrm.TheErrors.Items.IndexOf(str) = -1 then
                  EdFrm.TheErrors.Items.Append(str);
              end;
            end;
          end;
          {show the errors}
          MainForm.barStatus.Panels[1].Text := sErrors;
          EdFrm.TheErrors.Visible := True;
          EdFrm.splErrors.Visible := True;
          result := false;
          EdFrm.TheErrors.ItemIndex:=0;
          EdFrm.TheErrorsClick(EdFrm.TheErrors);
        end else begin
          {Show the code listing}
          if FileExists(tempDir + 'temp.lst') then
            CodeForm.CodeEdit.Lines.LoadFromFile(tempDir + 'temp.lst')
          else
            CodeForm.CodeEdit.Lines.Clear;
          CodeForm.Caption := sCodeListing + ' ' + EdFrm.Caption;
          {Hide the short errors}
          MainForm.HideErrors1Click(MainForm.HideErrors1);
          result := true;
        end;
      finally
        tmpErrors.Free;
      end;
    end;
    if (not execError) and ShowCompilerStatus then
    begin
      if result and download then
        statusStr := sCompileDownloadSuccess
      else if result then
        statusStr := sCompileSuccess
      else if download then
        statusStr := sCompileDownloadErrors
      else
        statusStr := sCompileErrors;
      ShowMessage(statusStr);
    end
    else if execError then
    begin
      if outStr <> '' then
        outStr := outStr + #13#10;
      outStr := outStr + GetRCXErrorString(NQC_Result);
      if outStr <> '' then
        MessageDlg('NQC Failed' + #13#10 + outStr, mtError, [mbOK], 0);
    end;
  finally
    {Clean up}
    DeleteFile(tempDir + 'temp.log');
    DeleteFile(tempDir + 'temp.lst');
    DeleteFile(tempDir + 'temp.nqc');
    Screen.Cursor := SaveCursor;
    SetCurrentDir(SaveDir);
  end;
end;

procedure TEditorForm.mniCompileProgramClick(Sender: TObject);
begin
  CompileIt(false);
end;

procedure TEditorForm.Download1Click(Sender: TObject);
begin
  if not CheckAlive then Exit;
  if IsRCX then
  begin
    if LockedProgArray[MainForm.ProgramBox.ItemIndex] then
    begin
      MessageDlg(sProgramLocked, mtError, [mbOK], 0);
      Exit;
    end;
    MainForm.SelectProgram(MainForm.ProgramBox.ItemIndex);
  end;
  CompileIt(true);
end;

procedure TEditorForm.CompileClick(Sender: TObject);
var
  BrickAlive : boolean;
begin
  BrickAlive                := FakeRCX.IsOpen;  
  Stop1.Enabled             := BrickAlive;
  Run1.Enabled              := BrickAlive;
  ProgramNumber1.Enabled    := BrickAlive and IsRCX;
  mniCompileProgram.Enabled := true;
  Download1.Enabled         := BrickAlive;
  DownloadandRun1.Enabled   := BrickAlive;
end;

procedure TEditorForm.DownloadandRun1Click(Sender: TObject);
begin
  if not CheckAlive then Exit;
  if IsRCX then MainForm.SelectProgram(MainForm.ProgramBox.ItemIndex);
  if CompileIt(true) then MainForm.StartTask(0);
end;

procedure TEditorForm.Run1Click(Sender: TObject);
begin
  MainForm.RunClick(Sender);
end;

procedure TEditorForm.Stop1Click(Sender: TObject);
begin
  MainForm.StopClick(Sender);
end;

procedure TEditorForm.Program11Click(Sender: TObject);
begin
  MainForm.Program11Click(Sender);
end;

procedure TEditorForm.File1Click(Sender: TObject);
begin
  // uses shortcut boolean evaluation
  Save1.Enabled :=TheEditor.Modified;
  SaveAs1.Enabled := True;
  SaveAll1.Enabled := True;
  Close1.Enabled := True;
  CloseAll1.Enabled := True;
  InsertFile1.Enabled := not TheEditor.ReadOnly;
  Print1.Enabled := True;
  PrintPreview1.Enabled := True;

  {Show the recent files}
  RecentSep.Visible:=false;
  Recent1.Visible:=false;
  Recent2.Visible:=false;
  Recent3.Visible:=false;
  Recent4.Visible:=false;
  if not ShowRecent then Exit;
  if RecentFiles[1] <> '' then RecentSep.Visible:=true;
  if RecentFiles[1] <> '' then
  begin
    Recent1.Visible:=true;
    Recent1.Caption:='&1 '+RecentFiles[1];
  end;
  if RecentFiles[2] <> '' then
  begin
    Recent2.Visible:=true;
    Recent2.Caption:='&2 '+RecentFiles[2];
  end;
  if RecentFiles[3] <> '' then
  begin
    Recent3.Visible:=true;
    Recent3.Caption:='&3 '+RecentFiles[3];
  end;
  if RecentFiles[4] <> '' then
  begin
    Recent4.Visible:=true;
    Recent4.Caption:='&4 '+RecentFiles[4];
  end;

end;

procedure TEditorForm.New1Click(Sender: TObject);
begin
  MainForm.NewClick(Sender);
end;

procedure TEditorForm.Open1Click(Sender: TObject);
begin
  MainForm.OpenClick(Sender);
end;

procedure TEditorForm.Save1Click(Sender: TObject);
begin
  SaveFile;
end;

procedure TEditorForm.SaveAs1Click(Sender: TObject);
begin
  MainForm.DoSaveAs(Self);
end;

procedure TEditorForm.SaveAll1Click(Sender: TObject);
begin
  MainForm.SaveAll1Click(Sender);
end;

procedure TEditorForm.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TEditorForm.CloseAll1Click(Sender: TObject);
begin
  MainForm.CloseAll1Click(Sender);
end;

procedure TEditorForm.InsertFile1Click(Sender: TObject);
begin
  if TheEditor.ReadOnly then Exit;
  if OpenDialog3.Execute() then
    InsertFile(OpenDialog3.FileName);
end;

procedure TEditorForm.Print1Click(Sender: TObject);
begin
  MainForm.DoPrint(Self);
end;

procedure TEditorForm.PrinterSetup1Click(Sender: TObject);
begin
  MainForm.PrinterSetup1Click(Sender);
end;

procedure TEditorForm.PageSetup1Click(Sender: TObject);
begin
  MainForm.PageSetup1Click(Sender);
end;

procedure TEditorForm.Exit1Click(Sender: TObject);
begin
  MainForm.Exit1Click(Sender);
end;

procedure TEditorForm.Recent1Click(Sender: TObject);
begin
  MainForm.RecentFileClick(Sender);
end;

procedure TEditorForm.PrintPreview1Click(Sender: TObject);
begin
  MainForm.DoPrintPreview(Self);
end;

procedure TEditorForm.GetContextHelp;
begin
  HelpALink(TheEditor.GetWordAtRowCol(TheEditor.CaretXY));
end;

procedure TEditorForm.TheEditorContextHelp(Sender: TObject; word: String);
begin
  GetContextHelp;
end;

procedure TEditorForm.CreateParams(var Params: TCreateParams);
begin
  if MDI then begin
    FormStyle := fsMDIChild;
    Visible := False;
//    Position := poDesigned;
  end;
  inherited;
end;

function TEditorForm.MDI: Boolean;
begin
  if Assigned(Application.MainForm) and (Application.MainForm.FormStyle = fsMDIForm) then
    Result := True
  else
    Result := False;
end;

{
procedure TEditorForm.InsertOptionInfo;
begin
  TheEditor.Lines.Insert(0,
    Format('// Port:%s, RCXType:%s, Slot:Program %d',
      [FakeRCX.NicePortName, FakeRCX.RCXTypeName, CurrentProgramSlot+1]));
  TheEditor.CaretY := TheEditor.CaretY + 1;
  TheEditor.Modified := True;
end;
[eoAutoIndent,eoDragDropEditing,eoScrollPastEol,eoShowScrollHint,eoSmartTabs,eoTabsToSpaces,eoTrimTrailingSpaces,eoSmartTabDelete]

}

procedure TEditorForm.TheEditorChange(Sender: TObject);
begin
  frmCodeExplorer.ChangedSinceLastProcess := IsNQCFile;
end;

procedure TEditorForm.WMMDIActivate(var Message: TWMMDIActivate);
var
  IsActive : Boolean;
begin
  inherited;
  if AppIsClosing then Exit;
  IsActive := Message.ActiveWnd = Handle;
  if IsActive and Assigned(frmCodeExplorer) then
  begin
    frmCodeExplorer.ProcessFile(FileName);
  end;
end;

function TEditorForm.IsNQCFile: boolean;
begin
  result := fIsNQCFile;
end;

procedure TEditorForm.SetFilename(const Value: string);
var
  ext : string;
begin
  fFilename := Value;
  ext := UpperCase(ExtractFileExt(fFilename));
  fIsNQCFile := IsNew or ((Trim(ext) <> '') and
                (Pos(ext, UpperCase(MainForm.SynNQCSyn.DefaultFilter)) > 0));
end;

procedure TEditorForm.HookCompProp;
begin
  MainForm.SynNQCCompProp.RemoveEditor(TheEditor);
  MainForm.SynForthCompProp.RemoveEditor(TheEditor);
  MainForm.SynH8CompProp.RemoveEditor(TheEditor);
  if IsNew or (GetHighlighterForFile(Filename) = MainForm.SynNQCSyn) then
    MainForm.SynNQCCompProp.AddEditor(TheEditor)
  else if GetHighlighterForFile(Filename) = MainForm.SynForthSyn then
    MainForm.SynForthCompProp.AddEditor(TheEditor)
  else if GetHighlighterForFile(Filename) = MainForm.SynH8Syn then
    MainForm.SynH8CompProp.AddEditor(TheEditor);
end;

end.
