unit GotoLine;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TGotoForm = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    GotoLineField: TEdit;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    theLine : integer;
  end;

implementation

{$R *.DFM}

uses MainUnit, Editor;

resourcestring
  sGotoError = 'Line must be between 1 and %d.';

procedure TGotoForm.FormShow(Sender: TObject);
begin
  GotoLineField.SetFocus;
  GotoLineField.SelectAll;
end;

procedure TGotoForm.Button1Click(Sender: TObject);
var
  lineCount : integer;
begin
  if MainForm.ActiveEditorForm = nil then Exit;
  theline := StrtoIntDef(GotoLineField.Text, 0);
  lineCount := MainForm.ActiveEditorForm.TheEditor.Lines.Count;
  if (theline < 1) or (theline > lineCount) then
  begin
    ShowMessage(Format(sGotoError, [lineCount]));
    GotoLineField.SetFocus;
    GotoLineField.SelectAll;
  end
  else
    ModalResult:=mrOK;
end;

end.
