unit MemoryUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TMemoryForm = class(TForm)
    MemoryMemo: TMemo;
    RefreshBtn: TButton;
    procedure RefreshBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MemoryForm: TMemoryForm;

implementation

uses
  SearchRCX, FakeSpirit;

{$R *.DFM}

resourcestring
  sDownloadMemMapFailed = 'Memory map download failed!';

procedure TMemoryForm.RefreshBtnClick(Sender: TObject);
var
  memdata : TStrings;
  i,j:integer;
  str:string;
  c : TCursor;
begin
  if not CheckAlive then Exit;
  MemoryMemo.Lines.Clear;
  Application.ProcessMessages;
  c := Screen.Cursor;
  try
    Screen.Cursor := crHourGlass;
    memdata := FakeRCX.DownloadMemoryMap;
  finally
    Screen.Cursor := c;
  end;
  if IsRCX then
  begin
    if memdata.Count < 93 then
    begin
      MessageDlg(sDownloadMemMapFailed, mtError, [mbOK], 0);
      Exit;
    end;
    MemoryMemo.Lines.Add('Subroutine Pointers');
    for i:=0 to 4 do
    begin
      str := Format('P%d:',[i+1]);
      for j:=0 to 7 do
        str := str + Format('%6d',[StrToIntDef(memdata[(8 * i) + j], 0)]);
      MemoryMemo.Lines.Add(str);
    end;
    MemoryMemo.Lines.Add('');
    MemoryMemo.Lines.Add('Task Pointers');
    for i:=0 to 4 do
    begin
      str := Format('P%d:',[i+1]);
      for j:=0 to 9 do
        str := str + Format('%6d',[StrToIntDef(memdata[40+10*i+j], 0)]);
      MemoryMemo.Lines.Add(str);
    end;
    MemoryMemo.Lines.Add('');
    MemoryMemo.Lines.Add(Format('Datalog Start Pointer:   %6d',[StrToIntDef(memdata[90], 0)]));
    MemoryMemo.Lines.Add(Format('Datalog Current Pointer: %6d',[StrToIntDef(memdata[91], 0)]));
    MemoryMemo.Lines.Add(Format('Total Memory Used:       %6d',[StrToIntDef(memdata[92], 0)]));
    MemoryMemo.Lines.Add(Format('Top of Memory:           %6d',[StrToIntDef(memdata[93], 0)]));
    MemoryMemo.Lines.Add(Format('Free Memory Left:        %6d',[StrToIntDef(memdata[93], 0)-StrToIntDef(memdata[92], 0)]));
  end else if IsScout then begin
    // scout
    if memdata.Count < 11 then
    begin
      MessageDlg(sDownloadMemMapFailed, mtError, [mbOK], 0);
      Exit;
    end;
    MemoryMemo.Lines.Add('Subroutine Pointers');
    str := '';
    for j := 0 to 2 do
      str := str + Format('%6d', [StrToIntDef(memdata[j], 0)]);
    MemoryMemo.Lines.Add(str);
    MemoryMemo.Lines.Add('');
    MemoryMemo.Lines.Add('Task Pointers');
    str := '';
    for j := 0 to 3 do
      str := str + Format('%6d', [StrToIntDef(memdata[3+j], 0)]);
    MemoryMemo.Lines.Add(str);
    MemoryMemo.Lines.Add('');
    MemoryMemo.Lines.Add(Format('Total Memory Used: %6d',[StrToIntDef(memdata[9], 0)]));
    MemoryMemo.Lines.Add(Format('Top of Memory:     %6d',[StrToIntDef(memdata[10], 0)]));
    MemoryMemo.Lines.Add(Format('Free Memory Left:  %6d',[StrToIntDef(memdata[10], 0)-StrToIntDef(memdata[9], 0)]));
  end else begin
    if memdata.Count < 10 then
    begin
      MessageDlg(sDownloadMemMapFailed, mtError, [mbOK], 0);
      Exit;
    end;
    // cybermaster
    MemoryMemo.Lines.Add('Subroutine Pointers');
    str:='';
    for j:=0 to 3 do str:=str+Format('%6d',[StrToIntDef(memdata[j], 0)]);
    MemoryMemo.Lines.Add(str);
    MemoryMemo.Lines.Add('');
    MemoryMemo.Lines.Add('Task Pointers');
    str:='';
    for j:=0 to 3 do str:=str+Format('%6d',[StrToIntDef(memdata[4+j], 0)]);
    MemoryMemo.Lines.Add(str);
    MemoryMemo.Lines.Add('');
    MemoryMemo.Lines.Add(Format('Total Memory Used: %6d',[StrToIntDef(memdata[8], 0)]));
    MemoryMemo.Lines.Add(Format('Top of Memory:     %6d',[StrToIntDef(memdata[9], 0)]));
    MemoryMemo.Lines.Add(Format('Free Memory Left:  %6d',[StrToIntDef(memdata[9], 0)-StrToIntDef(memdata[8], 0)]));
  end;
end;

procedure TMemoryForm.FormShow(Sender: TObject);
begin
  RefreshBtnClick(Self);
end;

end.
