unit Piano;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons;

type
  TPianoForm = class(TForm)
    Panel1: TPanel;
    Shape1: TShape;
    Shape3: TShape;
    Shape2: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    Shape9: TShape;
    Shape10: TShape;
    Shape11: TShape;
    Shape12: TShape;
    Shape13: TShape;
    Shape14: TShape;
    Shape15: TShape;
    Shape16: TShape;
    Shape17: TShape;
    Shape18: TShape;
    Shape19: TShape;
    Shape20: TShape;
    Shape21: TShape;
    Shape22: TShape;
    Shape23: TShape;
    Shape24: TShape;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    PlayBtn: TButton;
    SaveBtn: TButton;
    SaveDialog1: TSaveDialog;
    TempMemo: TMemo;
    CopyBtn: TButton;
    ClearBtn: TButton;
    RestBtn: TBitBtn;
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RadioButton1Click(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure PlayBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CopyBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PianoForm: TPianoForm;

implementation

{$R *.DFM}

uses
  SearchRCX, FakeSpirit;

const NOTE_TIME = 10;
      WAIT_TIME = 12;
      MAX_NOTE = 2000;

var lnote: integer;
    notes: array[1..MAX_NOTE] of integer;
    duration: array[1..MAX_NOTE] of integer;
    notenumb:integer;

procedure FillTemp(forsave:boolean);
{Fills the notes in the temporary memo field}
var i:integer;
begin
  with PianoForm.TempMemo.Lines do
  begin
    Clear;
    if forsave then Add('// Music file created by RCX Command Center.');
    if forsave then Add('');
    Add(Format('#define __NOTETIME   %d',[NOTE_TIME]));
    Add(Format('#define __WAITTIME   %d',[WAIT_TIME]));
    Add('');
    if forsave then Add('task main()');
    if forsave then Add('{');
    for i:=1 to notenumb do
      if notes[i] > 0 then
        Add(Format(
        '  PlayTone(%d,%d*__NOTETIME); Wait(%d*__WAITTIME);',
                     [notes[i],duration[i],duration[i]]))
      else
        Add(Format('  Wait(%d*__WAITTIME);',[duration[i]]));
    if forsave then Add('}');
  end;
end;

procedure TPianoForm.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if FakeRCX.IsOpen then
    FakeRCX.PlayTone(TShape(Sender).Tag, lnote * NOTE_TIME);
  notenumb := notenumb + 1;
  notes[notenumb] := TShape(Sender).Tag;
  duration[notenumb] := lnote;
end;

procedure TPianoForm.RadioButton1Click(Sender: TObject);
begin
  lnote := TRadioButton(Sender).Tag;
end;

procedure TPianoForm.ClearBtnClick(Sender: TObject);
begin
  notenumb := 0;
end;

procedure TPianoForm.PlayBtnClick(Sender: TObject);
var
  i : integer;
begin
  for i:=1 to notenumb do
  begin
    if notes[i] > 0 then
      FakeRCX.PlayTone(notes[i],duration[i] * NOTE_TIME);
    sleep(10*duration[i] * NOTE_TIME);
  end;
end;

procedure TPianoForm.CopyBtnClick(Sender: TObject);
begin
  FillTemp(false);
  TempMemo.SelectAll;
  TempMemo.CopyToClipboard();
end;

procedure TPianoForm.SaveBtnClick(Sender: TObject);
begin
  if SaveDialog1.Execute() then
  begin
    FillTemp(true);
    TempMemo.Lines.SaveToFile(SaveDialog1.FileName);
  end;
end;

procedure TPianoForm.FormShow(Sender: TObject);
begin
  notenumb:=0;
  lnote := 4;
  RadioButton3.Checked := true;
  PlayBtn.Enabled := FakeRCX.IsOpen;
end;

end.
