unit Preferences;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Buttons, ColorGrd, SynEditHighlighter,
  SynHighlighterNQC, SynEdit, Spin, SynEditKeyCmds, Registry,
  SynHighlighterForth, SynHighlighterXML, SynHighlighterHtml,
  SynHighlighterCpp, SynHighlighterJava, SynHighlighterPas,
  SynHighlighterTclTk, SynHighlighterCss, SynHighlighterPython,
  SynHighlighterPerl, SynHighlighterHC11, SynHighlighterVB,
  SynHighlighterPHP, SynHighlighterCS, SynHighlighterH8;

type
  TCodeExplorerProperties = record
    CategorySort : string;
    AutoShowExplorer : boolean;
    DeclarationSyntax : boolean;
    UseAlphaSort : boolean;
    FunctionsVisible : boolean;
    FunctionsExpand : boolean;
    SubroutinesVisible : boolean;
    SubroutinesExpand : boolean;
    TasksVisible : boolean;
    TasksExpand : boolean;
  end;

  TTransferItem = class
  protected
    FWorkingDir: string;
    FTitle: string;
    FParams: string;
    FPath: string;
  public
    procedure Assign(TI : TTransferItem);
    property Title : string read FTitle write FTitle;
    property Path : string read FPath write FPath;
    property WorkingDir : string read FWorkingDir write FWorkingDir;
    property Params : string read FParams write FParams;
  end;

  TPrefForm = class(TForm)
    dlgFont: TFontDialog;
    SynNQCSyn: TSynNQCSyn;
    Panel3: TPanel;
    btnDefault: TButton;
    btnOK: TButton;
    btnCancel: TButton;
    Panel1: TPanel;
    pagPrefs: TPageControl;
    shtGeneral: TTabSheet;
    CheckSavePos: TCheckBox;
    CheckSaveBackup: TCheckBox;
    CheckShowRecent: TCheckBox;
    CheckCompatibility: TCheckBox;
    shtEditor: TTabSheet;
    Label28: TLabel;
    Label12: TLabel;
    Label26: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label16: TLabel;
    Label15: TLabel;
    Label11: TLabel;
    Label29: TLabel;
    CheckColorCoding: TCheckBox;
    CheckShowTemplates: TCheckBox;
    CheckAutoIndentCode: TCheckBox;
    CheckMacrosOn: TCheckBox;
    btnFont: TButton;
    cbHideSelection: TCheckBox;
    cbScrollPastEOL: TCheckBox;
    cbHalfPageScroll: TCheckBox;
    inpExtraLineSpacing: TSpinEdit;
    inpRightEdge: TSpinEdit;
    cbxREColor: TComboBox;
    cbxScrollBars: TComboBox;
    cbxColor: TComboBox;
    cbxForeground: TComboBox;
    cbxBackground: TComboBox;
    inpMaxUndo: TSpinEdit;
    inpTabWidth: TSpinEdit;
    chkDragDrop: TCheckBox;
    shtStartup: TTabSheet;
    CheckShowForm: TRadioButton;
    CheckNoConnect: TRadioButton;
    CheckConnect: TRadioButton;
    ComBox: TGroupBox;
    Bevel2: TBevel;
    Panel2: TPanel;
    CheckMindStorms: TRadioButton;
    CheckCyberMaster: TRadioButton;
    CheckScout: TRadioButton;
    CheckRCX2: TRadioButton;
    pnlPorts: TPanel;
    CheckAutomatic: TRadioButton;
    CheckCOM1: TRadioButton;
    CheckCOM2: TRadioButton;
    CheckCOM3: TRadioButton;
    CheckCOM4: TRadioButton;
    shtTemplates: TTabSheet;
    TemplatesList: TListBox;
    InsertBtn: TButton;
    ChangeBtn: TButton;
    DeleteBtn: TButton;
    UpBtn: TBitBtn;
    DownBtn: TBitBtn;
    shtMacros: TTabSheet;
    ShiftMacrosList: TListBox;
    MacrosList: TListBox;
    MChange: TButton;
    MDelete: TButton;
    shtColors: TTabSheet;
    lblElement: TLabel;
    lblColor: TLabel;
    cgColor: TColorGrid;
    lbElements: TListBox;
    grpTextAttributes: TGroupBox;
    chkBold: TCheckBox;
    chkItalic: TCheckBox;
    chkUnderline: TCheckBox;
    SynEdit1: TSynEdit;
    grpFGBG: TGroupBox;
    chkFG: TCheckBox;
    chkBG: TCheckBox;
    shtOptions: TTabSheet;
    grpGutter: TGroupBox;
    Label32: TLabel;
    Label31: TLabel;
    Label30: TLabel;
    Label6: TLabel;
    Label5: TLabel;
    cbUseFontStyle: TCheckBox;
    cbGutterVisible: TCheckBox;
    cbAutoSize: TCheckBox;
    cbLineNumbers: TCheckBox;
    cbLeadingZeros: TCheckBox;
    cbZeroStart: TCheckBox;
    inpRightOffset: TSpinEdit;
    inpLeftOffset: TSpinEdit;
    inpDigitCount: TSpinEdit;
    inpGutterWidth: TSpinEdit;
    cbxGutterColor: TComboBox;
    btnKeystrokes: TButton;
    chkShowCompileStatus: TCheckBox;
    MShift: TSpeedButton;
    lblNQCTimeout: TLabel;
    edtNQCTimeout: TSpinEdit;
    chkFirmfast: TCheckBox;
    grpLockedProgs: TGroupBox;
    cbProg1: TCheckBox;
    cbProg2: TCheckBox;
    cbProg3: TCheckBox;
    cbProg4: TCheckBox;
    cbProg5: TCheckBox;
    CheckUSB1: TRadioButton;
    CheckUSB2: TRadioButton;
    CheckUSB3: TRadioButton;
    CheckUSB4: TRadioButton;
    btnEditCodeTemplates: TButton;
    lblNQCSwitches: TLabel;
    edtNQCSwitches: TEdit;
    btnClaimExt: TButton;
    CheckCOM5: TRadioButton;
    CheckCOM6: TRadioButton;
    CheckCOM7: TRadioButton;
    CheckCOM8: TRadioButton;
    shtAPI: TTabSheet;
    pagAPI: TPageControl;
    shtAPIKeywords: TTabSheet;
    shtAPICommands: TTabSheet;
    shtAPIConstants: TTabSheet;
    lstKeywords: TListBox;
    lstCommands: TListBox;
    lstConstants: TListBox;
    edtKeyword: TEdit;
    edtCommand: TEdit;
    edtConstant: TEdit;
    btnAddAPI: TButton;
    btnDeleteAPI: TButton;
    chkIncludeSrcInList: TCheckBox;
    grpAutoSave: TGroupBox;
    chkAutoSave: TCheckBox;
    chkSaveDesktop: TCheckBox;
    chkSaveBinaryOutput: TCheckBox;
    chkFBAlwaysPrompt: TCheckBox;
    chkAltSelMode: TCheckBox;
    chkMoveRight: TCheckBox;
    chkKeepBlanks: TCheckBox;
    chkSmartTab: TCheckBox;
    chkEnhHomeKey: TCheckBox;
    chkGroupUndo: TCheckBox;
    SynForthSyn: TSynForthSyn;
    SynPasSyn1: TSynPasSyn;
    SynJavaSyn1: TSynJavaSyn;
    SynCppSyn1: TSynCppSyn;
    SynHTMLSyn1: TSynHTMLSyn;
    SynXMLSyn1: TSynXMLSyn;
    lblLanguages: TLabel;
    cboLanguages: TComboBox;
    SynPerlSyn1: TSynPerlSyn;
    SynPythonSyn1: TSynPythonSyn;
    SynCssSyn1: TSynCssSyn;
    SynTclTkSyn1: TSynTclTkSyn;
    SynHC11Syn1: TSynHC11Syn;
    SynPHPSyn1: TSynPHPSyn;
    SynVBSyn1: TSynVBSyn;
    SynCSSyn1: TSynCSSyn;
    SynH8Syn1: TSynH8Syn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure CheckConnectClick(Sender: TObject);
    procedure btnDefaultClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnFontClick(Sender: TObject);
    procedure UpBtnClick(Sender: TObject);
    procedure DownBtnClick(Sender: TObject);
    procedure ChangeBtnClick(Sender: TObject);
    procedure InsertBtnClick(Sender: TObject);
    procedure DeleteBtnClick(Sender: TObject);
    procedure TemplatesListDblClick(Sender: TObject);
    procedure MShiftClick(Sender: TObject);
    procedure MDeleteClick(Sender: TObject);
    procedure MChangeClick(Sender: TObject);
    procedure ShiftMacrosListDblClick(Sender: TObject);
    procedure lbElementsClick(Sender: TObject);
    procedure cgColorChange(Sender: TObject);
    procedure chkBoldClick(Sender: TObject);
    procedure chkItalicClick(Sender: TObject);
    procedure chkUnderlineClick(Sender: TObject);
    procedure chkFGClick(Sender: TObject);
    procedure chkBGClick(Sender: TObject);
    procedure btnKeystrokesClick(Sender: TObject);
    procedure edtNQCTimeoutKeyPress(Sender: TObject; var Key: Char);
    procedure btnEditCodeTemplatesClick(Sender: TObject);
    procedure btnClaimExtClick(Sender: TObject);
    procedure btnAddAPIClick(Sender: TObject);
    procedure btnDeleteAPIClick(Sender: TObject);
    procedure lstAPIClick(Sender: TObject);
    procedure edtAPIChange(Sender: TObject);
    procedure pagPrefsChange(Sender: TObject);
    procedure pagAPIChange(Sender: TObject);
    procedure cboLanguagesChange(Sender: TObject);
  private
    { Private declarations }
    fColorsChanged : boolean;
    fKeystrokes : TSynEditKeyStrokes;
    fCodeTemplates: TStrings;
    fLocalHighlighters : TStringList;
    fReg: TRegistry;
    fDefBGColors : array of array of TColor;
    fDefFGColors : array of array of TColor;
    fDefStyles : array of array of TFontStyles;
    function GetCustomHighlighter(index: Integer): TSynCustomHighlighter;
    function GetActiveHighlighter : TSynCustomHighlighter;
    procedure StoreDefaultAttributes;
    procedure LoadAttributeNames;
    procedure ShowSampleSource;
    procedure ShowItemInEditor(i : Integer);
    procedure UncheckStyles;
    procedure CheckStyles;
    procedure UncheckDefaults;
    procedure CheckDefaults;
    function GetFGColor(idx : integer) : TColor;
    procedure SetFGColor(idx : integer; aColor : TColor);
    function GetBGColor(idx : integer) : TColor;
    procedure SetBGColor(idx : integer; aColor : TColor);
    function GetStyles(idx : integer) : TFontStyles;
    procedure SetStyles(idx : integer; aStyle : TFontStyles);
    procedure DisplayColorValues;
    procedure UpdateGlobalColorsAndStyles;
    function UsingFGDefault(idx : integer) : boolean;
    function UsingBGDefault(idx : integer) : boolean;
    function GetFGDefault(idx : integer) : TColor;
    function GetBGDefault(idx : integer) : TColor;
    procedure DisplayGutterValues;
    procedure UpdateGlobalGutterValues;
    procedure SetKeystrokes(const Value: TSynEditKeyStrokes);
    procedure DisplayKeystrokeValues;
    procedure UpdateGlobalKeystrokeValues;
    procedure DisplayCodeTemplateValues;
    procedure SetCodeTemplates(const Value: TStrings);
    function GetActiveAPIListBox : TListBox;
    function GetActiveAPIEdit : TEdit;
    procedure UpdateAPIButtonState;
    procedure ResetColorGrid;
    procedure AddColorName(const S: string);
    function ActiveLanguageIndex : Integer;
    function LocalHighlighters : TStringList;
    function LanguageCount : Integer;
    property LanguageHighlighter[index : Integer] : TSynCustomHighlighter read GetCustomHighlighter;
  public
    { Public declarations }
    property ColorsChanged : boolean read fColorsChanged;
    property Keystrokes : TSynEditKeyStrokes read fKeystrokes write SetKeystrokes;
    property CodeTemplates : TStrings read fCodeTemplates write SetCodeTemplates;
  end;

var
  PrefForm: TPrefForm;
  ProgramDir : string;
  CodeExplorerSettings : TCodeExplorerProperties;

resourcestring
  sFunctions   = 'Functions';
  sSubroutines = 'Subroutines';
  sTasks       = 'Tasks';
  sExploring   = 'Exploring';

{Joystick settings}
var LeftRight:boolean;              // Whether in left-right mode
    LeftMotor:integer;              // the left motor
    RightMotor:integer;             // the right motor
    LeftReversed:boolean;           // whether left must be reversed
    RightReversed:boolean;          // whether right must be reversed
    MotorSpeed:integer;             // speed of the motors

{Macros}
const MAXMACRO = 200;
var macros:array[1..MAXMACRO] of string;
    macronumb:integer;
    MacrosChanged:boolean;

{Templates}
const MAX_TEMPLATES = 200;
var templates:array[1..MAX_TEMPLATES] of string;
    templatenumb:integer;
    ShowTemplateForm:boolean;
    ShowTemplatePopup:boolean;
    TemplatesChanged:boolean;

{Keywords}
const MAXKEY = 200;
      MAXCOM = 200;
      MAXCONST = 200;
var cc_keywords:array[1..MAXKEY] of string;
    cc_keynumb:integer;
    cc_commands:array[1..MAXCOM] of string;
    cc_commandnumb:integer;
    cc_constants:array[1..MAXCONST] of string;
    cc_constantnumb:integer;

{Recent Files}
procedure AddRecentFile(str:string);
const MAXRECENT = 4;
var RecentFiles : array [1..4] of string;

procedure FillLockedProgramArray;

{Startup}
const
  SU_SHOWFORM = 0;
  SU_CONNECT = 1;
  SU_NOCONNECT = 2;
  SU_RCX = 0;
  SU_CYBERMASTER = 1;
  SU_SCOUT = 2;
  SU_RCX2 = 3;
  K_MSTOSEC = 1000;
  K_DEFAULT_PING_TIMEOUT = 200;

var
  MainWindowState : integer; // main form window state (normal, minimized, maximized)
  LocalPortNum : integer;    // Number of the port to use for this instance
  LocalRCXType:integer;      // Brick type to use for this instance
  LocalStartupAction : integer; // action to take at startup for this instance
  LocalNQCTimeout : integer;
  RunningAsCOMServer : Boolean = False;
  NQCDebug : boolean;
  FBAlwaysPrompt : Boolean;
  FirmwareFast : boolean;
  Prog1Locked : boolean;
  Prog2Locked : boolean;
  Prog3Locked : boolean;
  Prog4Locked : boolean;
  Prog5Locked : boolean;
  LockedProgArray : array[0..4] of Boolean;
  CurrentProgramSlot : Integer = 0;
  ParseTimeout : Integer;
  PingTimeout : Word = K_DEFAULT_PING_TIMEOUT;


{Editor}
var
  ColorsChanged : boolean;   // Whether color scheme was changed
  ColorCoding:boolean;       // Whether to use color coding
  ColorCodingChanged:boolean;// Whether ColorCoding was changed
  FontName:string;           // Name of the font
  FontSize:integer;          // Size of the font
  FontChanged:boolean;       // Whether the font changed
  AutoIndentCode:boolean;    // Whether to automatically indent code
  MacrosOn:boolean;          // Whether macros can be used

  HideSelection : boolean;
  ScrollPastEOL : boolean;
  HalfPageScroll : boolean;
  DragAndDropEditing : boolean;
  AltSetsSelMode : Boolean;
  MoveCursorRight : Boolean;
  KeepBlanks : Boolean;
  UseSmartTabs : Boolean;
  EnhanceHomeKey : Boolean;
  GroupUndo : Boolean;
  TabWidth : integer;
  MaxUndo : integer;
  ExtraLineSpacing : integer;
  RightEdgePosition : integer;
  RightEdgeColor : TColor;
  ScrollBars : integer;
  EditorColor : TColor;
  SelectionForeground : TColor;
  SelectionBackground : TColor;
  AppIsClosing : Boolean;

{ Gutter }
var
  GutterColor : TColor;
  GutterWidth : integer;
  DigitCount : integer;
  LeftOffset : integer;
  RightOffset : integer;
  ShowLineNumbers : boolean;
  ShowLeadingZeros : boolean;
  ZeroStart : boolean;
  AutoSizeGutter : boolean;
  GutterVisible : boolean;
  UseFontStyle : boolean;

{General}
var
  SaveWindowPos:boolean;     // Whether to save window positions
  ShowRecent:boolean;        // Whether to show recent files
  ShowRecentChanged:boolean; // Whether ShowRecent was changed
  SaveBackup:boolean;        // Whether to save backups of existing files
  ShowStatusbar:boolean;     // Whether to show the statusbar
  CompatibilityMode:boolean; // Whether nqc 1.x compatible
  ShowCompilerStatus : boolean;
  AutoSaveFiles : Boolean;
  AutoSaveDesktop : Boolean;
  SaveBinaryOutput : Boolean;
  IncludeSrcInList : Boolean;
  NQCSwitches : string;
  DefaultMacroLibrary : string;

function  GetTarget : string;
procedure DeleteMainKey;
procedure SaveDesktopMiscToFile(aFilename : string);
procedure LoadDesktopMiscFromFile(aFilename : string);
procedure SaveWindowValuesToFile(aFilename : string);
procedure LoadWindowValuesFromFile(aFilename : string);
procedure UpgradeRegistry;
procedure RegisterApp;
procedure RestoreToolbars;
procedure SaveToolbars;
function GetHighlighterForFile(AFileName: string): TSynCustomHighlighter;

var
  gbSearchBackwards: boolean;
  gbSearchCaseSensitive: boolean;
  gbSearchFromCaret: boolean;
  gbSearchSelectionOnly: boolean;
  gbSearchTextAtCaret: boolean = true;
  gbSearchWholeWords: boolean;

  gsSearchText: string;
  gsSearchTextHistory: string;
  gsReplaceText: string;
  gsReplaceTextHistory: string;


function TransferList : Tlist;

function Highlighters : TStringList;

implementation

uses
  MainUnit, Diagnose, Controller, Watch, Piano, ConstructUnit,
  JoystickUnit, DatalogUnit, MemoryUnit, CodeUnit,
  MessageUnit, SynEditKeyCmdsEditor, IniFiles, CodeTemplates,
  uVersionInfo, uHighlighterProcs;

{$R *.DFM}

resourcestring
  S_ChangeMacroCaption    = 'Changing a Macro';
  S_ChangeMacroPrompt     = 'Change Macro %s:';
  S_ChangeTemplateCaption = 'Changing a Template';
  S_ChangeTemplatePrompt  = 'Change the Template:';
  S_InsertTemplateCaption = 'Inserting a Template';
  S_InsertTemplatePrompt  = 'Type the template you want to insert:';
  S_KeystrokeCaption      = 'Keystroke Editor';
  S_CodeTemplatesCaption  = 'Code Templates';
  S_ConfirmAPIDelete      = 'Are you sure you want to delete this item?';

var
  fHighlighters : TStringList;
  fTransferList : TList;
  StartupAction : Integer;     // Action to take at startup
  RCXType : Integer;           // RCX (0), Cybermaster (1), Scout (2), or RCX2 (3)
  COMPort : Integer;           // Number of the default COM port (0=automatic)
  NQCTimeout : Integer;

const
  K_PID = 'BricxCC.1';
  K_MAINKEY = '\Software\BricxCC';
  K_VERSION = '3.3';
  K_OLDMAINKEY = '\Software\RcxCC';
  K_OLDVERSION = 'version 3.2';
  K_WINDOWSECTION = 'BricxCC_Windows';
  K_MISCSECTION = 'BricxCC_Misc';
  K_DEF_MACRO_LIB = 'bricxcc.mlb';

var
  fMainKey : string = K_MAINKEY;
  fVersion : string = K_VERSION;
  fVerDbl : Double;

function Highlighters : TStringList;
begin
  if not Assigned(fHighlighters) then
    fHighlighters := TStringList.Create;
  Result := fHighlighters;
end;

function GetHighlighterForFile(AFileName: string): TSynCustomHighlighter;
begin
  if AFileName <> '' then
    Result := GetHighlighterFromFileExt(fHighlighters, ExtractFileExt(AFileName))
  else
    Result := nil;
end;

function TransferList : Tlist;
begin
  if not Assigned(fTransferList) then
    fTransferList := TList.Create;
  result := fTransferList;
end;

function BoolToStr(aVal : boolean) : string;
begin
  Result := 'F';
  if aVal then
    Result := 'T';
end;

function StrToBool(aStr : string) : boolean;
var
  U : string;
begin
  U := UpperCase(aStr);
  result := (U = 'T') or (U = 'TRUE');
end;

procedure SavePositions(R : TRegistry; aComp : TComponent);
var
  C : TControl;
  S : string;
  bVisible : boolean;
begin
  if aComp is TToolbar then begin
    C := TControl(aComp);
    S := C.Name;
    if C.Floating and Assigned(C.Parent) then begin
      R.WriteInteger(S + '_Left', C.Parent.Left);
      R.WriteInteger(S + '_Top', C.Parent.Top);
    end
    else begin
      R.WriteInteger(S + '_Left', C.Left);
      R.WriteInteger(S + '_Top', C.Top);
    end;
    R.WriteInteger(S + '_Width', C.Width);
    R.WriteInteger(S + '_Height', C.Height);
    R.WriteBool(S + '_Float', C.Floating);
    if Assigned(C.HostDockSite) then
      R.WriteString(S + '_HostDockSiteName', C.HostDockSite.Name)
    else
      R.WriteString(S + '_HostDockSiteName', 'cbrTop');
    if C.Floating then
      bVisible := C.HostDockSite.Visible
    else
      bVisible := C.Visible;
    R.WriteBool(S + '_Visible', bVisible);
  end;
end;

procedure LoadPositions(R : TRegistry; aComp : TComponent);
var
  M : TComponent;
  t, l, w, h : integer;
  C : TControl;
  S, dockName : string;
  bFloat, bVisible : boolean;
  P1, P2 : TPoint;
begin
  if aComp is TToolbar then begin
    C := TControl(aComp);
    S := C.Name;
    l := C.Left;
    t := C.Top;
    w := C.Width;
    h := C.Height;
    bFloat := False;
    bVisible := True;
    if R.ValueExists(S + '_Float') then begin
      bFloat := R.ReadBool(S + '_Float');
    end;
    if R.ValueExists(S + '_Visible') then begin
      bVisible := R.ReadBool(S + '_Visible');
    end;
    if R.ValueExists(S + '_HostDockSiteName') then begin
      dockName := R.ReadString(S + '_HostDockSiteName');
    end;
    if R.ValueExists(S + '_Left') then begin
      l := R.ReadInteger(S + '_Left');
    end;
    if R.ValueExists(S + '_Top') then begin
      t := R.ReadInteger(S + '_Top');
    end;
    if R.ValueExists(S + '_Width') then begin
      w := R.ReadInteger(S + '_Width');
    end;
    if R.ValueExists(S + '_Height') then begin
      h := R.ReadInteger(S + '_Height');
    end;
    if bFloat then begin
      P1 := Point(l, t);
      P2 := Point(l+w, t+h);
      C.ManualFloat(Rect(P1.x, P1.y, P2.x, P2.y));
      C.HostDockSite.Visible := bVisible;
    end
    else begin
      if dockName <> '' then begin
        M := MainForm.FindComponent(dockName);
        if Assigned(M) and (M is TWinControl) then begin
          C.ManualDock(TWinControl(M));
          C.Visible := bVisible;
        end;
      end;
      C.Left   := l;
      C.Top    := t;
      C.Width  := w;
      C.Height := h;
    end;
    Exit;
  end;
end;

procedure RestoreToolbars;
var
  R : TRegistry;
begin
  R := TRegistry.Create;
  try
    R.RootKey := HKEY_CURRENT_USER;
    if R.OpenKey(fMainKey+'\'+fVersion+'\Toolbars', false) then begin
      LoadPositions(R, MainForm.barFile);
      LoadPositions(R, MainForm.barSearch);
      LoadPositions(R, MainForm.barCompile);
      LoadPositions(R, MainForm.barHelp);
      LoadPositions(R, MainForm.barEdit);
      LoadPositions(R, MainForm.barTools);
    end;
  finally
    R.Free;
  end;
end;

procedure SaveToolbars;
var
  R : TRegistry;
begin
  R := TRegistry.Create;
  try
    R.RootKey := HKEY_CURRENT_USER;
    if R.OpenKey(fMainKey+'\'+fVersion+'\Toolbars', true) then
    begin
      SavePositions(R, MainForm.barFile);
      SavePositions(R, MainForm.barSearch);
      SavePositions(R, MainForm.barCompile);
      SavePositions(R, MainForm.barHelp);
      SavePositions(R, MainForm.barEdit);
      SavePositions(R, MainForm.barTools);
    end;
  finally
    R.Free;
  end;
end;

procedure FillLockedProgramArray;
begin
  LockedProgArray[0] := Prog1Locked;
  LockedProgArray[1] := Prog2Locked;
  LockedProgArray[2] := Prog3Locked;
  LockedProgArray[3] := Prog4Locked;
  LockedProgArray[4] := Prog5Locked;
end;

function GetTarget : string;
begin
  result := ' -TRCX';
  case LocalRCXType of
    SU_CYBERMASTER :
      result := ' -TCM';
    SU_SCOUT :
      result := ' -TScout';
    SU_RCX2 :
      result := ' -TRCX2';
  end;
end;

procedure SaveDesktopMiscToFile(aFilename : string);
var
  theFile : TMemIniFile;
begin
  theFile := TMemIniFile.Create(aFilename);
  try
    theFile.WriteInteger(K_MISCSECTION, 'PortNum', LocalPortNum);
    theFile.WriteInteger(K_MISCSECTION, 'RCXType', LocalRCXType);
    theFile.WriteInteger(K_MISCSECTION, 'SlotNum', CurrentProgramSlot);
    theFile.UpdateFile;
  finally
    theFile.Free;
  end;
end;

procedure LoadDesktopMiscFromFile(aFilename : string);
var
  theFile : TMemIniFile;
begin
  theFile := TMemIniFile.Create(aFilename);
  try
    LocalPortNum := theFile.ReadInteger(K_MISCSECTION, 'PortNum', LocalPortNum);
    LocalRCXType := theFile.ReadInteger(K_MISCSECTION, 'RCXType', LocalRCXType);
    CurrentProgramSlot := theFile.ReadInteger(K_MISCSECTION, 'SlotNum', CurrentProgramSlot);
  finally
    theFile.Free;
  end;
end;

procedure SaveWindowValuesToFile(aFilename : string);
var
  theFile : TMemIniFile;
begin
  theFile := TMemIniFile.Create(aFilename);
  try
    theFile.WriteInteger(K_WINDOWSECTION, 'XMainWindow', MainForm.Left);
    theFile.WriteInteger(K_WINDOWSECTION, 'YMainWindow', MainForm.Top);
    theFile.WriteInteger(K_WINDOWSECTION, 'WMainWindow', MainForm.Width);
    theFile.WriteInteger(K_WINDOWSECTION, 'HMainWindow', MainForm.Height);
    theFile.WriteInteger(K_WINDOWSECTION, 'CodeExplorerWidth', MainForm.pnlCodeExplorer.Width);
    theFile.WriteInteger(K_WINDOWSECTION, 'XDiagWindow', DiagForm.Left);
    theFile.WriteInteger(K_WINDOWSECTION, 'YDiagWindow', DiagForm.Top);
    theFile.WriteInteger(K_WINDOWSECTION, 'XDirectWindow', DirectForm.Left);
    theFile.WriteInteger(K_WINDOWSECTION, 'YDirectWindow', DirectForm.Top);
    theFile.WriteInteger(K_WINDOWSECTION, 'XWatchWindow', WatchForm.Left);
    theFile.WriteInteger(K_WINDOWSECTION, 'YWatchWindow', WatchForm.Top);
    theFile.WriteInteger(K_WINDOWSECTION, 'XPianoWindow', PianoForm.Left);
    theFile.WriteInteger(K_WINDOWSECTION, 'YPianoWindow', PianoForm.Top);
    theFile.WriteInteger(K_WINDOWSECTION, 'XConstructWindow', ConstructForm.Left);
    theFile.WriteInteger(K_WINDOWSECTION, 'YConstructWindow', ConstructForm.Top);
    theFile.WriteInteger(K_WINDOWSECTION, 'XJoystickWindow', JoystickForm.Left);
    theFile.WriteInteger(K_WINDOWSECTION, 'YJoystickWindow', JoystickForm.Top);
    theFile.WriteInteger(K_WINDOWSECTION, 'XDatalogWindow', DatalogForm.Left);
    theFile.WriteInteger(K_WINDOWSECTION, 'YDatalogWindow', DatalogForm.Top);
    theFile.WriteInteger(K_WINDOWSECTION, 'XMemoryWindow', MemoryForm.Left);
    theFile.WriteInteger(K_WINDOWSECTION, 'YMemoryWindow', MemoryForm.Top);
    theFile.WriteInteger(K_WINDOWSECTION, 'XCodeWindow', CodeForm.Left);
    theFile.WriteInteger(K_WINDOWSECTION, 'YCodeWindow', CodeForm.Top);
    theFile.WriteInteger(K_WINDOWSECTION, 'WCodeWindow', CodeForm.Width);
    theFile.WriteInteger(K_WINDOWSECTION, 'HCodeWindow', CodeForm.Height);
    theFile.WriteInteger(K_WINDOWSECTION, 'XMessageWindow', MessageForm.Left);
    theFile.WriteInteger(K_WINDOWSECTION, 'YMessageWindow', MessageForm.Top);
    theFile.UpdateFile;
  finally
    theFile.Free;
  end;
end;

procedure LoadWindowValuesFromFile(aFilename : string);
var
  theFile : TMemIniFile;
begin
  theFile := TMemIniFile.Create(aFilename);
  try
    MainForm.Left := theFile.ReadInteger(K_WINDOWSECTION, 'XMainWindow', MainForm.Left);
    MainForm.Top := theFile.ReadInteger(K_WINDOWSECTION, 'YMainWindow', MainForm.Top);
    MainForm.Width := theFile.ReadInteger(K_WINDOWSECTION, 'WMainWindow', MainForm.Width);
    MainForm.Height := theFile.ReadInteger(K_WINDOWSECTION, 'HMainWindow', MainForm.Height);
    MainForm.pnlCodeExplorer.Width := theFile.ReadInteger(K_WINDOWSECTION, 'CodeExplorerWidth', MainForm.pnlCodeExplorer.Width);
    DiagForm.Left := theFile.ReadInteger(K_WINDOWSECTION, 'XDiagWindow', DiagForm.Left);
    DiagForm.Top := theFile.ReadInteger(K_WINDOWSECTION, 'YDiagWindow', DiagForm.Top);
    DirectForm.Left := theFile.ReadInteger(K_WINDOWSECTION, 'XDirectWindow', DirectForm.Left);
    DirectForm.Top := theFile.ReadInteger(K_WINDOWSECTION, 'YDirectWindow', DirectForm.Top);
    WatchForm.Left := theFile.ReadInteger(K_WINDOWSECTION, 'XWatchWindow', WatchForm.Left);
    WatchForm.Top := theFile.ReadInteger(K_WINDOWSECTION, 'YWatchWindow', WatchForm.Top);
    PianoForm.Left := theFile.ReadInteger(K_WINDOWSECTION, 'XPianoWindow', PianoForm.Left);
    PianoForm.Top := theFile.ReadInteger(K_WINDOWSECTION, 'YPianoWindow', PianoForm.Top);
    ConstructForm.Left := theFile.ReadInteger(K_WINDOWSECTION, 'XConstructWindow', ConstructForm.Left);
    ConstructForm.Top := theFile.ReadInteger(K_WINDOWSECTION, 'YConstructWindow', ConstructForm.Top);
    JoystickForm.Left := theFile.ReadInteger(K_WINDOWSECTION, 'XJoystickWindow', JoystickForm.Left);
    JoystickForm.Top := theFile.ReadInteger(K_WINDOWSECTION, 'YJoystickWindow', JoystickForm.Top);
    DatalogForm.Left := theFile.ReadInteger(K_WINDOWSECTION, 'XDatalogWindow', DatalogForm.Left);
    DatalogForm.Top := theFile.ReadInteger(K_WINDOWSECTION, 'YDatalogWindow', DatalogForm.Top);
    MemoryForm.Left := theFile.ReadInteger(K_WINDOWSECTION, 'XMemoryWindow', MemoryForm.Left);
    MemoryForm.Top := theFile.ReadInteger(K_WINDOWSECTION, 'YMemoryWindow', MemoryForm.Top);
    CodeForm.Left := theFile.ReadInteger(K_WINDOWSECTION, 'XCodeWindow', CodeForm.Left);
    CodeForm.Top := theFile.ReadInteger(K_WINDOWSECTION, 'YCodeWindow', CodeForm.Top);
    CodeForm.Width := theFile.ReadInteger(K_WINDOWSECTION, 'WCodeWindow', CodeForm.Width);
    CodeForm.Height := theFile.ReadInteger(K_WINDOWSECTION, 'HCodeWindow', CodeForm.Height);
    MessageForm.Left := theFile.ReadInteger(K_WINDOWSECTION, 'XMessageWindow', MessageForm.Left);
    MessageForm.Top := theFile.ReadInteger(K_WINDOWSECTION, 'YMessageWindow', MessageForm.Top);
  finally
    theFile.Free;
  end;
end;

{**************************************************
  Registry stuff
 **************************************************}

procedure DeleteMainKey;
var
  tmpReg : TRegistry;
begin
  tmpReg := TRegistry.Create;
  try
    tmpReg.DeleteKey(fMainKey + '\' + fVersion);
  finally
    tmpReg.Free;
  end;
end;

procedure Reg_OpenKey(r : TRegistry; name:string);
begin
  {Opens the registry key}
  r.OpenKey(fMainKey+'\'+fVersion+'\'+name,true);
end;

procedure Reg_DeleteKey(r : TRegistry; name:string);
begin
  {Deletes the registry key}
  r.DeleteKey(fMainKey+'\'+fVersion+'\'+name);
end;

function Reg_KeyExists(r : TRegistry; name:string):boolean;
begin
  Result := r.KeyExists(fMainKey+'\'+fVersion+'\'+name);
end;

{-- Booleans --}

function Reg_ReadBool(r: TRegistry; name:string; def:boolean):boolean;
begin
  {Read a boolean value from the registry. Returns the
   default when it does not exist.}
  if r.ValueExists(name) then
    Result := r.ReadBool(name)
  else
    Result := def;
end;

{-- Integers --}

function Reg_ReadInteger(r: TRegistry; name:string; def:integer):integer;
begin
  {Read a integer value from the registry. Returns the
   default when it does not exist.}
  if r.ValueExists(name) then
    Result := r.ReadInteger(name)
  else
    Result := def;
end;

{-- Strings --}

function Reg_ReadString(r: TRegistry; name:string; def:string):string;
begin
  {Read a string value from the registry. Returns the
   default when it does not exist.}
  if r.ValueExists(name) then
    Result := r.ReadString(name)
  else
    Result := def;
end;

{-- Styles --}

procedure Reg_WriteStyle(r : TRegistry; name:string; val:TFontStyles);
var
  tt : integer;
begin
{Writes a style value to the registry}
  tt := 0;
  if fsBold in val then tt := tt+1;
  if fsItalic in val then tt := tt+2;
  r.WriteInteger(name,tt);
end;

function Reg_ReadStyle(r : TRegistry; name:string; def:TFontStyles):TFontStyles;
var
  tt : integer;
begin
  {Read a style value from the registry. Returns the default when it does not exist.}
  if r.ValueExists(name) then
  begin
    tt := r.ReadInteger(name);
    Result := [];
    if (tt and 1) > 0 then Result := Result + [fsBold];
    if (tt and 2) > 0 then Result := Result + [fsItalic];
  end
  else
    Result := def;
end;

{-- Colors --}

procedure Reg_WriteColor(r : TRegistry; name:string; val:TColor);
begin
  {Writes a color value to the registry}
  r.WriteInteger(name,integer(val));
end;

function Reg_ReadColor(r : TRegistry; name:string; def:TColor) : TColor;
begin
  {Read a color value from the registry. Returns the
   default when it does not exist.}
  if r.ValueExists(name) then
    Result := TColor(r.ReadInteger(name))
  else
    Result := def;
end;

{**************************************************
  Reading and writing the registry
 **************************************************}

function MyIntToStr(val:integer):string;
begin
  Result := IntToStr(val div 100) +
            IntToStr((val mod 100) div 10) +
            IntToStr(val mod 10);
end;

(*
{ color stuff }

const
  Colors: array[1..42 {sic!}] of TColor = (clBlack, clMaroon, clGreen, clOlive,
    clNavy, clPurple, clTeal, clDkGray, clLtGray, clRed, clLime,
    clYellow, clBlue, clFuchsia, clAqua, clWhite, clScrollBar,
    clBackground, clActiveCaption, clInactiveCaption, clMenu, clWindow,
    clWindowFrame, clMenuText, clWindowText, clCaptionText,
    clActiveBorder, clInactiveBorder, clAppWorkSpace, clHighlight,
    clHighlightText, clBtnFace, clBtnShadow, clGrayText, clBtnText,
    clInactiveCaptionText, clBtnHighlight, cl3DDkShadow, cl3DLight,
    clInfoText, clInfoBk, clNone);

function ColorToIndex(AColor: TColor): integer;
var
  i: integer;
begin
  Result := 0;
  for i := Low(Colors) to High(Colors) do
    if Colors[i] = AColor then begin
      Result := i - 1;
      break;
    end;
end;

function IndexToColor(AIndex: integer): TColor;
begin
  Result := Colors[AIndex + 1];
end;
*)


{Macros}

procedure LoadMacroValues(reg : TRegistry);
{Loads the macro values from the registry}
var i:integer;
    f:TextFile;
begin
  if not Reg_KeyExists(reg, 'Macros') then
  begin
    if FileExists(ProgramDir+'Default\macros.txt') then begin
      AssignFile(f,ProgramDir+'Default\macros.txt');
      try
        Reset(f);
        macronumb := 0;
        while not Eof(f) do
        begin
          macronumb:=macronumb+1;
          ReadLn(f,macros[macronumb]);
        end;
      finally
        CloseFile(f);
      end;
    end;
  end
  else
  begin
    Reg_OpenKey(reg, 'Macros');
    i:=1;
    while reg.ValueExists('Macro'+MyIntToStr(i)) do
    begin
      macros[i] := Reg_ReadString(reg, 'Macro'+MyIntToStr(i),'');
      i := i+1;
    end;
    macronumb := i-1;
    reg.CloseKey;
  end;
end;

procedure SaveMacroValues(reg : TRegistry);
{Saves the macro values to the registry}
var i:integer;
begin
  Reg_DeleteKey(reg, 'Macros');
  Reg_OpenKey(reg, 'Macros');
  for i:=1 to macronumb do
    reg.WriteString('Macro'+MyIntToStr(i),macros[i]);
  reg.CloseKey;
end;

procedure ResetMacroValues(reg : TRegistry);
{Resets the macro values to default}
begin
  Reg_DeleteKey(reg, 'Macros');
  LoadMacroValues(reg);
end;

{Templates}

{Loads the template values from the registry}
procedure LoadTemplateValues(reg : TRegistry);
var i:integer;
    f:TextFile;
begin
  if not Reg_KeyExists(reg, 'Templates') then
  begin
    if FileExists(ProgramDir+'Default\templates.txt') then begin
      AssignFile(f,ProgramDir+'Default\templates.txt');
      try
        Reset(f);
        templatenumb := 0;
        while not Eof(f) do
        begin
          templatenumb:=templatenumb+1;
          ReadLn(f,templates[templatenumb]);
        end;
      finally
        CloseFile(f);
      end;
    end;
  end
  else
  begin
    Reg_OpenKey(reg, 'Templates');
    i:=1;
    while reg.ValueExists('Template'+MyIntToStr(i)) do
    begin
      templates[i] := Reg_ReadString(reg, 'Template'+MyIntToStr(i),'');
      i := i+1;
    end;
    templatenumb := i-1;
    reg.CloseKey;
  end;
end;

{Saves the template values to the registry}
procedure SaveTemplateValues(reg : TRegistry);
var i:integer;
begin
  Reg_DeleteKey(reg, 'Templates');
  Reg_OpenKey(reg, 'Templates');
  for i:=1 to templatenumb do
    reg.WriteString('Template'+MyIntToStr(i),templates[i]);
  reg.CloseKey;
end;

{Resets the template values to default}
procedure ResetTemplateValues(reg : TRegistry);
begin
  Reg_DeleteKey(reg, 'Templates');
  LoadTemplateValues(reg);
end;

procedure PutValuesInSyntaxHighlighter;
var
  i : integer;
begin
  if not Assigned(PrefForm) then Exit;
  // keywords
  PrefForm.SynNQCSyn.KeyWords.Clear;
  for i := 1 to cc_keynumb do
  begin
    PrefForm.SynNQCSyn.KeyWords.Add(cc_keywords[i]);
  end;
  // commands
  PrefForm.SynNQCSyn.Commands.Clear;
  for i := 1 to cc_commandnumb do
  begin
    PrefForm.SynNQCSyn.Commands.Add(cc_commands[i]);
  end;
  // constants
  PrefForm.SynNQCSyn.Constants.Clear;
  for i := 1 to cc_constantnumb do
  begin
    PrefForm.SynNQCSyn.Constants.Add(cc_constants[i]);
  end;
  // now copy to main form
  MainForm.SynNQCSyn.KeyWords.Assign(PrefForm.SynNQCSyn.KeyWords);
  MainForm.SynNQCSyn.Commands.Assign(PrefForm.SynNQCSyn.Commands);
  MainForm.SynNQCSyn.Constants.Assign(PrefForm.SynNQCSyn.Constants);
end;

{Keywords for Colorcoding}

procedure LoadAPIValues(reg : TRegistry);
var i:integer;
    f:TextFile;
begin
  {Loads the keyword values from the registry}
  if not Reg_KeyExists(reg, 'Keywords') then
  begin
    if FileExists(ProgramDir+'Default\keywords.txt') then begin
      AssignFile(f,ProgramDir+'Default\keywords.txt');
      try
        Reset(f);
        cc_keynumb := 0;
        while not Eof(f) do
        begin
          cc_keynumb:=cc_keynumb+1;
          ReadLn(f,cc_keywords[cc_keynumb]);
        end;
      finally
        CloseFile(f);
      end;
    end;

    if FileExists(ProgramDir+'Default\commands.txt') then begin
      AssignFile(f,ProgramDir+'Default\commands.txt');
      try
        Reset(f);
        cc_commandnumb := 0;
        while not Eof(f) do
        begin
          cc_commandnumb:=cc_commandnumb+1;
          ReadLn(f,cc_commands[cc_commandnumb]);
        end;
      finally
        CloseFile(f);
      end;
    end;

    if FileExists(ProgramDir+'Default\constants.txt') then begin
      AssignFile(f,ProgramDir+'Default\constants.txt');
      try
        Reset(f);
        cc_constantnumb := 0;
        while not Eof(f) do
        begin
          cc_constantnumb:=cc_constantnumb+1;
          ReadLn(f,cc_constants[cc_constantnumb]);
        end;
      finally
        CloseFile(f);
      end;
    end;
  end
  else
  begin
    Reg_OpenKey(reg, 'Keywords');
    try
      i:=1;
      while reg.ValueExists('Keyword'+MyIntToStr(i)) do
      begin
        cc_keywords[i] := Reg_ReadString(reg, 'Keyword'+MyIntToStr(i),'');
        i := i+1;
      end;
      cc_keynumb := i-1;
    finally
      reg.CloseKey;
    end;

    Reg_OpenKey(reg, 'Commands');
    try
      i:=1;
      while reg.ValueExists('Command'+MyIntToStr(i)) do
      begin
        cc_commands[i] := Reg_ReadString(reg, 'Command'+MyIntToStr(i),'');
        i := i+1;
      end;
      cc_commandnumb := i-1;
    finally
      reg.CloseKey;
    end;

    Reg_OpenKey(reg, 'Constants');
    try
      i:=1;
      while reg.ValueExists('Constant'+MyIntToStr(i)) do
      begin
        cc_constants[i] := Reg_ReadString(reg, 'Constant'+MyIntToStr(i),'');
        i := i+1;
      end;
      cc_constantnumb := i-1;
    finally
      reg.CloseKey;
    end;
  end;
  PutValuesInSyntaxHighlighter;
end;

procedure SaveAPIValues(reg : TRegistry);
var
  i : integer;
begin
  {Saves the keyword values to the registry}
  Reg_DeleteKey(reg, 'Keywords');
  Reg_OpenKey(reg, 'Keywords');
  try
    for i:=1 to cc_keynumb do
      reg.WriteString('Keyword'+MyIntToStr(i),cc_keywords[i]);
  finally
    reg.CloseKey;
  end;

  Reg_DeleteKey(reg, 'Commands');
  Reg_OpenKey(reg, 'Commands');
  try
    for i:=1 to cc_commandnumb do
      reg.WriteString('Command'+MyIntToStr(i),cc_commands[i]);
  finally
    reg.CloseKey;
  end;

  Reg_DeleteKey(reg, 'Constants');
  Reg_OpenKey(reg, 'Constants');
  try
    for i:=1 to cc_constantnumb do
      reg.WriteString('Constant'+MyIntToStr(i),cc_constants[i]);
  finally
    reg.CloseKey;
  end;
end;

procedure ResetAPIValues(reg : TRegistry);
begin
{Resets the keyword values to default}
  Reg_DeleteKey(reg, 'Keywords');
  Reg_DeleteKey(reg, 'Commands');
  Reg_DeleteKey(reg, 'Constants');
  LoadAPIValues(reg);
end;

{ The Recent Files Information}

procedure AddRecentFile(str:string);
var
  i : integer;
begin
  for i:=1 to MAXRECENT do
    if RecentFiles[i] = str then Exit;
  for i:= MAXRECENT downto 2 do
    RecentFiles[i] := RecentFiles[i-1];
  RecentFiles[1] := str;
end;

procedure LoadRecentValues(reg : TRegistry);
var
  i : integer;
begin
  {Loads the recent files values from the registry}
  Reg_OpenKey(reg, 'Recent Files');
  try
    for i:=1 to MAXRECENT do
      RecentFiles[i] := Reg_ReadString(reg, 'RecentFiles'+MyIntToStr(i),'');
  finally
    reg.CloseKey;
  end;
end;

procedure SaveRecentValues(reg : TRegistry);
var
  i : integer;
begin
  {Saves the recent files values in the registry}
  Reg_DeleteKey(reg, 'Recent Files');
  Reg_OpenKey(reg, 'Recent Files');
  try
    for i:=1 to MAXRECENT do
      reg.WriteString('RecentFiles'+MyIntToStr(i),RecentFiles[i]);
  finally
    reg.CloseKey;
  end;
end;

procedure ResetRecentValues(reg : TRegistry);
begin
  {Resets the recent values to default}
  Reg_DeleteKey(reg, 'Recent Files');
  LoadRecentValues(reg);
end;

procedure LoadWindowsValues(reg : TRegistry);
begin
  {Loads the windows values from the registry}
  if not SaveWindowPos then Exit;
  Reg_OpenKey(reg, 'Windows');
  try
    MainWindowState    := Reg_ReadInteger(reg, 'WSMainWindow', Integer(wsNormal));
    MainForm.Left      := Reg_ReadInteger(reg, 'XMainWindow', 100);
    MainForm.Top       := Reg_ReadInteger(reg, 'YMainWindow', 10);
    MainForm.Width     := Reg_ReadInteger(reg, 'WMainWindow', 600);
    MainForm.Height    := Reg_ReadInteger(reg, 'HMainWindow', 450);
    MainForm.pnlCodeExplorer.Width := Reg_ReadInteger(reg, 'CodeExplorerWidth', 105); 
    DiagForm.Left      := Reg_ReadInteger(reg, 'XDiagWindow', 30);
    DiagForm.Top       := Reg_ReadInteger(reg, 'YDiagWindow', 30);
    DirectForm.Left    := Reg_ReadInteger(reg, 'XDirectWindow', 50);
    DirectForm.Top     := Reg_ReadInteger(reg, 'YDirectWindow', 50);
    WatchForm.Left     := Reg_ReadInteger(reg, 'XWatchWindow', 70);
    WatchForm.Top      := Reg_ReadInteger(reg, 'YWatchWindow', 70);
    PianoForm.Left     := Reg_ReadInteger(reg, 'XPianoWindow', 90);
    PianoForm.Top      := Reg_ReadInteger(reg, 'YPianoWindow', 90);
    ConstructForm.Left := Reg_ReadInteger(reg, 'XTemplateWindow', 10);
    ConstructForm.Top  := Reg_ReadInteger(reg, 'YTemplateWindow', 10);
    JoystickForm.Left  := Reg_ReadInteger(reg, 'XJoystickWindow', 100);
    JoystickForm.Top   := Reg_ReadInteger(reg, 'YJoyStickWindow', 100);
    DatalogForm.Left   := Reg_ReadInteger(reg, 'XDatalogWindow', 110);
    DatalogForm.Top    := Reg_ReadInteger(reg, 'YDatalogWindow', 110);
    MemoryForm.Left    := Reg_ReadInteger(reg, 'XMemoryWindow', 130);
    MemoryForm.Top     := Reg_ReadInteger(reg, 'YMemoryWindow', 130);
    CodeForm.Left      := Reg_ReadInteger(reg, 'XCodeWindow', 140);
    CodeForm.Top       := Reg_ReadInteger(reg, 'YCodeWindow', 140);
    CodeForm.Width     := Reg_ReadInteger(reg, 'WCodeWindow', 500);
    CodeForm.Height    := Reg_ReadInteger(reg, 'HCodeWindow', 340);
    MessageForm.Left   := Reg_ReadInteger(reg, 'XMessageWindow', 150);
    MessageForm.Top    := Reg_ReadInteger(reg, 'YMessageWindow', 150);
    if Assigned(PrefForm) then
    begin
      PrefForm.Left      := Reg_ReadInteger(reg, 'XPrefWindow', 90);
      PrefForm.Top       := Reg_ReadInteger(reg, 'YPrefWindow', 90);
    end;
  finally
    reg.CloseKey;
  end;
end;

procedure SaveWindowsValues(reg : TRegistry);
var
  w : Integer;
begin
  {Saves the windows values in the registry}
  if not SaveWindowPos then Exit;
  Reg_DeleteKey(reg, 'Windows');
  Reg_OpenKey(reg, 'Windows');
  try
    reg.WriteInteger('WSMainWindow', MainWindowState);
    reg.WriteInteger('XMainWindow', MainForm.Left);
    reg.WriteInteger('YMainWindow', MainForm.Top);
    reg.WriteInteger('WMainWindow', MainForm.Width);
    reg.WriteInteger('HMainWindow', MainForm.Height);
    w := MainForm.pnlCodeExplorer.Width;
    if w = 0 then w := 105;
    reg.WriteInteger('CodeExplorerWidth', w);
    reg.WriteInteger('XDiagWindow', DiagForm.Left);
    reg.WriteInteger('YDiagWindow', DiagForm.Top);
    reg.WriteInteger('XDirectWindow', DirectForm.Left);
    reg.WriteInteger('YDirectWindow', DirectForm.Top);
    reg.WriteInteger('XWatchWindow', WatchForm.Left);
    reg.WriteInteger('YWatchWindow', WatchForm.Top);
    reg.WriteInteger('XPianoWindow', PianoForm.Left);
    reg.WriteInteger('YPianoWindow', PianoForm.Top);
    reg.WriteInteger('XTemplateWindow', ConstructForm.Left);
    reg.WriteInteger('YTemplateWindow', ConstructForm.Top);
    reg.WriteInteger('XJoystickWindow', JoystickForm.Left);
    reg.WriteInteger('YJoystickWindow', JoystickForm.Top);
    reg.WriteInteger('XDatalogWindow', DatalogForm.Left);
    reg.WriteInteger('YDatalogWindow', DatalogForm.Top);
    reg.WriteInteger('XMemoryWindow', MemoryForm.Left);
    reg.WriteInteger('YMemoryWindow', MemoryForm.Top);
    reg.WriteInteger('XCodeWindow', CodeForm.Left);
    reg.WriteInteger('YCodeWindow', CodeForm.Top);
    reg.WriteInteger('WCodeWindow', CodeForm.Width);
    reg.WriteInteger('HCodeWindow', CodeForm.Height);
    reg.WriteInteger('XMessageWindow', MessageForm.Left);
    reg.WriteInteger('YMessageWindow', MessageForm.Top);
    if Assigned(PrefForm) then
    begin
      reg.WriteInteger('XPrefWindow', PrefForm.Left);
      reg.WriteInteger('YPrefWindow', PrefForm.Top);
    end;
  finally
    reg.CloseKey;
  end;
end;

procedure ResetWindowsValues(reg : TRegistry);
begin
  {Resets the windows values to default}
  Reg_DeleteKey(reg, 'Windows');
  LoadWindowsValues(reg);
end;

procedure LoadJoystickValues(reg : TRegistry);
begin
  {Loads the joystick values from the registry}
  Reg_OpenKey(reg, 'Joystick');
  try
    LeftRight     := Reg_ReadBool(reg, 'LeftRight', true);
    LeftMotor     := Reg_ReadInteger(reg, 'LeftMotor', 0);
    RightMotor    := Reg_ReadInteger(reg, 'RightMotor', 2);
    LeftReversed  := Reg_ReadBool(reg, 'LeftReversed', false);
    RightReversed := Reg_ReadBool(reg, 'RightReversed', false);
    MotorSpeed    := Reg_ReadInteger(reg, 'MotorSpeed', 4);
  finally
    reg.CloseKey;
  end;
end;

procedure SaveJoystickValues(reg : TRegistry);
{Saves the joystick values to the registry}
begin
  Reg_DeleteKey(reg, 'Joystick');
  Reg_OpenKey(reg, 'Joystick');
  try
    reg.WriteBool('LeftRight',LeftRight);
    reg.WriteInteger('LeftMotor',LeftMotor);
    reg.WriteInteger('RightMotor',RightMotor);
    reg.WriteBool('LeftReversed',LeftReversed);
    reg.WriteBool('RightReversed',RightReversed);
    reg.WriteInteger('MotorSpeed',MotorSpeed);
  finally
    reg.CloseKey;
  end;
end;

procedure ResetJoystickValues(reg : TRegistry);
begin
  {Resets the joystick values to default}
  Reg_DeleteKey(reg, 'Joystick');
  LoadJoystickValues(reg);
end;

procedure LoadColorValues(reg : TRegistry);
var
  j, i : Integer;
  SCH : TSynCustomHighlighter;
  A : TSynHighlighterAttributes;
begin
  // load color and style values into global syntax highlighter
  for j := 0 to Highlighters.Count - 1 do
  begin
    SCH := TSynCustomHighlighter(Highlighters.Objects[j]);
    Reg_OpenKey(reg, SCH.GetLanguageName + 'Colors');
    try
      for i := 0 to SCH.AttrCount - 1 do
      begin
        A := SCH.Attribute[i];
        A.Background := Reg_ReadColor(reg, A.Name + 'BGColor', PrefForm.fDefBGColors[j][i]);
        A.Foreground := Reg_ReadColor(reg, A.Name + 'FGColor', PrefForm.fDefFGColors[j][i]);
        A.Style      := Reg_ReadStyle(reg, A.Name + 'Style', PrefForm.fDefStyles[j][i]);
      end;
    finally
      reg.CloseKey;
    end;
  end;
end;

procedure DeleteAllColorKeys(reg : TRegistry);
var
  j : Integer;
  SCH : TSynCustomHighlighter;
begin
  for j := 0 to Highlighters.Count - 1 do
  begin
    SCH := TSynCustomHighlighter(Highlighters.Objects[j]);
    Reg_DeleteKey(reg, SCH.GetLanguageName + 'Colors');
  end;
end;

procedure SaveColorValues(reg : TRegistry);
var
  j, i : Integer;
  SCH : TSynCustomHighlighter;
  A : TSynHighlighterAttributes;
begin
  {Saves the color values in the registry}
  DeleteAllColorKeys(reg);
  for j := 0 to Highlighters.Count - 1 do
  begin
    SCH := TSynCustomHighlighter(Highlighters.Objects[j]);
    Reg_OpenKey(reg, SCH.GetLanguageName + 'Colors');
    try
      for i := 0 to SCH.AttrCount - 1 do
      begin
        A := SCH.Attribute[i];
        Reg_WriteColor(reg, A.Name + 'BGColor', A.Background);
        Reg_WriteColor(reg, A.Name + 'FGColor', A.Foreground);
        Reg_WriteStyle(reg, A.Name + 'Style', A.Style);
      end;
    finally
      reg.CloseKey;
    end;
  end;
end;

procedure ResetColorValues(reg : TRegistry);
begin
  {Resets the color values to default}
  DeleteAllColorKeys(reg);
  LoadColorValues(reg);
end;

procedure LoadStartupValues(reg : TRegistry);
begin
  {Loads the startup values from the registry}
  Reg_OpenKey(reg, 'Startup');
  try
    StartupAction := Reg_ReadInteger(reg, 'StartupAction', SU_SHOWFORM);
    // initialize the "this instance" startup action
    LocalStartupAction := StartupAction;

    RCXType := Reg_ReadInteger(reg, 'RCXType', SU_RCX);
    // initialize the "this instance" RCXType to be the default RCXType
    LocalRCXType := RCXType;

    COMPort := Reg_ReadInteger(reg, 'COMPort', 0);
    // initialize the "this instance" COMPort to be the default COMPort
    LocalPortNum := COMPort;

    FBAlwaysPrompt := Reg_ReadBool(reg, 'FBAlwaysPrompt', True);
  finally
    reg.CloseKey;
  end;
end;

procedure SaveStartupValues(reg : TRegistry);
begin
  {Saves the startup values from the registry}
  Reg_DeleteKey(reg, 'Startup');
  Reg_OpenKey(reg, 'Startup');
  try
    reg.WriteInteger('StartupAction',StartupAction);
    reg.WriteInteger('RCXType',RCXType);
    reg.WriteInteger('COMPort',COMPort);
    reg.WriteBool('FBAlwaysPrompt', FBAlwaysPrompt);
  finally
    reg.CloseKey;
  end;
end;

procedure ResetStartupValues(reg : TRegistry);
begin
  {Resets the startup values to default}
  Reg_DeleteKey(reg, 'Startup');
  LoadStartupValues(reg);
end;

procedure LoadGeneralValues(reg : TRegistry);
begin
  {Loads the general values from the registry}
  Reg_OpenKey(reg, 'General');
  try
    ShowRecent         := Reg_ReadBool(reg, 'ShowRecent',True);
    SaveBackup         := Reg_ReadBool(reg, 'SaveBackup',True);
    SaveWindowPos      := Reg_ReadBool(reg, 'SaveWindowPos',True);
    ShowStatusbar      := Reg_ReadBool(reg, 'ShowStatusbar',True);
    CompatibilityMode  := Reg_ReadBool(reg, 'CompatibilityMode',False);
    ShowCompilerStatus := Reg_ReadBool(reg, 'ShowCompilerStatus', False);
    AutoSaveFiles      := Reg_ReadBool(reg, 'AutoSaveFiles', False);
    AutoSaveDesktop    := Reg_ReadBool(reg, 'AutoSaveDesktop', False);
    SaveBinaryOutput   := Reg_ReadBool(reg, 'SaveBinaryOutput', False);
    IncludeSrcInList   := Reg_ReadBool(reg, 'IncludeSrcInList', False);
    FirmwareFast       := Reg_ReadBool(reg, 'FirmwareFast', False);
    NQCTimeout         := Reg_ReadInteger(reg, 'NQCTimeout', 60000);
    LocalNQCTimeout    := NQCTimeout;
    NQCSwitches        := Reg_ReadString(reg, 'NQCSwitches', '');
    Prog1Locked        := Reg_ReadBool(reg, 'Prog1Locked', False);
    Prog2Locked        := Reg_ReadBool(reg, 'Prog2Locked', False);
    Prog3Locked        := Reg_ReadBool(reg, 'Prog3Locked', False);
    Prog4Locked        := Reg_ReadBool(reg, 'Prog4Locked', False);
    Prog5Locked        := Reg_ReadBool(reg, 'Prog5Locked', False);

    DefaultMacroLibrary := Reg_ReadString(reg, 'DefaultMacroLibrary', ExtractFilePath(Application.ExeName) + K_DEF_MACRO_LIB);
    ParseTimeout        := Reg_ReadInteger(reg, 'ParseTimeout', 10000);
    PingTimeout         := Reg_ReadInteger(reg, 'PingTimeout', PingTimeout);

    gbSearchBackwards     := Reg_ReadBool(reg, 'SearchBackwards', false);
    gbSearchCaseSensitive := Reg_ReadBool(reg, 'SearchCaseSensitive', false);
    gbSearchFromCaret     := Reg_ReadBool(reg, 'SearchFromCaret', false);
    gbSearchSelectionOnly := Reg_ReadBool(reg, 'SearchSelectionOnly', false);
    gbSearchTextAtCaret   := Reg_ReadBool(reg, 'SearchTextAtCaret', true);
    gbSearchWholeWords    := Reg_ReadBool(reg, 'SearchWholeWords', false);

    gsSearchText          := Reg_ReadString(reg, 'SearchText', '');
    gsSearchTextHistory   := Reg_ReadString(reg, 'SearchTextHistory', '');
    gsReplaceText         := Reg_ReadString(reg, 'ReplaceText', '');
    gsReplaceTextHistory  := Reg_ReadString(reg, 'ReplaceTextHistory', '');

  finally
    reg.CloseKey;
  end;
  FillLockedProgramArray;
end;

procedure SaveGeneralValues(reg : TRegistry);
begin
  {Saves the general values to the registry}
  Reg_DeleteKey(reg, 'General');
  Reg_OpenKey(reg, 'General');
  try
    reg.WriteBool('ShowRecent', ShowRecent);
    reg.WriteBool('SaveBackup', SaveBackup);
    reg.WriteBool('SaveWindowPos', SaveWindowPos);
    reg.WriteBool('ShowStatusbar', ShowStatusbar);
    reg.WriteBool('CompatibilityMode', CompatibilityMode);
    reg.WriteBool('ShowCompilerStatus', ShowCompilerStatus);
    reg.WriteBool('AutoSaveFiles', AutoSaveFiles);
    reg.WriteBool('AutoSaveDesktop', AutoSaveDesktop);
    reg.WriteBool('SaveBinaryOutput', SaveBinaryOutput);
    reg.WriteBool('IncludeSrcInList', IncludeSrcInList);
    reg.WriteBool('FirmwareFast', FirmwareFast);
    reg.WriteInteger('NQCTimeout', NQCTimeout);
    reg.WriteString('NQCSwitches', NQCSwitches);
    reg.WriteBool('Prog1Locked', Prog1Locked);
    reg.WriteBool('Prog2Locked', Prog2Locked);
    reg.WriteBool('Prog3Locked', Prog3Locked);
    reg.WriteBool('Prog4Locked', Prog4Locked);
    reg.WriteBool('Prog5Locked', Prog5Locked);

    reg.WriteString('DefaultMacroLibrary', DefaultMacroLibrary);
    reg.WriteInteger('ParseTimeout', ParseTimeout);
    reg.WriteInteger('PingTimeout', PingTimeout);

    reg.WriteBool('SearchBackwards', gbSearchBackwards);
    reg.WriteBool('SearchCaseSensitive', gbSearchCaseSensitive);
    reg.WriteBool('SearchFromCaret', gbSearchFromCaret);
    reg.WriteBool('SearchSelectionOnly', gbSearchSelectionOnly);
    reg.WriteBool('SearchTextAtCaret', gbSearchTextAtCaret);
    reg.WriteBool('SearchWholeWords', gbSearchWholeWords);

    reg.WriteString('SearchText', gsSearchText);
    reg.WriteString('SearchTextHistory', gsSearchTextHistory);
    reg.WriteString('ReplaceText', gsReplaceText);
    reg.WriteString('ReplaceTextHistory', gsReplaceTextHistory);

  finally
    reg.CloseKey;
  end;
end;

procedure ResetGeneralValues(reg : TRegistry);
begin
  {Resets the general values to default}
  Reg_DeleteKey(reg, 'General');
  LoadGeneralValues(reg);
end;

procedure LoadEditorValues(reg : TRegistry);
begin
  {Loads the editor values from the registry}
  Reg_OpenKey(reg, 'Editor');
  try
    ColorCoding         := Reg_ReadBool(reg, 'ColorCoding', true);
    ShowTemplateForm    := Reg_ReadBool(reg, 'ShowTemplateForm', true);
    ShowTemplatePopup   := Reg_ReadBool(reg, 'ShowTemplatePopup', false);
    FontName            := Reg_ReadString(reg, 'FontName', 'Courier New');
    FontSize            := Reg_ReadInteger(reg, 'FontSize', 9);
    AutoIndentCode      := Reg_ReadBool(reg, 'AutoIndentCode', true);
    MacrosOn            := Reg_ReadBool(reg, 'MacrosOn', false);
    HideSelection       := Reg_ReadBool(reg, 'HideSelection', false);
    ScrollPastEOL       := Reg_ReadBool(reg, 'ScrollPastEOL', true);
    HalfPageScroll      := Reg_ReadBool(reg, 'HalfPageScroll', false);
    DragAndDropEditing  := Reg_ReadBool(reg, 'DragDropEdit', true);
    TabWidth            := Reg_ReadInteger(reg, 'TabWidth', 2);
    MaxUndo             := Reg_ReadInteger(reg, 'MaxUndo', 10);
    ExtraLineSpacing    := Reg_ReadInteger(reg, 'ExtraLineSpacing', 0);
    RightEdgePosition   := Reg_ReadInteger(reg, 'RightEdgePosition', 80);
    RightEdgeColor      := Reg_ReadColor(reg, 'RightEdgeColor', clSilver);
    ScrollBars          := Reg_ReadInteger(reg, 'ScrollBars', 0);
    EditorColor         := Reg_ReadColor(reg, 'EditorColor', clWindow);
    SelectionForeground := Reg_ReadColor(reg, 'SelectionFG', clHighlightText);
    SelectionBackground := Reg_ReadColor(reg, 'SelectionBG', clHighlight);
    AltSetsSelMode      := Reg_ReadBool(reg, 'AltSetsSelMode', false);
    MoveCursorRight     := Reg_ReadBool(reg, 'MoveCursorRight', false);
    KeepBlanks          := Reg_ReadBool(reg, 'KeepBlanks', false);
    UseSmartTabs        := Reg_ReadBool(reg, 'UseSmartTabs', true);
    EnhanceHomeKey      := Reg_ReadBool(reg, 'EnhanceHomeKey', false);
    GroupUndo           := Reg_ReadBool(reg, 'GroupUndo', false);
  finally
    reg.CloseKey;
  end;
end;

procedure SaveEditorValues(reg : TRegistry);
begin
  {Saves the editor values to the registry}
  Reg_DeleteKey(reg, 'Editor');
  Reg_OpenKey(reg, 'Editor');
  try
    reg.WriteBool('ColorCoding', ColorCoding);
    reg.WriteBool('ShowTemplateForm', ShowTemplateForm);
    reg.WriteBool('ShowTemplatePopup', ShowTemplatePopup);
    reg.WriteString('FontName', FontName);
    reg.WriteInteger('FontSize', FontSize);
    reg.WriteBool('AutoIndentCode', AutoIndentCode);
    reg.WriteBool('MacrosOn', MacrosOn);
    reg.WriteBool('HideSelection', HideSelection);
    reg.WriteBool('ScrollPastEOL', ScrollPastEOL);
    reg.WriteBool('HalfPageScroll', HalfPageScroll);
    reg.WriteBool('DragDropEdit', DragAndDropEditing);
    reg.WriteInteger('TabWidth', TabWidth);
    reg.WriteInteger('MaxUndo', MaxUndo);
    reg.WriteInteger('ExtraLineSpacing', ExtraLineSpacing);
    reg.WriteInteger('RightEdgePosition', RightEdgePosition);
    Reg_WriteColor(reg, 'RightEdgeColor', RightEdgeColor);
    reg.WriteInteger('ScrollBars', ScrollBars);
    Reg_WriteColor(reg, 'EditorColor', EditorColor);
    Reg_WriteColor(reg, 'SelectionFG', SelectionForeground);
    Reg_WriteColor(reg, 'SelectionBG', SelectionBackground);
    reg.WriteBool('AltSetsSelMode', AltSetsSelMode);
    reg.WriteBool('MoveCursorRight', MoveCursorRight);
    reg.WriteBool('KeepBlanks', KeepBlanks);
    reg.WriteBool('UseSmartTabs', UseSmartTabs);
    reg.WriteBool('EnhanceHomeKey', EnhanceHomeKey);
    reg.WriteBool('GroupUndo', GroupUndo);
  finally
    reg.CloseKey;
  end;
end;

procedure ResetEditorValues(reg : TRegistry);
{Resets the editor values to default}
begin
  Reg_DeleteKey(reg, 'Editor');
  LoadEditorValues(reg);
end;

{ gutter }
procedure LoadGutterValues(reg : TRegistry);
begin
  Reg_OpenKey(reg, 'Gutter');
  try
    GutterColor      := Reg_ReadColor(reg, 'GutterColor', clBtnFace);
    GutterWidth      := Reg_ReadInteger(reg, 'GutterWidth', 30);
    DigitCount       := Reg_ReadInteger(reg, 'DigitCount', 4);
    LeftOffset       := Reg_ReadInteger(reg, 'LeftOffset', 16);
    RightOffset      := Reg_ReadInteger(reg, 'RightOffset', 2);
    ShowLineNumbers  := Reg_ReadBool(reg, 'ShowLineNumbers', false);
    ShowLeadingZeros := Reg_ReadBool(reg, 'ShowLeadingZeros', false);
    ZeroStart        := Reg_ReadBool(reg, 'ZeroStart', false);
    AutoSizeGutter   := Reg_ReadBool(reg, 'AutoSizeGutter', false);
    GutterVisible    := Reg_ReadBool(reg, 'GutterVisible', true);
    UseFontStyle     := Reg_ReadBool(reg, 'UseFontStyle', false);
  finally
    reg.CloseKey;
  end;
end;

procedure SaveGutterValues(reg : TRegistry);
begin
  Reg_DeleteKey(reg, 'Gutter');
  Reg_OpenKey(reg, 'Gutter');
  try
    Reg_WriteColor(reg, 'GutterColor', GutterColor);
    reg.WriteInteger('GutterWidth', GutterWidth);
    reg.WriteInteger('DigitCount', DigitCount);
    reg.WriteInteger('LeftOffset', LeftOffset);
    reg.WriteInteger('RightOffset', RightOffset);
    reg.WriteBool('ShowLineNumbers', ShowLineNumbers);
    reg.WriteBool('ShowLeadingZeros', ShowLeadingZeros);
    reg.WriteBool('ZeroStart', ZeroStart);
    reg.WriteBool('AutoSizeGutter', AutoSizeGutter);
    reg.WriteBool('GutterVisible', GutterVisible);
    reg.WriteBool('UseFontStyle', UseFontStyle);
  finally
    reg.CloseKey;
  end;
end;

procedure ResetGutterValues(reg : TRegistry);
begin
  Reg_DeleteKey(reg, 'Gutter');
  LoadGutterValues(reg);
end;

{ keystrokes }
procedure LoadKeystrokeValues(reg : TRegistry; k : TSynEditKeyStrokes);
var
  tmpStream : TMemoryStream;
  bufSize : integer;
  buffer : PChar;
begin
  if not Reg_KeyExists(reg, 'Keystrokes') then
  begin
    k.ResetDefaults;
  end
  else
  begin
    Reg_OpenKey(reg, 'Keystrokes');
    try
      bufSize := Reg_ReadInteger(reg, 'ValueSize', 0);
      if bufSize > 0 then
      begin
        GetMem(buffer, bufSize);
        try
          reg.ReadBinaryData('Values', buffer^, bufSize);
          tmpStream := TMemoryStream.Create;
          try
            tmpStream.Write(buffer^, bufSize);
            tmpStream.Position := 0;
            k.LoadFromStream(tmpStream);
          finally
            tmpStream.Free;
          end;
        finally
          FreeMem(buffer, bufSize);
        end;
      end;
    finally
      reg.CloseKey;
    end;
  end;
  if Assigned(PrefForm) then
    PrefForm.SynEdit1.Keystrokes.Assign(k);
end;

procedure SaveKeystrokeValues(reg : TRegistry; k : TSynEditKeyStrokes);
var
  tmpStream : TMemoryStream;
begin
  Reg_DeleteKey(reg, 'Keystrokes');
  Reg_OpenKey(reg, 'Keystrokes');
  try
    tmpStream := TMemoryStream.Create;
    try
      k.SaveToStream(tmpStream);
      tmpStream.Position := 0;
      reg.WriteInteger('ValueSize', tmpStream.Size);
      reg.WriteBinaryData('Values', tmpStream.Memory^, tmpStream.Size);
    finally
      tmpStream.Free;
    end;
  finally
    reg.CloseKey;
  end;
end;

procedure ResetKeystrokeValues(reg : TRegistry);
begin
  Reg_DeleteKey(reg, 'Keystrokes');
  if Assigned(PrefForm.Keystrokes) then
    LoadKeystrokeValues(reg, PrefForm.Keystrokes);
end;

{ code templates }

procedure LoadCodeTemplateValues(reg : TRegistry; S : TStrings);
var
  tmpSL : TStringList;
begin
  tmpSL := TStringList.Create;
  try
    if not Reg_KeyExists(reg, 'CodeTemplates') then
    begin
      if FileExists(ProgramDir + 'Default\code.dci') then
        tmpSL.LoadFromFile(ProgramDir + 'Default\code.dci');
    end
    else
    begin
      Reg_OpenKey(reg, 'CodeTemplates');
      try
        tmpSL.Text := Reg_ReadString(reg, 'Data', '');
      finally
        reg.CloseKey;
      end;
    end;
    S.Assign(tmpSL);
  finally
    tmpSL.Free;
  end;
end;

procedure SaveCodeTemplateValues(reg : TRegistry; S : TStrings);
begin
  Reg_DeleteKey(reg, 'CodeTemplates');
  Reg_OpenKey(reg, 'CodeTemplates');
  try
    reg.WriteString('Data',S.Text);
  finally
    reg.CloseKey;
  end;
end;

procedure ResetCodeTemplateValues(reg : TRegistry; S : TStrings);
begin
  Reg_DeleteKey(reg, 'CodeTemplates');
  LoadCodeTemplateValues(reg, S);
end;

procedure LoadPageSetupValues(reg : TRegistry);
var
  tmpStream : TMemoryStream;
  bufSize : integer;
  buffer : PChar;
begin
  Reg_OpenKey(reg, 'PageSetup');
  try
    bufSize := Reg_ReadInteger(reg, 'ValueSize', 0);
    if bufSize > 0 then
    begin
      GetMem(buffer, bufSize);
      try
        reg.ReadBinaryData('Values', buffer^, bufSize);
        tmpStream := TMemoryStream.Create;
        try
          tmpStream.Write(buffer^, bufSize);
          tmpStream.Position := 0;
          MainForm.SynEditPrint.LoadFromStream(tmpStream);
        finally
          tmpStream.Free;
        end;
      finally
        FreeMem(buffer, bufSize);
      end;
    end;
  finally
    reg.CloseKey;
  end;
end;

procedure SavePageSetupValues(reg : TRegistry);
var
  tmpStream : TMemoryStream;
begin
  Reg_DeleteKey(reg, 'PageSetup');
  Reg_OpenKey(reg, 'PageSetup');
  try
    tmpStream := TMemoryStream.Create;
    try
      MainForm.SynEditPrint.SaveToStream(tmpStream);
      tmpStream.Position := 0;
      reg.WriteInteger('ValueSize', tmpStream.Size);
      reg.WriteBinaryData('Values', tmpStream.Memory^, tmpStream.Size);
    finally
      tmpStream.Free;
    end;
  finally
    reg.CloseKey;
  end;
end;

procedure ResetPageSetupValues(reg : TRegistry);
begin
  Reg_DeleteKey(reg, 'PageSetup');
  LoadPageSetupValues(reg);
end;

procedure LoadWatchValues(reg : TRegistry);
begin
  Reg_OpenKey(reg, 'WatchValues');
  try
    WatchForm.chkIfActive.Checked := Reg_ReadBool(reg, 'OnlyIfActive', False);
  finally
    reg.CloseKey;
  end;
end;

procedure SaveWatchValues(reg : TRegistry);
begin
  Reg_DeleteKey(reg, 'WatchValues');
  Reg_OpenKey(reg, 'WatchValues');
  try
    reg.WriteBool('OnlyIfActive', WatchForm.chkIfActive.Checked);
  finally
    reg.CloseKey;
  end;
end;

procedure ResetWatchValues(reg : TRegistry);
begin
  Reg_DeleteKey(reg, 'WatchValues');
  LoadWatchValues(reg);
end;

{ Transfer }
procedure LoadTransferValues(reg : TRegistry);
var
  i, cnt : integer;
  T : TTransferItem;
begin
  Reg_OpenKey(reg, 'Transfer');
  try
    // load transfer items from registry
    cnt := Reg_ReadInteger(reg, 'Count', 0);
    for i := 0 to cnt - 1 do
    begin
      T := TTransferItem.Create;
      try
        TransferList.Add(T);
        T.Title := Reg_ReadString(reg, 'Title' + IntToStr(i), '');
        T.Path := Reg_ReadString(reg, 'Path' + IntToStr(i), '');
        T.WorkingDir := Reg_ReadString(reg, 'WorkingDir' + IntToStr(i), '');
        T.Params := Reg_ReadString(reg, 'Params' + IntToStr(i), '');
      except
        T.Free;
      end;
    end;
  finally
    reg.CloseKey;
  end;
end;

procedure SaveTransferValues(reg : TRegistry);
var
  i : integer;
  T : TTransferItem;
begin
  Reg_DeleteKey(reg, 'Transfer');
  Reg_OpenKey(reg, 'Transfer');
  try
    // save transfer items to registry
    reg.WriteInteger('Count', TransferList.Count);
    for i := 0 to TransferList.Count - 1 do
    begin
      T := TTransferItem(TransferList[i]);
      reg.WriteString('Title' + IntToStr(i), T.Title);
      reg.WriteString('Path' + IntToStr(i), T.Path);
      reg.WriteString('WorkingDir' + IntToStr(i), T.WorkingDir);
      reg.WriteString('Params' + IntToStr(i), T.Params);
    end;
  finally
    reg.CloseKey;
  end;
end;

procedure ResetTransferValues(reg : TRegistry);
begin
  Reg_DeleteKey(reg, 'Transfer');
  LoadTransferValues(reg);
end;

{ Code Explorer }
procedure LoadExplorerValues(reg : TRegistry);
begin
  Reg_OpenKey(reg, 'Code Explorer');
  try
    // load code explorer settings from registry
    CodeExplorerSettings.CategorySort := Reg_ReadString(reg, 'CategorySort', '');
    CodeExplorerSettings.AutoShowExplorer := Reg_ReadBool(reg, 'Show Mod Exp', True);
    CodeExplorerSettings.DeclarationSyntax := Reg_ReadBool(reg, 'DeclarationSyntax', False);
    CodeExplorerSettings.UseAlphaSort := Reg_ReadBool(reg, 'UseAlphaSort', True);
    CodeExplorerSettings.FunctionsVisible := Reg_ReadBool(reg, 'FunctionsVisible', True);
    CodeExplorerSettings.FunctionsExpand := Reg_ReadBool(reg, 'FunctionsExpand', False);
    CodeExplorerSettings.SubroutinesVisible := Reg_ReadBool(reg, 'SubroutinesVisible', True);
    CodeExplorerSettings.SubroutinesExpand := Reg_ReadBool(reg, 'SubroutinesExpand', False);
    CodeExplorerSettings.TasksVisible := Reg_ReadBool(reg, 'TasksVisible', True);
    CodeExplorerSettings.TasksExpand := Reg_ReadBool(reg, 'TasksExpand', False);
  finally
    reg.CloseKey;
  end;
end;

procedure SaveExplorerValues(reg : TRegistry);
begin
  Reg_DeleteKey(reg, 'Code Explorer');
  Reg_OpenKey(reg, 'Code Explorer');
  try
    reg.WriteString('CategorySort', CodeExplorerSettings.CategorySort);
    reg.WriteBool('Show Mod Exp', CodeExplorerSettings.AutoShowExplorer);
    reg.WriteBool('DeclarationSyntax', CodeExplorerSettings.DeclarationSyntax);
    reg.WriteBool('UseAlphaSort', CodeExplorerSettings.UseAlphaSort);
    reg.WriteBool('FunctionsVisible', CodeExplorerSettings.FunctionsVisible);
    reg.WriteBool('FunctionsExpand', CodeExplorerSettings.FunctionsExpand);
    reg.WriteBool('SubroutinesVisible', CodeExplorerSettings.SubroutinesVisible);
    reg.WriteBool('SubroutinesExpand', CodeExplorerSettings.SubroutinesExpand);
    reg.WriteBool('TasksVisible', CodeExplorerSettings.TasksVisible);
    reg.WriteBool('TasksExpand', CodeExplorerSettings.TasksExpand);
  finally
    reg.CloseKey;
  end;
end;

procedure ResetExplorerValues(reg : TRegistry);
begin
  Reg_DeleteKey(reg, 'Code Explorer');
  LoadExplorerValues(reg);
end;

{ all }
procedure LoadAllValues(reg : TRegistry; k : TSynEditKeyStrokes; S : TStrings);
begin
  LoadGeneralValues(reg);
  LoadEditorValues(reg);
  LoadStartupValues(reg);
  LoadColorValues(reg);
  LoadJoystickValues(reg);
  LoadRecentValues(reg);
  LoadWindowsValues(reg);
  LoadAPIValues(reg);
  LoadTemplateValues(reg);
  LoadMacroValues(reg);
  LoadGutterValues(reg);
  LoadKeystrokeValues(reg, k);
  LoadPageSetupValues(reg);
  LoadCodeTemplateValues(reg, S);
  LoadWatchValues(reg);
  LoadTransferValues(reg);
  LoadExplorerValues(reg);
end;

procedure SaveAllValues(reg : TRegistry; k : TSynEditKeyStrokes; S : TStrings);
begin
  SaveGeneralValues(reg);
  SaveEditorValues(reg);
  SaveStartupValues(reg);
  SaveColorValues(reg);
  SaveJoystickValues(reg);
  SaveRecentValues(reg);
  SaveWindowsValues(reg);
  SaveAPIValues(reg);
  SaveTemplateValues(reg);
  SaveMacroValues(reg);
  SaveGutterValues(reg);
  SaveKeystrokeValues(reg, k);
  SavePageSetupValues(reg);
  SaveCodeTemplateValues(reg, S);
  SaveWatchValues(reg);
  SaveTransferValues(reg);
  SaveExplorerValues(reg);
end;

procedure ResetAllValues(reg : TRegistry; S : TStrings);
begin
  ResetGeneralValues(reg);
  ResetEditorValues(reg);
  ResetStartupValues(reg);
  ResetColorValues(reg);
  ResetJoystickValues(reg);
  ResetRecentValues(reg);
  ResetWindowsValues(reg);
  ResetAPIValues(reg);
  ResetTemplateValues(reg);
  ResetMacroValues(reg);
  ResetGutterValues(reg);
  ResetKeystrokeValues(reg);
  ResetPageSetupValues(reg);
  ResetCodeTemplateValues(reg, S);
  ResetWatchValues(reg);
  ResetTransferValues(reg);
  ResetExplorerValues(reg);
end;


procedure UpgradeRegistry;
const
  K_MINVER = 3.2;
var
  R : TRegistry;
  mkStr, vStr, sVer : string;
  K : TSynEditKeyStrokes;
  S : TStringList;
  dVer : Double;
  bLoaded : boolean;
begin
  try
    dVer := StrToFloat(fVersion);
  except
    dVer := K_MINVER;
  end;
  R := TRegistry.Create;
  try
    bLoaded := False;
    // if our key doesn't exist then
    if not R.OpenKey(fMainKey+'\'+fVersion, false) then begin
      // store old values of fMainKey & fVersion
      K := TSynEditKeyStrokes.Create(nil);
      try
        S := TStringList.Create;
        try
          mkStr := fMainKey;
          vStr  := fVersion;
          try
            while dVer > (K_MINVER - 0.1) do begin
              sVer := FloatToStr(dVer);
              if R.OpenKey(K_MAINKEY+'\version ' + sVer, false) then begin
                fMainKey := K_MAINKEY;
                fVersion := 'version ' + sVer;
                // load values from old version
                LoadAllValues(R, K, S);
                bLoaded := True;
              end
              else if R.OpenKey(K_MAINKEY+'\'+sVer, false) then begin
                fMainKey := K_MAINKEY;
                fVersion := sVer;
                // load values from old version
                LoadAllValues(R, K, S);
                bLoaded := True;
              end;
              dVer := dVer - 0.1;
            end;
            if not bLoaded and R.OpenKey(K_OLDMAINKEY+'\'+K_OLDVERSION, false) then begin
              fMainKey := K_OLDMAINKEY;
              fVersion := K_OLDVERSION;
              // load values from old version
              LoadAllValues(R, K, S);
              bLoaded := True;
            end;
          finally
            fMainKey := mkStr;
            fVersion := vStr;
          end;
          // save values to new key
          if bLoaded then
            SaveAllValues(R, K, S);
        finally
          S.Free;
        end;
      finally
        K.Free;
      end;
    end;
  finally
    R.Free;
  end;
end;

procedure ClaimNQCExtension;
var
  R : TRegistry;
begin
  // claim .nqc extension
  R := TRegistry.Create;
  try
    R.RootKey := HKEY_CLASSES_ROOT;
    if R.OpenKey('.nqc', true) then begin
      R.WriteString('', K_PID);
      // create ShellNew subkey
      if R.OpenKey('ShellNew', true) then begin
        // do nothing
      end;
      R.CloseKey;
      if R.OpenKey('.nqc\' + K_PID + '\ShellNew', true) then begin
        R.WriteString('FileName', 'New NQC Document.nqc');
      end;
      R.CloseKey;
      if R.OpenKey(K_PID, true) then begin
        R.WriteString('', 'Not Quite C Document');
        // default icon
        if R.OpenKey('DefaultIcon', true) then begin
          R.WriteString('', '"' + ParamStr(0) + '",0');
        end;
      end;
      R.CloseKey;
      if R.OpenKey(K_PID + '\shell\New', true) then begin
        // shell New
        R.WriteString('', '&New');
        if R.OpenKey('command', true) then begin
          R.WriteString('', '"' + ParamStr(0) + '" "/New"');
        end;
      end;
      R.CloseKey;
      if R.OpenKey(K_PID + '\shell\Open', true) then begin
        // shell Open
        R.WriteString('', '&Open');
        if R.OpenKey('command', true) then begin
          R.WriteString('', '"' + ParamStr(0) + '" "/NOCONNECT" "%1"');
        end;
      end;
      R.CloseKey;
      if R.OpenKey(K_PID + '\shell\Print', true) then begin
        // shell Print
        R.WriteString('', '&Print');
        if R.OpenKey('command', true) then begin
          R.WriteString('', '"' + ParamStr(0) + '" "/Print" "%1"');
        end;
      end;
      R.CloseKey;
      if R.OpenKey(K_PID + '\shell\printto\command', true) then begin
        // shell PrintTo
        R.WriteString('', '"' + ParamStr(0) + '" "/Print" "%1"');
      end;
    end;
  finally
    R.Free;
  end;
end;

procedure RegisterApp;
var
  R : TRegistry;
  V : TVersionInfo;
  S : string;
begin
  R := TRegistry.Create;
  try
    V := GetVersionInfo(Application.ExeName);
    S := ExtractFileName(Application.ExeName);
    // register NoOpenWith
    R.RootKey := HKEY_CLASSES_ROOT;
    if R.OpenKey('Applications\' + S, true) then begin
      R.WriteString('NoOpenWith', '');
    end;
    R.CloseKey;
    // claim NQC extension if it isn't registered already
    if not R.OpenKey('.nqc', false) then begin
      ClaimNQCExtension;
    end;
    R.CloseKey;
    // register product version under HKLM\Software\BricxCC
    R.RootKey := HKEY_LOCAL_MACHINE;
    R.OpenKey(K_MAINKEY + '\' + V.ProductVersion, true);
    R.CloseKey;
    // register app paths
    if R.OpenKey('Software\Microsoft\Windows\CurrentVersion\App Paths', false) then begin
      if R.OpenKey(S, true) then begin
        R.WriteString('', Application.ExeName);
        R.WriteString('Path', ExtractFilePath(Application.ExeName));
      end;
    end;
    R.CloseKey;
  finally
    R.Free;
  end;
end;

{********************************************
 Handling the preferences form
 ********************************************}

var OldShowRecent:boolean;   // For saving the old version

procedure RememberGeneralValues;
begin
{Remember current settings such that we know whether changed}
  OldShowRecent := ShowRecent;
end;

procedure GetGeneralValues;
begin
{Gets the values from the form}
  ShowRecent         := PrefForm.CheckShowRecent.Checked;
  ShowRecentChanged  := (ShowRecent <> OldShowRecent);
  SaveWindowPos      := PrefForm.CheckSavePos.Checked;
  SaveBackup         := PrefForm.CheckSaveBackup.Checked;
  CompatibilityMode  := PrefForm.CheckCompatibility.Checked;
  ShowCompilerStatus := PrefForm.chkShowCompileStatus.Checked;
  AutoSaveFiles      := PrefForm.chkAutoSave.Checked;
  AutoSaveDesktop    := PrefForm.chkSaveDesktop.Checked;
  SaveBinaryOutput   := PrefForm.chkSaveBinaryOutput.Checked;
  IncludeSrcInList   := PrefForm.chkIncludeSrcInList.Checked;
  FirmwareFast       := PrefForm.chkFirmfast.Checked;
  NQCTimeout         := PrefForm.edtNQCTimeout.Value * K_MSTOSEC;
  LocalNQCTimeout    := NQCTimeout;
  NQCSwitches        := PrefForm.edtNQCSwitches.Text;
  Prog1Locked        := PrefForm.cbProg1.Checked;
  Prog2Locked        := PrefForm.cbProg2.Checked;
  Prog3Locked        := PrefForm.cbProg3.Checked;
  Prog4Locked        := PrefForm.cbProg4.Checked;
  Prog5Locked        := PrefForm.cbProg5.Checked;
end;

procedure DisplayGeneralValues;
begin
{Displays the values in the form}
  PrefForm.CheckShowRecent.Checked      := ShowRecent;
  PrefForm.CheckSavePos.Checked         := SaveWindowPos;
  PrefForm.CheckSaveBackup.Checked      := SaveBackup;
  PrefForm.CheckCompatibility.Checked   := CompatibilityMode;
  PrefForm.chkShowCompileStatus.Checked := ShowCompilerStatus;
  PrefForm.chkAutoSave.Checked          := AutoSaveFiles;
  PrefForm.chkSaveDesktop.Checked       := AutoSaveDesktop;
  PrefForm.chkSaveBinaryOutput.Checked  := SaveBinaryOutput;
  PrefForm.chkIncludeSrcInList.Checked  := IncludeSrcInList;
  PrefForm.chkFirmfast.Checked          := FirmwareFast;
  PrefForm.edtNQCTimeout.Value          := NQCTimeout div K_MSTOSEC;
  PrefForm.edtNQCSwitches.Text          := NQCSwitches;
  PrefForm.cbProg1.Checked              := Prog1Locked;
  PrefForm.cbProg2.Checked              := Prog2Locked;
  PrefForm.cbProg3.Checked              := Prog3Locked;
  PrefForm.cbProg4.Checked              := Prog4Locked;
  PrefForm.cbProg5.Checked              := Prog5Locked;
end;

{The Editor Information}

var OldColorCoding:boolean;  // For saving the old version
    OldFontName:string;
    OldFontSize:integer;

procedure RememberEditorValues;
begin
{Remember current settings such that we know whether changed}
  OldColorCoding := ColorCoding;
  OldFontName := FontName;
  OldFontSize := FontSize;
end;

procedure GetEditorValues;
begin
  {Gets the values from the form}
  ColorsChanged       := PrefForm.ColorsChanged;
  ColorCoding         := PrefForm.CheckColorCoding.Checked;
  ColorCodingChanged  := (ColorCoding <> OldColorCoding);
  ShowTemplatePopup   := PrefForm.CheckShowTemplates.Checked;
  FontChanged         := (FontName <> OldFontName) or (FontSize <> OldFontSize);
  AutoIndentCode      := PrefForm.CheckAutoIndentCode.Checked;
  MacrosOn            := PrefForm.CheckMacrosOn.Checked;
  HideSelection       := PrefForm.cbHideSelection.Checked;
  ScrollPastEOL       := PrefForm.cbScrollPastEOL.Checked;
  HalfPageScroll      := PrefForm.cbHalfPageScroll.Checked;
  DragAndDropEditing  := PrefForm.chkDragDrop.Checked;
  TabWidth            := PrefForm.inpTabWidth.Value;
  MaxUndo             := PrefForm.inpMaxUndo.Value;
  ExtraLineSpacing    := PrefForm.inpExtraLineSpacing.Value;
  ScrollBars          := PrefForm.cbxScrollBars.ItemIndex;
  RightEdgePosition   := PrefForm.inpRightEdge.Value;
  RightEdgeColor      := StringToColor(PrefForm.cbxREColor.Text);
  EditorColor         := StringToColor(PrefForm.cbxColor.Text);
  SelectionForeground := StringToColor(PrefForm.cbxForeground.Text);
  SelectionBackground := StringToColor(PrefForm.cbxBackground.Text);
  AltSetsSelMode      := PrefForm.chkAltSelMode.Checked;
  MoveCursorRight     := PrefForm.chkMoveRight.Checked;
  KeepBlanks          := PrefForm.chkKeepBlanks.Checked;
  UseSmartTabs        := PrefForm.chkSmartTab.Checked;
  EnhanceHomeKey      := PrefForm.chkEnhHomeKey.Checked;
  GroupUndo           := PrefForm.chkGroupUndo.Checked;
end;

procedure DisplayEditorValues;
begin
  {Displays the values in the form}
  PrefForm.CheckColorCoding.Checked    := ColorCoding;
  PrefForm.CheckShowTemplates.Checked  := ShowTemplatePopup;
  PrefForm.CheckAutoIndentCode.Checked := AutoIndentCode;
  PrefForm.CheckMacrosOn.Checked       := MacrosOn;
  PrefForm.cbHideSelection.Checked     := HideSelection;
  PrefForm.cbScrollPastEOL.Checked     := ScrollPastEOL;
  PrefForm.cbHalfPageScroll.Checked    := HalfPageScroll;
  PrefForm.chkDragDrop.Checked         := DragAndDropEditing;
  PrefForm.inpTabWidth.Value           := TabWidth;
  PrefForm.inpMaxUndo.Value            := MaxUndo;
  PrefForm.inpExtraLineSpacing.Value   := ExtraLineSpacing;
  PrefForm.cbxScrollBars.ItemIndex     := ScrollBars;
  PrefForm.inpRightEdge.Value          := RightEdgePosition;
  PrefForm.cbxREColor.ItemIndex        := PrefForm.cbxREColor.Items.IndexOf(ColorToString(RightEdgeColor));
  PrefForm.cbxColor.ItemIndex          := PrefForm.cbxColor.Items.IndexOf(ColorToString(EditorColor));
  PrefForm.cbxForeground.ItemIndex     := PrefForm.cbxForeground.Items.IndexOf(ColorToString(SelectionForeground));
  PrefForm.cbxBackground.ItemIndex     := PrefForm.cbxBackground.Items.IndexOf(ColorToString(SelectionBackground));
  PrefForm.chkAltSelMode.Checked       := AltSetsSelMode;
  PrefForm.chkMoveRight.Checked        := MoveCursorRight;
  PrefForm.chkKeepBlanks.Checked       := KeepBlanks;
  PrefForm.chkSmartTab.Checked         := UseSmartTabs;
  PrefForm.chkEnhHomeKey.Checked       := EnhanceHomeKey;
  PrefForm.chkGroupUndo.Checked        := GroupUndo;
end;

{ The API information }

procedure DisplayAPIValues;
var
  i : Integer;
begin
  if not Assigned(PrefForm) then Exit;
  PrefForm.edtKeyword.Text := '';
  PrefForm.edtCommand.Text := '';
  PrefForm.edtConstant.Text := '';
  PrefForm.lstKeywords.Items.Clear;
  PrefForm.lstCommands.Items.Clear;
  PrefForm.lstConstants.Items.Clear;

  for i := 1 to cc_keynumb do begin
    PrefForm.lstKeywords.Items.Add(cc_keywords[i]);
  end;
  for i := 1 to cc_commandnumb do begin
    PrefForm.lstCommands.Items.Add(cc_commands[i]);
  end;
  for i := 1 to cc_constantnumb do begin
    PrefForm.lstConstants.Items.Add(cc_constants[i]);
  end;
end;

procedure RememberAPIValues;
begin
end;

procedure GetAPIValues;
var
  i : Integer;
begin
  if not Assigned(PrefForm) then Exit;
  cc_keynumb      := PrefForm.lstKeywords.Items.Count;
  cc_commandnumb  := PrefForm.lstCommands.Items.Count;
  cc_constantnumb := PrefForm.lstConstants.Items.Count;
  for i := 1 to cc_keynumb do begin
    cc_keywords[i] := PrefForm.lstKeywords.Items[i-1];
  end;
  for i := 1 to cc_commandnumb do begin
    cc_commands[i] := PrefForm.lstCommands.Items[i-1];
  end;
  for i := 1 to cc_constantnumb do begin
    cc_constants[i] := PrefForm.lstConstants.Items[i-1];
  end;
  PutValuesInSyntaxHighlighter;
end;

{The Gutter Information}

procedure RememberGutterValues;
begin
end;

procedure GetGutterValues;
begin
  PrefForm.UpdateGlobalGutterValues;
end;

procedure DisplayGutterValues;
begin
  PrefForm.DisplayGutterValues;
end;

{The keystroke Information}

procedure RememberKeystrokeValues;
begin
end;

procedure GetKeystrokeValues;
begin
  PrefForm.UpdateGlobalKeystrokeValues;
end;

procedure DisplayKeystrokeValues;
begin
  PrefForm.DisplayKeystrokeValues;
end;

procedure DisplayCodeTemplateValues;
begin
  PrefForm.DisplayCodeTemplateValues;
end;

{ The Startup Information}

procedure RememberStartupValues;
begin
  {Remember current settings such that we know whether changed}
  {Nothing to be done yet}
end;

procedure GetStartupValues;
var
  i : integer;
  RB : TRadioButton;
begin
  {Gets the values from the form}
  if PrefForm.CheckShowForm.Checked then StartupAction := SU_SHOWFORM;
  if PrefForm.CheckConnect.Checked then StartupAction := SU_CONNECT;
  if PrefForm.CheckNoConnect.Checked then StartupAction := SU_NOCONNECT;

  if PrefForm.CheckMindStorms.Checked then RCXType := SU_RCX;
  if PrefForm.CheckCyberMaster.Checked then RCXType := SU_CYBERMASTER;
  if PrefForm.CheckScout.Checked then RCXType := SU_SCOUT;
  if PrefForm.CheckRCX2.Checked then RCXType := SU_RCX2;

  for i := 0 to PrefForm.pnlPorts.ControlCount - 1 do
  begin
    if PrefForm.pnlPorts.Controls[i] is TRadioButton then
    begin
      RB := TRadioButton(PrefForm.pnlPorts.Controls[i]);
      if RB.Checked then
      begin
        COMPort := RB.Tag;
        break;
      end;
    end;
  end;
  FBAlwaysPrompt := PrefForm.chkFBAlwaysPrompt.Checked;
end;

procedure GroupEnable(aCtrl : TWinControl; bEnable : boolean);
var
  i : integer;
  tmpCtrl : TControl;
begin
  for i := 0 to aCtrl.ControlCount - 1 do
  begin
    tmpCtrl := aCtrl.Controls[i];
    if tmpCtrl is TWinControl then
      GroupEnable(TWinControl(tmpCtrl), bEnable);
    tmpCtrl.Enabled := bEnable;
  end;
  aCtrl.Enabled := bEnable;
end;

procedure DisplayStartupValues;
var
  i : integer;
  RB : TRadioButton;
begin
  {Display the values in the form}
  PrefForm.CheckShowForm.Checked := (StartupAction = SU_SHOWFORM);
  PrefForm.CheckConnect.Checked := (StartupAction = SU_CONNECT);
  PrefForm.CheckNoConnect.Checked := (StartupAction = SU_NOCONNECT);

//  GroupEnable(PrefForm.ComBox, PrefForm.CheckConnect.Checked);

  PrefForm.CheckMindStorms.Checked := (RCXType = SU_RCX);
  PrefForm.CheckCyberMaster.Checked := (RCXType = SU_CYBERMASTER);
  PrefForm.CheckScout.Checked := (RCXType = SU_SCOUT);
  PrefForm.CheckRCX2.Checked := (RCXType = SU_RCX2);

  for i := 0 to PrefForm.pnlPorts.ControlCount - 1 do
  begin
    if PrefForm.pnlPorts.Controls[i] is TRadioButton then
    begin
      RB := TRadioButton(PrefForm.pnlPorts.Controls[i]);
      RB.Checked := (RB.Tag = COMPort);
    end;
  end;
  PrefForm.chkFBAlwaysPrompt.Checked := FBAlwaysPrompt;
end;

{The Templates Information}

procedure RememberTemplateValues;
begin
{Remember current settings such that we know whether changed}
  // Nothing to be done
end;

procedure GetTemplateValues;
var
  i : integer;
begin
  {Gets the values from the form}
  TemplatesChanged := false;
  for i:=0 to PrefForm.TemplatesList.Items.Count-1 do
  begin
    if PrefForm.TemplatesList.Items[i] <> templates[i+1] then
    begin
      TemplatesChanged := true;
      templates[i+1] := PrefForm.TemplatesList.Items[i];
    end
  end;
  templatenumb := PrefForm.TemplatesList.Items.Count;
end;

procedure DisplayTemplateValues;
var
  i : integer;
begin
  {Displays the values in the form}
  PrefForm.TemplatesList.Items.Clear;
  for i:= 1 to templatenumb do
    PrefForm.TemplatesList.Items.Add(templates[i]);
  PrefForm.TemplatesList.ItemIndex:=0;
end;

{The Macros Information}

procedure RememberMacroValues;
begin
{Remember current settings such that we know whether changed}
  // Nothing to be done
end;

procedure GetMacroValues;
var
  i : integer;
  str : string;
begin
  {Gets the values from the form}
  MacrosChanged := false;
  macronumb:=0;
  for i:=0 to PrefForm.MacrosList.Items.Count-1 do
  begin
    str:='<Ctrl><Alt>';
    str:=str+ PrefForm.MacrosList.Items[i][1]+':';
    str:=str+Copy(PrefForm.MacrosList.Items[i],4,1000);
    if (Length(str)>13) then
    begin
      macronumb:=macronumb+1;
      if (str <> macros[macronumb]) then MacrosChanged := true;
      macros[macronumb] := str;
    end
  end;
  for i:=0 to PrefForm.ShiftMacrosList.Items.Count-1 do
  begin
    str:='<Ctrl><Alt><Shift>';
    str:=str+ PrefForm.ShiftMacrosList.Items[i][1]+':';
    str:=str+Copy(PrefForm.ShiftMacrosList.Items[i],4,1000);
    if (Length(str)>20) then
    begin
      macronumb:=macronumb+1;
      if (str <> macros[macronumb]) then MacrosChanged := true;
      macros[macronumb] := str;
    end
  end;
end;

procedure DisplayMacroValues;
var
  i, numb : integer;
begin
  {Displays the values in the form}
  PrefForm.MacrosList.Items.Clear;
  PrefForm.ShiftMacrosList.Items.Clear;
  for i:=1 to 26 do PrefForm.MacrosList.Items.Add(Chr(Ord('A')+i-1)+': ');
  for i:=1 to 10 do PrefForm.MacrosList.Items.Add(Chr(Ord('0')+i-1)+': ');
  for i:=1 to 26 do PrefForm.ShiftMacrosList.Items.Add(Chr(Ord('A')+i-1)+': ');
  for i:=1 to 10 do PrefForm.ShiftMacrosList.Items.Add(Chr(Ord('0')+i-1)+': ');
  for i:= 1 to macronumb do
  begin
    if Pos('<Shift>',macros[i]) = 12 then
    begin
      numb:=Ord(macros[i][19])-Ord('A');
      if (numb<0) or (numb>25) then numb:=Ord(macros[i][19])-Ord('0')+26;
      PrefForm.ShiftMacrosList.Items[numb] := macros[i][19]+': '+ Copy(macros[i],21,1000);
    end else begin
      numb:=Ord(macros[i][12])-Ord('A');
      if (numb<0) or (numb>25) then numb:=Ord(macros[i][12])-Ord('0')+26;
      PrefForm.MacrosList.Items[numb] := macros[i][12]+': '+ Copy(macros[i],14,1000);
    end;
  end;
  PrefForm.MacrosList.ItemIndex:=0;
  PrefForm.ShiftMacrosList.ItemIndex:=0;
  PrefForm.MacrosList.Visible:=true;
  PrefForm.ShiftMacrosList.Visible:=false;
  PrefForm.MShift.Down := false;
end;

{ TTransferItem }

procedure TTransferItem.Assign(TI: TTransferItem);
begin
  Title := TI.Title;
  Path := TI.Path;
  WorkingDir := TI.WorkingDir;
  Params := TI.Params;
end;

{ TPrefForm }

procedure TPrefForm.CheckConnectClick(Sender: TObject);
begin
//  GroupEnable(ComBox, CheckConnect.Checked);
end;

procedure TPrefForm.btnDefaultClick(Sender: TObject);
begin
  if pagPrefs.ActivePage = shtGeneral then
  begin
    ResetGeneralValues(fReg);
    DisplayGeneralValues;
  end
  else if pagPrefs.ActivePage = shtEditor then
  begin
    ResetEditorValues(fReg);
    DisplayEditorValues;
  end
  else if pagPrefs.ActivePage = shtAPI then
  begin
    ResetAPIValues(fReg);
    DisplayAPIValues;
  end
  else if pagPrefs.ActivePage = shtStartup then
  begin
    ResetStartupValues(fReg);
    DisplayStartupValues;
  end
  else if pagPrefs.ActivePage = shtTemplates then
  begin
    ResetTemplateValues(fReg);
    DisplayTemplateValues;
  end
  else if pagPrefs.ActivePage = shtMacros then
  begin
    ResetMacroValues(fReg);
    DisplayMacroValues;
  end
  else if pagPrefs.ActivePage = shtColors then
  begin
    ResetColorValues(fReg);
    DisplayColorValues;
  end
  else if pagPrefs.ActivePage = shtOptions then
  begin
    ResetGutterValues(fReg);
    DisplayGutterValues;
    ResetKeystrokeValues(fReg);
    DisplayKeystrokeValues;
    ResetCodeTemplateValues(fReg, CodeTemplates);
    DisplayCodeTemplateValues;
  end;
end;

procedure TPrefForm.btnFontClick(Sender: TObject);
begin
  dlgFont.Font.Name := FontName;
  dlgFont.Font.Size := FontSize;
  if dlgFont.Execute then
  begin
    FontName := dlgFont.Font.Name;
    FontSize := dlgFont.Font.Size;
  end;
end;

procedure TPrefForm.UpBtnClick(Sender: TObject);
begin
  if PrefForm.TemplatesList.ItemIndex <= 0 then Exit;
  PrefForm.TemplatesList.Items.Exchange(
      PrefForm.TemplatesList.ItemIndex-1,
      PrefForm.TemplatesList.ItemIndex);
  PrefForm.TemplatesList.ItemIndex:=PrefForm.TemplatesList.ItemIndex-1;
end;

procedure TPrefForm.DownBtnClick(Sender: TObject);
begin
  if PrefForm.TemplatesList.ItemIndex < 0 then Exit;
  if PrefForm.TemplatesList.ItemIndex = PrefForm.TemplatesList.Items.Count-1 then Exit;
  PrefForm.TemplatesList.Items.Exchange(
      PrefForm.TemplatesList.ItemIndex,
      PrefForm.TemplatesList.ItemIndex+1);
  PrefForm.TemplatesList.ItemIndex:=PrefForm.TemplatesList.ItemIndex+1;
end;

procedure TPrefForm.InsertBtnClick(Sender: TObject);
var
  str : string;
begin
  if PrefForm.TemplatesList.ItemIndex < 0 then Exit;
  str := InputBox(S_InsertTemplateCaption, S_InsertTemplatePrompt, '');
  if str<>'' then
    PrefForm.TemplatesList.Items.Insert(PrefForm.TemplatesList.ItemIndex,str);
end;

procedure TPrefForm.ChangeBtnClick(Sender: TObject);
var str:string;
begin
  if PrefForm.TemplatesList.ItemIndex < 0 then Exit;
  str := InputBox(S_ChangeTemplateCaption,
                  S_ChangeTemplatePrompt,
                  PrefForm.TemplatesList.Items[PrefForm.TemplatesList.ItemIndex]);
  PrefForm.TemplatesList.Items[PrefForm.TemplatesList.ItemIndex]:=str;
end;

procedure TPrefForm.DeleteBtnClick(Sender: TObject);
var ttt:integer;
begin
  ttt:= PrefForm.TemplatesList.ItemIndex;
  if ttt < 0 then Exit;
  PrefForm.TemplatesList.Items.Delete(ttt);
  if ttt< PrefForm.TemplatesList.Items.Count-1 then
    PrefForm.TemplatesList.ItemIndex:=ttt
  else
    PrefForm.TemplatesList.ItemIndex:=ttt-1;
end;

procedure TPrefForm.TemplatesListDblClick(Sender: TObject);
begin
  ChangeBtnClick(Self);
end;

procedure TPrefForm.MShiftClick(Sender: TObject);
var lb:TListBox;
begin
  MacrosList.Visible:= not MShift.Down;
  ShiftMacrosList.Visible:= MShift.Down;
  if shtMacros = pagPrefs.ActivePage then
  begin
    if MShift.Down then lb:=ShiftMacrosList else lb := MacrosList;
    lb.SetFocus;
  end;
end;

procedure TPrefForm.MDeleteClick(Sender: TObject);
var lb:TListBox;
begin
  if MShift.Down then lb:=ShiftMacrosList else lb := MacrosList;
  lb.Items[lb.ItemIndex] := Copy(lb.Items[lb.ItemIndex],1,3);
  lb.SetFocus;
end;

procedure TPrefForm.MChangeClick(Sender: TObject);
var str:string;
    lb:TListBox;
begin
  if MShift.Down then lb:=ShiftMacrosList else lb := MacrosList;
  str := InputBox(S_ChangeMacroCaption,
                  Format(S_ChangeMacroPrompt, [lb.Items[lb.ItemIndex][1]]),
                  Copy(lb.Items[lb.ItemIndex],4,1000));
  MDeleteClick(Self);
  lb.Items[lb.ItemIndex]:=lb.Items[lb.ItemIndex]+str;
  lb.SetFocus;
end;

procedure TPrefForm.ShiftMacrosListDblClick(Sender: TObject);
begin
  MChangeClick(Self);
end;

procedure TPrefForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if ModalResult <> mrCancel then
  begin
    GetGeneralValues;
    GetEditorValues;
    GetStartupValues;
    GetTemplateValues;
    GetMacroValues;
    UpdateGlobalColorsAndStyles;
    GetGutterValues;
    GetKeystrokeValues;
    GetAPIValues;
  end;
// when we close the form we should focus the first control on the general page
  pagPrefs.ActivePage := shtGeneral;
  ActiveControl       := CheckSavePos;
end;

procedure TPrefForm.FormShow(Sender: TObject);
begin
  fColorsChanged := False;
  pagPrefs.ActivePage := shtGeneral;
  pagAPI.ActivePage   := shtAPIKeywords;
  // load values
  RememberGeneralValues;
  DisplayGeneralValues;
  RememberEditorValues;
  DisplayEditorValues;
  RememberAPIValues;
  DisplayAPIValues;
  RememberStartupValues;
  DisplayStartupValues;
  RememberTemplateValues;
  DisplayTemplateValues;
  RememberMacroValues;
  DisplayMacroValues;
  DisplayColorValues;
  RememberGutterValues;
  DisplayGutterValues;
  RememberKeystrokeValues;
  DisplayKeystrokeValues;
end;

procedure TPrefForm.FormCreate(Sender: TObject);
begin
  {Create the Registry}
  fReg := TRegistry.Create;
  // create global keystrokes list
  fKeystrokes := TSynEditKeyStrokes.Create(nil);
  fKeystrokes.ResetDefaults;
  // create global code template list
  fCodeTemplates := TStringList.Create;
  // create local highlighters list
  fLocalHighlighters := TStringList.Create;
  // populate local highlighters list
  GetHighlighters(Self, LocalHighlighters, False);
  cboLanguages.Items.Assign(LocalHighlighters);
  cboLanguages.ItemIndex := LocalHighlighters.IndexOf('NQC');
  // setup color components
  GetColorValues(AddColorName);
  LoadAttributeNames;
  StoreDefaultAttributes;
  ShowSampleSource;
  SynEdit1.Highlighter := GetActiveHighlighter;
  {Load the settings}
  LoadAllValues(fReg, Keystrokes, CodeTemplates);
  MainForm.UpdateSynComponents;
end;

procedure TPrefForm.FormDestroy(Sender: TObject);
begin
  if not RunningAsCOMServer then
    SaveAllValues(fReg, Keystrokes, CodeTemplates);
  fReg.Free;
  fKeystrokes.Free;
  fCodeTemplates.Free;
  fLocalHighlighters.Free;
end;

procedure TPrefForm.AddColorName(const S: string);
begin
  cbxREColor.Items.Add(S);
  cbxColor.Items.Add(S);
  cbxForeground.Items.Add(S);
  cbxBackground.Items.Add(S);
  cbxGutterColor.Items.Add(S);
end;

procedure TPrefForm.DisplayColorValues;
var
  j, i : Integer;
  SCH : TSynCustomHighlighter;
begin
  for j := 0 to Highlighters.Count - 1 do
  begin
    SCH := TSynCustomHighlighter(Highlighters.Objects[j]);
    // copy global values into local syntax highlighters
    for i := 0 to SCH.AttrCount - 1 do
    begin
      LanguageHighlighter[j].Attribute[i].Assign(SCH.Attribute[i]);
    end;
  end;
  // set listbox selection
  lbElements.ItemIndex := 0;
  lbElementsClick(lbElements);
end;

procedure TPrefForm.UpdateGlobalColorsAndStyles;
var
  j, i : Integer;
  SCH : TSynCustomHighlighter;
begin
  for j := 0 to Highlighters.Count - 1 do
  begin
    SCH := TSynCustomHighlighter(Highlighters.Objects[j]);
    // copy local values into global syntax highlighter
    for i := 0 to SCH.AttrCount - 1 do
    begin
      SCH.Attribute[i].Assign(LanguageHighlighter[j].Attribute[i]);
    end;
  end;
end;


procedure TPrefForm.lbElementsClick(Sender: TObject);
var
  i : Integer;
begin
  // show color and style
  i := lbElements.ItemIndex;
  UncheckStyles;
  UncheckDefaults;
  ResetColorGrid;
  if UsingFGDefault(i) then
    cgColor.ForegroundIndex := -1
  else
    cgColor.ForegroundIndex := cgColor.ColorToIndex(GetFGColor(i));
  if UsingBGDefault(i) then
    cgColor.BackgroundIndex := -1
  else
    cgColor.BackgroundIndex := cgColor.ColorToIndex(GetBGColor(i));
  CheckStyles;
  CheckDefaults;
  ShowItemInEditor(i);
end;

procedure TPrefForm.cgColorChange(Sender: TObject);
var
  i : integer;
begin
  i := lbElements.ItemIndex;
  if i = -1 then Exit;
  // change color (both fg and bg)
  if cgColor.ForegroundIndex <> -1 then
    SetFGColor(i, cgColor.ForegroundColor)
  else
    SetFGColor(i, GetFGDefault(lbElements.ItemIndex));
  if cgColor.BackgroundIndex <> -1 then
    SetBGColor(i, cgColor.BackgroundColor)
  else
    SetBGColor(i, GetBGDefault(lbElements.ItemIndex));

  fColorsChanged := True;
  CheckDefaults;
end;

procedure TPrefForm.chkBoldClick(Sender: TObject);
var
  idx : integer;
begin
  // add bold to style
  idx := lbElements.ItemIndex;
  if idx = -1 then Exit;
  if chkBold.Checked then
  begin
    SetStyles(idx, GetStyles(idx) + [fsBold]);
  end
  else
  begin
    SetStyles(idx, GetStyles(idx) - [fsBold]);
  end;
  fColorsChanged := True;
end;

procedure TPrefForm.chkItalicClick(Sender: TObject);
var
  idx : integer;
begin
  // add italic to style
  idx := lbElements.ItemIndex;
  if idx = -1 then Exit;
  if chkItalic.Checked then
  begin
    SetStyles(idx, GetStyles(idx) + [fsItalic]);
  end
  else
  begin
    SetStyles(idx, GetStyles(idx) - [fsItalic]);
  end;
  fColorsChanged := True;
end;

procedure TPrefForm.chkUnderlineClick(Sender: TObject);
var
  idx : integer;
begin
 // add underline to style
  idx := lbElements.ItemIndex;
  if idx = -1 then Exit;
  if chkUnderline.Checked then
  begin
    SetStyles(idx, GetStyles(idx) + [fsUnderline]);
  end
  else
  begin
    SetStyles(idx, GetStyles(idx) - [fsUnderline]);
  end;
  fColorsChanged := True;
end;

procedure SilentCheck(aCB : TCheckBox; bCheck : boolean);
var
  evt : TNotifyEvent;
begin
  evt := aCB.OnClick;
  aCB.OnClick := nil;
  try
    aCB.Checked := bCheck;
  finally
    aCB.OnClick := evt;
  end;
end;

procedure TPrefForm.UncheckStyles;
begin
  SilentCheck(chkBold, False);
  SilentCheck(chkItalic, False);
  SilentCheck(chkUnderline, False);
end;

procedure TPrefForm.CheckStyles;
var
  tmpStyles : TFontStyles;
begin
  tmpStyles := GetStyles(lbElements.ItemIndex);
  SilentCheck(chkBold, fsBold in tmpStyles);
  SilentCheck(chkItalic, fsItalic in tmpStyles);
  SilentCheck(chkUnderline, fsUnderline in tmpStyles);
end;

function TPrefForm.GetBGColor(idx: integer): TColor;
begin
  Result := GetActiveHighlighter.Attribute[idx].Background;
end;

function TPrefForm.GetFGColor(idx: integer): TColor;
begin
  Result := GetActiveHighlighter.Attribute[idx].Foreground;
end;

function TPrefForm.GetStyles(idx: integer): TFontStyles;
begin
  Result := GetActiveHighlighter.Attribute[idx].Style;
end;

procedure TPrefForm.SetStyles(idx: integer; aStyle: TFontStyles);
begin
  GetActiveHighlighter.Attribute[idx].Style := aStyle;
end;

procedure TPrefForm.SetBGColor(idx: integer; aColor: TColor);
begin
  GetActiveHighlighter.Attribute[idx].Background := aColor;
end;

procedure TPrefForm.SetFGColor(idx: integer; aColor: TColor);
begin
  GetActiveHighlighter.Attribute[idx].Foreground := aColor;
end;

procedure TPrefForm.chkFGClick(Sender: TObject);
begin
  if chkFG.Checked then
    cgColor.ForegroundIndex := -1;
end;

procedure TPrefForm.chkBGClick(Sender: TObject);
begin
  if chkBG.Checked then
    cgColor.BackgroundIndex := -1;
end;

procedure TPrefForm.CheckDefaults;
var
  i : integer;
begin
  i := lbElements.ItemIndex;
  SilentCheck(chkFG, UsingFGDefault(i));
  SilentCheck(chkBG, UsingBGDefault(i));
end;

procedure TPrefForm.UncheckDefaults;
begin
  SilentCheck(chkFG, False);
  SilentCheck(chkBG, False);
end;

function TPrefForm.UsingBGDefault(idx: integer): boolean;
begin
  Result := GetActiveHighlighter.Attribute[idx].Background = GetBGDefault(idx);
end;

function TPrefForm.UsingFGDefault(idx: integer): boolean;
begin
  Result := GetActiveHighlighter.Attribute[idx].Foreground = GetFGDefault(idx);
end;

function TPrefForm.GetBGDefault(idx: integer): TColor;
begin
  Result := fDefBGColors[ActiveLanguageIndex][idx];
end;

function TPrefForm.GetFGDefault(idx: integer): TColor;
begin
  Result := fDefFGColors[ActiveLanguageIndex][idx];
end;

procedure TPrefForm.StoreDefaultAttributes;
var
  j, i : Integer;
  SCH : TSynCustomHighlighter;
begin
  SetLength(fDefBGColors, LanguageCount);
  SetLength(fDefFGColors, LanguageCount);
  SetLength(fDefStyles, LanguageCount);
  for j := 0 to LanguageCount - 1 do
  begin
    SCH := LanguageHighlighter[j];
    SetLength(fDefBGColors[j], SCH.AttrCount);
    SetLength(fDefFGColors[j], SCH.AttrCount);
    SetLength(fDefStyles[j], SCH.AttrCount);
    for i := 0 to SCH.AttrCount - 1 do
    begin
      fDefBGColors[j][i] := SCH.Attribute[i].Background;
      fDefFGColors[j][i] := SCH.Attribute[i].Foreground;
      fDefStyles[j][i]   := SCH.Attribute[i].Style;
    end;
  end;
end;

procedure TPrefForm.DisplayGutterValues;
begin
  PrefForm.cbGutterVisible.Checked  := GutterVisible;
  PrefForm.cbLineNumbers.Checked    := ShowLineNumbers;
  PrefForm.cbLeadingZeros.Checked   := ShowLeadingZeros;
  PrefForm.cbAutoSize.Checked       := AutoSizeGutter;
  PrefForm.cbUseFontStyle.Checked   := UseFontStyle;
  PrefForm.cbZeroStart.Checked      := ZeroStart;
  PrefForm.inpDigitCount.Value      := DigitCount;
  PrefForm.inpLeftOffset.Value      := LeftOffset;
  PrefForm.inpRightOffset.Value     := RightOffset;
  PrefForm.inpGutterWidth.Value     := GutterWidth;
  PrefForm.cbxGutterColor.ItemIndex := PrefForm.cbxGutterColor.Items.IndexOf(ColorToString(GutterColor));
end;

procedure TPrefForm.UpdateGlobalGutterValues;
begin
  GutterVisible    := PrefForm.cbGutterVisible.Checked;
  ShowLineNumbers  := PrefForm.cbLineNumbers.Checked;
  ShowLeadingZeros := PrefForm.cbLeadingZeros.Checked;
  AutoSizeGutter   := PrefForm.cbAutoSize.Checked;
  UseFontStyle     := PrefForm.cbUseFontStyle.Checked;
  ZeroStart        := PrefForm.cbZeroStart.Checked;
  DigitCount       := PrefForm.inpDigitCount.Value;
  LeftOffset       := PrefForm.inpLeftOffset.Value;
  RightOffset      := PrefForm.inpRightOffset.Value;
  GutterWidth      := PrefForm.inpGutterWidth.Value;
  GutterColor      := StringToColor(PrefForm.cbxGutterColor.Text);
end;

procedure TPrefForm.DisplayKeystrokeValues;
begin
  SynEdit1.Keystrokes := Keystrokes;
end;

procedure TPrefForm.DisplayCodeTemplateValues;
begin
end;

procedure TPrefForm.UpdateGlobalKeystrokeValues;
begin
  Keystrokes := SynEdit1.Keystrokes;
end;

procedure TPrefForm.btnKeystrokesClick(Sender: TObject);
var
  Dlg: TSynEditKeystrokesEditorForm;
begin
  Dlg := TSynEditKeystrokesEditorForm.Create(Self);
  try
    Dlg.Caption := S_KeystrokeCaption;
    Dlg.Keystrokes := SynEdit1.Keystrokes;
    if Dlg.ShowModal = mrOk then begin
      SynEdit1.Keystrokes := Dlg.Keystrokes;
    end;
  finally
    Dlg.Free;
  end;
end;

procedure TPrefForm.SetKeystrokes(const Value: TSynEditKeyStrokes);
begin
  if Value = nil then
    fKeystrokes.Clear
  else
    fKeystrokes.Assign(Value);
end;

procedure TPrefForm.edtNQCTimeoutKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in [#8, #16, '0'..'9']) then
    Key := #0;
end;

procedure TPrefForm.SetCodeTemplates(const Value: TStrings);
begin
  if Value = nil then
    fCodeTemplates.Clear
  else
    fCodeTemplates.Assign(Value);
end;

procedure TPrefForm.btnEditCodeTemplatesClick(Sender: TObject);
begin
  with TfrmCodeTemplates.Create(nil) do
  try
    Caption := S_CodeTemplatesCaption;
    CodeTemplates := Self.CodeTemplates;
    if ShowModal = mrOk then begin
      Self.CodeTemplates := CodeTemplates;
    end;
  finally
    Free;
  end;
end;

procedure TPrefForm.btnClaimExtClick(Sender: TObject);
begin
  ClaimNQCExtension;
end;

function TPrefForm.GetActiveAPIEdit: TEdit;
begin
  if pagAPI.ActivePage = shtAPIKeywords then
    Result := edtKeyword
  else if pagAPI.ActivePage = shtAPICommands then
    Result := edtCommand
  else
    Result := edtConstant;
end;

function TPrefForm.GetActiveAPIListBox: TListBox;
begin
  if pagAPI.ActivePage = shtAPIKeywords then
    Result := lstKeywords
  else if pagAPI.ActivePage = shtAPICommands then
    Result := lstCommands
  else
    Result := lstConstants;
end;

procedure TPrefForm.btnAddAPIClick(Sender: TObject);
var
  LB : TListBox;
  ED : TEdit;
begin
  LB := GetActiveAPIListBox;
  ED := GetActiveAPIEdit;
  if ED.Text = '' then Exit;
  if LB.Items.IndexOf(ED.Text) = -1 then
    LB.Items.Add(ED.Text);
  UpdateAPIButtonState;
end;

procedure TPrefForm.btnDeleteAPIClick(Sender: TObject);
var
  LB : TListBox;
begin
  LB := GetActiveAPIListBox;
  if LB.ItemIndex = -1 then Exit;
  if MessageDlg(S_ConfirmAPIDelete, mtConfirmation, [mbYes,mbNo], 0) = mrYes then
    LB.Items.Delete(LB.ItemIndex);
  UpdateAPIButtonState;
end;

procedure TPrefForm.lstAPIClick(Sender: TObject);
var
  LB : TListBox;
  ED : TEdit;
begin
  LB := GetActiveAPIListBox;
  ED := GetActiveAPIEdit;
  if LB.ItemIndex <> -1 then
    ED.Text := LB.Items[LB.ItemIndex];
  UpdateAPIButtonState;
end;

procedure TPrefForm.edtAPIChange(Sender: TObject);
begin
  UpdateAPIButtonState;
end;

procedure TPrefForm.pagPrefsChange(Sender: TObject);
begin
  if pagPrefs.ActivePage = shtAPI then
    UpdateAPIButtonState;
end;

procedure TPrefForm.pagAPIChange(Sender: TObject);
begin
  UpdateAPIButtonState;
end;

procedure TPrefForm.UpdateAPIButtonState;
var
  ED : TEdit;
  LB : TListBox;
begin
  LB := GetActiveAPIListBox;
  ED := GetActiveAPIEdit;
  btnAddAPI.Enabled := ED.Text <> '';
  btnDeleteAPI.Enabled := LB.ItemIndex <> -1;
end;

procedure CleanupTransferList;
var
  i : integer;
begin
  if Assigned(fTransferList) then
  begin
    for i := 0 to fTransferList.Count - 1 do
    begin
      TTransferItem(fTransferList[i]).Free;
    end;
    FreeAndNil(fTransferList);
  end;
end;

procedure TPrefForm.ShowItemInEditor(i: Integer);
var
  y : Integer;
begin
  if ActiveLanguageIndex <> LocalHighlighters.IndexOf('NQC') then
    Exit;
  case i of
    0 : y := 10; // command
    1 : y := 2;  // comment
    2 : y := 13; // constant
    3 : y := 11; // field
    4 : y := 7;  // identifier
    5 : y := 5;  // keyword
    6 : y := 15; // number
    7 : y := 3;  // preprocessor
    8 : y := 8;  // space
    9 : y := 6;  // symbol
  else
    y := 1; // other
  end;
  SynEdit1.CaretXY := Point(1, y);
  if pagPrefs.ActivePage = shtColors then
    SynEdit1.SetFocus;
end;

procedure TPrefForm.LoadAttributeNames;
var
  i : Integer;
begin
  lbElements.Items.Clear;
  for i := 0 to GetActiveHighlighter.AttrCount - 1 do
  begin
    lbElements.Items.Add(GetActiveHighlighter.Attribute[i].Name);
  end;
end;

function TPrefForm.GetActiveHighlighter: TSynCustomHighlighter;
begin
  Result := LanguageHighlighter[ActiveLanguageIndex];
end;

procedure TPrefForm.ShowSampleSource;
begin
  SynEdit1.Text := GetActiveHighlighter.SampleSource;
end;

function TPrefForm.ActiveLanguageIndex: Integer;
begin
  Result := cboLanguages.ItemIndex;
end;

function TPrefForm.LanguageCount: Integer;
begin
  Result := LocalHighlighters.Count;
end;

function TPrefForm.GetCustomHighlighter(index: Integer): TSynCustomHighlighter;
begin
  Result := TSynCustomHighlighter(LocalHighlighters.Objects[index]);
end;

function TPrefForm.LocalHighlighters: TStringList;
begin
  Result := fLocalHighlighters;
end;

procedure TPrefForm.cboLanguagesChange(Sender: TObject);
begin
  LoadAttributeNames;
  ShowSampleSource;
  SynEdit1.Highlighter := GetActiveHighlighter;
end;

procedure TPrefForm.ResetColorGrid;
var
  OC : TNotifyEvent;
begin
  OC := cgColor.OnChange;
  cgColor.OnChange := nil;
  try
    cgColor.ForegroundIndex := -1;
    cgColor.BackgroundIndex := -1;
  finally
    cgColor.OnChange := OC;
  end;
end;

initialization
  fVersion := GetVersionInfo(Application.ExeName).ProductVersion;

finalization
  CleanupTransferList;
  FreeAndNil(fHighlighters);
end.
