unit Watch;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, DataAnalysis;

type
  TWatchForm = class(TForm)
    VarBox: TGroupBox;
    TimerBox: TGroupBox;
    CheckTimer0: TCheckBox;
    ValueTimer0: TEdit;
    CheckTimer1: TCheckBox;
    ValueTImer1: TEdit;
    CheckTimer2: TCheckBox;
    ValueTimer2: TEdit;
    PollNow: TButton;
    ValueTimer3: TEdit;
    CheckTimer3: TCheckBox;
    VVar0: TEdit;
    CVar0: TCheckBox;
    CVar1: TCheckBox;
    VVar1: TEdit;
    CVar2: TCheckBox;
    VVar2: TEdit;
    VVar3: TEdit;
    CVar3: TCheckBox;
    CVar4: TCheckBox;
    VVar4: TEdit;
    CVar5: TCheckBox;
    VVar5: TEdit;
    VVar6: TEdit;
    CVar6: TCheckBox;
    CVar7: TCheckBox;
    VVar7: TEdit;
    CVar8: TCheckBox;
    VVar8: TEdit;
    VVar9: TEdit;
    CVar9: TCheckBox;
    CVar10: TCheckBox;
    VVar10: TEdit;
    CVar11: TCheckBox;
    VVar11: TEdit;
    VVar12: TEdit;
    CVar12: TCheckBox;
    CVar13: TCheckBox;
    VVar13: TEdit;
    CVar14: TCheckBox;
    VVar14: TEdit;
    VVar15: TEdit;
    CVar15: TCheckBox;
    VVar16: TEdit;
    CVar16: TCheckBox;
    CVar17: TCheckBox;
    VVar17: TEdit;
    CVar18: TCheckBox;
    VVar18: TEdit;
    VVar19: TEdit;
    CVar19: TCheckBox;
    CVar20: TCheckBox;
    VVar20: TEdit;
    CVar21: TCheckBox;
    VVar21: TEdit;
    VVar22: TEdit;
    CVar22: TCheckBox;
    CVar23: TCheckBox;
    VVar23: TEdit;
    VVar24: TEdit;
    CVar24: TCheckBox;
    CVar25: TCheckBox;
    VVar25: TEdit;
    CVar26: TCheckBox;
    VVar26: TEdit;
    VVar27: TEdit;
    CVar27: TCheckBox;
    CVar28: TCheckBox;
    VVar28: TEdit;
    CVar29: TCheckBox;
    VVar29: TEdit;
    VVar30: TEdit;
    CVar30: TCheckBox;
    CVar31: TCheckBox;
    VVar31: TEdit;
    MotorBox: TGroupBox;
    CheckMotorA: TCheckBox;
    ValueMotorA: TEdit;
    CheckMotorB: TCheckBox;
    ValueMotorB: TEdit;
    CheckMotorC: TCheckBox;
    ValueMotorC: TEdit;
    SensorBox: TGroupBox;
    CheckSensor1: TCheckBox;
    ValueSensor1: TEdit;
    CheckSensor2: TCheckBox;
    ValueSensor2: TEdit;
    CheckSensor3: TCheckBox;
    ValueSensor3: TEdit;
    MessageBox: TGroupBox;
    CheckMessage: TCheckBox;
    ValueMessage: TEdit;
    CheckAllBtn: TButton;
    CheckNoneBtn: TButton;
    PollRegularBtn: TSpeedButton;
    TimeBox: TComboBox;
    Timer1: TTimer;
    TachoBox: TGroupBox;
    CheckTCounterL: TCheckBox;
    ValueTCounterL: TEdit;
    CheckTSpeedR: TCheckBox;
    ValueTSpeedR: TEdit;
    CheckMCurrent: TCheckBox;
    ValueMCurrent: TEdit;
    CounterBox: TGroupBox;
    CheckCounter0: TCheckBox;
    ValueCounter0: TEdit;
    CheckCounter1: TCheckBox;
    ValueCounter1: TEdit;
    CheckCounter2: TCheckBox;
    ValueCounter2: TEdit;
    btnGraph: TSpeedButton;
    chkIfActive: TCheckBox;
    ValueTCounterR: TEdit;
    CheckTCounterR: TCheckBox;
    ValueTSpeedL: TEdit;
    CheckTSpeedL: TCheckBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PollNowClick(Sender: TObject);
    procedure CheckAllBtnClick(Sender: TObject);
    procedure CheckNoneBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure PollRegularBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TimeBoxChange(Sender: TObject);
    procedure btnGraphClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
  private
    { Private declarations }
    fGraph : TfrmDataAnalysis;
    fNewData : TStrings;
    procedure UpdateGraph;
  public
    { Public declarations }
    procedure GraphDestroyed;
  end;

var
  WatchForm: TWatchForm;

implementation

{$R *.DFM}

uses
  SearchRCX, FakeSpirit, rcx_constants;

resourcestring
  sWatchError = 'Cannot find the brick anymore';

function GetMotorData(numb : integer) : string;
var ttt:integer;
    str:string;
begin
  ttt := FakeRCX.GetOutputStatus(numb);
  str:='';
  if ttt div 128 = 1 then str:=str+' On ' else str:=str+'Off ';
  if (ttt mod 128) div 64 = 1 then str:=str+'Brake ' else str:=str+'Float ';
  if (ttt mod 16) div 8 = 1 then str:=str+'Fwd ' else str:=str+'Rev ';
  str:=str+Format('  %d', [ttt mod 8]);
  Result := str;
end;

var busy:boolean = false;

procedure TWatchForm.PollNowClick(Sender: TObject);
var
  i : integer;
  val : integer;
  tmpStr : string;
begin
  if busy then exit;     // Avoid polling while polling
  busy:=true;
  try
    fNewData.Clear;
    for i:=0 to 31 do begin
      if TCheckBox(FindComponent(Format('CVar%d',[i]))).Checked then
      begin
        val := FakeRCX.GetVariableValue(i);
        tmpStr := Format('Var %d: %d', [i, val]);
        fNewData.Add(tmpStr);
        TEdit(FindComponent(Format('VVar%d',[i]))).Text := Format('%6d',[val]);
      end;
    end;
    if CheckSensor1.Checked then
    begin
      val := FakeRCX.GetInputValue(0);
      tmpStr := Format('Sensor %d: %d', [1, val]);
      fNewData.Add(tmpStr);
      ValueSensor1.Text := Format('%6d',[val]);
    end;
    if CheckSensor2.Checked then
    begin
      val := FakeRCX.GetInputValue(1);
      tmpStr := Format('Sensor %d: %d', [2, val]);
      fNewData.Add(tmpStr);
      ValueSensor2.Text := Format('%6d',[val]);
    end;
    if CheckSensor3.Checked then
    begin
      val := FakeRCX.GetInputValue(2);
      tmpStr := Format('Sensor %d: %d', [3, val]);
      fNewData.Add(tmpStr);
      ValueSensor3.Text := Format('%6d',[val]);
    end;

    if CheckMotorA.Checked then
      ValueMotorA.Text := GetMotorData(0);
    if CheckMotorB.Checked then
      ValueMotorB.Text := GetMotorData(1);
    if CheckMotorC.Checked then
      ValueMotorC.Text := GetMotorData(2);

    if CheckTimer0.Checked then
    begin
      val := FakeRCX.GetTimerValue(0);
      tmpStr := Format('Timer %d: %d', [0, val]);
      fNewData.Add(tmpStr);
      ValueTimer0.Text := Format('%6d',[val]);
    end;
    if CheckTimer1.Checked then
    begin
      val := FakeRCX.GetTimerValue(1);
      tmpStr := Format('Timer %d: %d', [1, val]);
      fNewData.Add(tmpStr);
      ValueTimer1.Text := Format('%6d',[val]);
    end;
    if CheckTimer2.Checked then
    begin
      val := FakeRCX.GetTimerValue(2);
      tmpStr := Format('Timer %d: %d', [2, val]);
      fNewData.Add(tmpStr);
      ValueTimer2.Text := Format('%6d',[val]);
    end;
    // timer 3 is only Cybermaster, RCX, & RCX2
    if CheckTimer3.Checked then
    begin
      val := FakeRCX.GetTimerValue(3);
      tmpStr := Format('Timer %d: %d', [3, val]);
      fNewData.Add(tmpStr);
      ValueTimer3.Text := Format('%6d',[val]);
    end;

    // counters only apply to RCX2 & Scout
    if CheckCounter0.Checked then
    begin
      val := FakeRCX.GetCounterValue(0);
      tmpStr := Format('Counter %d: %d', [0, val]);
      fNewData.Add(tmpStr);
      ValueCounter0.Text := Format('%6d',[val]);
    end;
    if CheckCounter1.Checked then
    begin
      val := FakeRCX.GetCounterValue(1);
      tmpStr := Format('Counter %d: %d', [1, val]);
      fNewData.Add(tmpStr);
      ValueCounter1.Text := Format('%6d',[val]);
    end;
    // counter 2 is only RCX2
    if CheckCounter2.Checked then
    begin
      val := FakeRCX.GetCounterValue(2);
      tmpStr := Format('Counter %d: %d', [2, val]);
      fNewData.Add(tmpStr);
      ValueCounter2.Text := Format('%6d',[val]);
    end;

    // this is RCX & Scout only
    if CheckMessage.Checked then
    begin
      val := FakeRCX.GetMessageValue(0);
      tmpStr := Format('Message : %d', [val]);
      fNewData.Add(tmpStr);
      ValueMessage.Text := Format('%6d',[val]);
    end;

    // these only apply to Cybermaster
    if CheckTCounterL.Checked then
    begin
      val := FakeRCX.Poll(kRCX_TachCounterType,0);
      tmpStr := Format('Tacho Counter Left: %d', [val]);
      fNewData.Add(tmpStr);
      ValueTCounterL.Text := Format('%6d', [val]);
    end;
    if CheckTCounterR.Checked then
    begin
      val := FakeRCX.Poll(kRCX_TachCounterType,1);
      tmpStr := Format('Tacho Counter Right: %d', [val]);
      fNewData.Add(tmpStr);
      ValueTCounterR.Text := Format('%6d', [val]);
    end;
    if CheckTSpeedL.Checked then
    begin
      val  := FakeRCX.Poll(kRCX_TachSpeedType,0);
      tmpStr := Format('Tacho Speed Left: %d', [val]);
      fNewData.Add(tmpStr);
      ValueTSpeedL.Text := Format('%6d', [val]);
    end;
    if CheckTSpeedR.Checked then
    begin
      val  := FakeRCX.Poll(kRCX_TachSpeedType,1);
      tmpStr := Format('Tacho Speed Right: %d', [val]);
      fNewData.Add(tmpStr);
      ValueTSpeedR.Text := Format('%6d', [val]);
    end;
    if CheckMCurrent.Checked then
    begin
      val := FakeRCX.Poll(kRCX_OutputCurrentType,2);
      tmpStr := Format('Motor Current: %d', [val]);
      fNewData.Add(tmpStr);
      ValueMCurrent.Text := Format('%6d',[val]);
    end;
    // end of Cybermaster-only watch elements
    UpdateGraph;
    busy:=false;
  except
    ShowMessage(sWatchError);
    Timer1.Enabled := false;
    PollRegularBtn.Down := false;
    busy:=false;
  end;
end;

procedure TWatchForm.CheckAllBtnClick(Sender: TObject);
var i: Integer;
    temp: TComponent;
    bChk : boolean;
begin
  for i := WatchForm.ComponentCount - 1 downto 0 do
  begin
    temp := WatchForm.Components[i];
    if (temp is TCheckBox) and TCheckBox(temp).Visible then
      TCheckBox(temp).Checked := true;
  end;
  if IsRCX or IsScout then
  begin
    CheckTCounterL.Checked := false;
    CheckTSpeedL.Checked   := false;
    CheckTCounterR.Checked := false;
    CheckTSpeedR.Checked   := false;
    CheckMCurrent.Checked  := false;
    bChk                  := IsScout or IsRCX2;
    CheckCounter0.Checked := bChk;
    CheckCounter1.Checked := bChk;
    CheckCounter2.Checked := IsRCX2;
  end
  else
  begin
    CheckMessage.Checked := false;
  end;
end;

procedure TWatchForm.CheckNoneBtnClick(Sender: TObject);
var i: Integer;
    temp: TComponent;
begin
  for i := WatchForm.ComponentCount - 1 downto 0 do
  begin
    temp := WatchForm.Components[i];
    if (temp is TCheckBox) then
      TCheckBox(temp).Checked := false;
  end;
end;

procedure TWatchForm.Timer1Timer(Sender: TObject);
begin
  PollNowClick(Self);
end;

procedure TWatchForm.PollRegularBtnClick(Sender: TObject);
begin
  Timer1.Enabled := PollRegularBtn.Down;
end;

procedure TWatchForm.FormShow(Sender: TObject);
const
  NEW_FORM_HEIGHT = 405 - 77;
  NEW_VAR_HEIGHT  = 220;
  NEW_MOTOR_WIDTH = 265 - 24;
var
  i : integer;
  bVis : boolean;
  cb : TCheckBox;
begin
  for i := 0 to 31 do
  begin
    bVis := (i in [0..9]) or not IsScout;
    cb := TCheckBox(FindComponent(Format('CVar%d',[i])));
    cb.Visible := bVis;
    if not cb.Visible then
      cb.Checked := False;
    TEdit(FindComponent(Format('VVar%d',[i]))).Visible := bVis;
  end;
  CheckTimer3.Visible := not IsScout;
  ValueTimer3.Visible := not IsScout;
  // counter 2 only visible if RCX2
  CheckCounter2.Visible := IsRCX2;
  ValueCounter2.Visible := IsRCX2;
  PollRegularBtn.Down := false;
  Timer1.Enabled := false;
  busy := false;
  if IsRCX or IsScout then
  begin
    MessageBox.Visible    := True;
    TachoBox.Visible      := False;
    CheckTCounterL.Checked := False;
    CheckTSpeedL.Checked   := False;
    CheckTCounterR.Checked := False;
    CheckTSpeedR.Checked   := False;
    CheckMCurrent.Checked  := False;
    CounterBox.Visible    := IsRCX2 or IsScout;
    if IsRCX2 or IsScout then
    begin
      // move counter box on top of tacho box
      CounterBox.Top := TachoBox.Top;
      if IsScout then
      begin
        // move up the motors and shorten the height of the variable box
        // also shorten the form
        VarBox.Height := NEW_VAR_HEIGHT;
        MotorBox.Top  := CounterBox.Top;
        Self.Height   := NEW_FORM_HEIGHT;
      end;
    end
    else
    begin
      // for RCX we move the motor box up to the tacho box position
      // and shorten the form
      MotorBox.Top   := TachoBox.Top;
      MotorBox.Left  := TachoBox.Left;
      MotorBox.Width := NEW_MOTOR_WIDTH;
      Self.Height    := NEW_FORM_HEIGHT;
    end;
  end
  else
  begin
    TachoBox.Visible      := True;
    MessageBox.Visible    := False;
    CheckMessage.Checked  := False;
    CounterBox.Visible    := False;
    CheckCounter0.Checked := False;
    CheckCounter1.Checked := False;
    CheckCounter2.Checked := False;
    // move the tachobox on top of the message box
    TachoBox.Top := MessageBox.Top;
  end;
end;

procedure TWatchForm.FormCreate(Sender: TObject);
begin
  fNewData := TStringList.Create;
  fGraph := nil;
  TimeBox.ItemIndex := 3;
end;

procedure TWatchForm.TimeBoxChange(Sender: TObject);
begin
  case TimeBox.ItemIndex of
    0: Timer1.Interval := 100;
    1: Timer1.Interval := 200;
    2: Timer1.Interval := 500;
    3: Timer1.Interval := 1000;
    4: Timer1.Interval := 2000;
    5: Timer1.Interval := 5000;
    6: Timer1.Interval := 10000;
  end;
end;

procedure TWatchForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Timer1.Enabled := false;
end;

procedure TWatchForm.btnGraphClick(Sender: TObject);
begin
  if not btnGraph.Down then
  begin
    // close graph form and nil our pointer
    if Assigned(fGraph) then
    begin
      fGraph.Close;
      fGraph := nil;
    end;
  end
  else
  begin
    // create graph form and show it
    fGraph := TfrmDataAnalysis.Create(Application);
    fGraph.FromWatch   := True;
    fGraph.WatchPoints := 10;
    fGraph.DataIsXY    := False;
    fGraph.Show;
  end;
end;

procedure TWatchForm.FormDestroy(Sender: TObject);
begin
  fNewData.Free;
end;

procedure TWatchForm.UpdateGraph;
begin
  if Assigned(fGraph) then
  begin
    fGraph.AddNewData(fNewData);
  end;
end;

procedure TWatchForm.GraphDestroyed;
begin
  // called by data analysis form when it closes
  if Assigned(fGraph) then
  begin
    fGraph := nil;
    btnGraph.Down := False;
  end;
end;

procedure TWatchForm.FormActivate(Sender: TObject);
begin
  if chkIfActive.Checked then
    Timer1.Enabled := PollRegularBtn.Down;
end;

procedure TWatchForm.FormDeactivate(Sender: TObject);
begin
  if chkIfActive.Checked then
    Timer1.Enabled := False;
end;

end.
