unit rcx_constants;

interface

const
  // opcodes
  kRCX_PingOp			      = $10;
  kRCX_MemMapOp         = $20; // not scout
  kRCX_BatteryLevelOp   = $30; // not scout
  kRCX_DeleteTasksOp    = $40;
  kRCX_StopAllOp		    = $50;
  kRCX_PBTurnOffOp      = $60;
  kRCX_DeleteSubsOp	    = $70;
  kRCX_ClearSound       = $80; // rcx2 only
  kRCX_ClearMsgOp		    = $90;
  kRCX_ExitAccessCtrlOp = $a0; // rcx2 and scout (program)
  kRCX_ExitEventChkOp   = $b0; // rcx2 and scout (program)
  kRCX_LSCalibrateOp    = $c0; // scout
  kRCX_MuteSoundOp      = $d0; // rcx2 only
  kRCX_UnmuteSoundOp    = $e0; // rcx2 only
//  kRCX_UnknownOp        = $f0;

//  kRCX_UnknownOp       = $01;
  kRCX_ClearTachoOp	   = $11; // cybermaster only
  kRCX_OutputModeOp	   = $21;
  kRCX_IRModeOp	       = $31;
  kRCX_DriveOp	       = $41; // cybermaster only
  kRCX_PlaySoundOp	   = $51;
  kRCX_DeleteTaskOp    = $61;
  kRCX_StartTaskOp	   = $71;
  kRCX_StopTaskOp		   = $81;
  kRCX_SelectProgramOp = $91; // rcx only
  kRCX_ClearTimerOp	   = $a1;
  kRCX_AutoOffOp	     = $b1;
  kRCX_DeleteSubOp     = $c1;
  kRCX_ClearSensorOp   = $d1;
  kRCX_OutputDirOp	   = $e1;
//  kRCX_UnknownOp       = $f1;

  kRCX_PlayVarOp      = $02;
  kRCX_ReadOp			    = $12;
  kRCX_SetWatchOp		  = $22;
  kRCX_InputTypeOp	  = $32;
  kRCX_InputModeOp	  = $42;
  kRCX_SetDatalogOp	  = $52;
  kRCX_DatalogOp		  = $62;
  kRCX_JumpOp			    = $72; // (program)
  kRCX_SetLoopOp	    = $82; // (program)
  kRCX_CheckLoopOp	  = $92; // (program)
//  kRCX_UnknownOp      = $a2;
  kRCX_SendMessageOp  = $b2; // (program)
  kRCX_SendUARTDataOp = $c2; // rcx2 only
  kRCX_OnWaitOp	      = $c2; // cybermaster only
  kRCX_Remote	        = $d2; // rcx2 & scout only
  kRCX_VLLOp          = $e2; // scout
  kRCX_DecVarJmpLTZOp = $f2; // (program)

  kRCX_DirectEventOp     = $03;
  kRCX_OutputPowerOp     = $13;
  kRCX_PlayToneOp		     = $23;
  kRCX_DisplayOp		     = $33;
  kRCX_DelayOp		       = $43; // (program)
  kRCX_OnWaitDifferentOp = $53; // cybermaster only
  kRCX_PollMemoryOp	     = $63; // rcx2 and scout only
  kRCX_EnterAccessCtrlOp = $73; // rcx2 & scout (program)
  kRCX_SetFeedbackOp     = $83; // scout
  kRCX_SetEventOp        = $93; // rcx2 only
  kRCX_GOutputPowerOp	   = $a3; // rcx2 & scout only
  kRCX_LSUpperThreshOp   = $b3; // scout
  kRCX_LSLowerThreshOp   = $c3; // scout
  kRCX_LSHysteresisOp    = $d3; // scout
  kRCX_LSBlinkTimeOp     = $e3; // scout
  kRCX_LDecVarJmpLTZOp   = $f3; // (program)

  kRCX_CalibrateEventOp = $04; // rcx2 only
  kRCX_SetVarOp         = $14;
  kRCX_SumVarOp         = $24;
  kRCX_SubVarOp         = $34;
  kRCX_DivVarOp         = $44;
  kRCX_MulVarOp         = $54;
  kRCX_SgnVarOp         = $64;
  kRCX_AbsVarOp         = $74;
  kRCX_AndVarOp         = $84;
  kRCX_OrVarOp          = $94;
  kRCX_UploadDatalogOp  = $a4;
  kRCX_SEnterEventChkOp = $b4; // rcx2 and scout (program)
  kRCX_SetTimerLimitOp  = $c4; // scout
  kRCX_SetCounterOp     = $d4; // scout
//  kRCX_UnknownOp        = $e4;
//  kRCX_UnknownOp        = $f4;

  kRCX_SetSourceValueOp = $05;
  kRCX_UnlockPBrick     = $15;
  kRCX_BeginTaskOp      = $25; // (program)
  kRCX_BeginSubOp	      = $35; // (program)
  kRCX_ContinueDLOp     = $45; // (program)
//  kRCX_UnknownOp        = $55;
  kRCX_BootModeOp		    = $65;
  kRCX_BeginFirmwareOp  = $75; // (program)
  kRCX_SCheckDoOp       = $85; // (program)
  kRCX_TestOp			      = $95; // (program)
  kRCX_UnlockFirmOp     = $a5;
  kRCX_LEnterEventChkOp = $b5; // rcx2 only (program)
//  kRCX_UnknownOp        = $c5;
  kRCX_ScoutRulesOp     = $d5; // scout
  kRCX_ViewSourceValOp  = $e5; // rcx2 only
//  kRCX_UnknownOp        = $f5;

  kRCX_ClearAllEventsOp = $06; // rcx2 only
//  kRCX_UnknownOp        = $16;
//  kRCX_UnknownOp        = $26;
//  kRCX_UnknownOp        = $36;
//  kRCX_UnknownOp        = $46;
//  kRCX_UnknownOp        = $56;
//  kRCX_UnknownOp        = $66;
//  kRCX_UnknownOp        = $76;
//  kRCX_UnknownOp        = $86;
//  kRCX_UnknownOp        = $96;
//  kRCX_UnknownOp        = $a6;
//  kRCX_UnknownOp        = $b6;
//  kRCX_UnknownOp        = $c6;
//  kRCX_UnknownOp        = $d6;
//  kRCX_UnknownOp        = $e6;
  kRCX_EndOfSubOp       = $F6; // (program)

//  kRCX_UnknownOp      = $07;
  kRCX_GoSubOp		    = $17; // (program)
  kRCX_SJumpOp		    = $27; // (program)
  kRCX_SChkLoopCtrOp  = $37; // (program)
  kRCX_ScoutOp        = $47; // scout
  kRCX_SoundOp        = $57; // scout
  kRCX_GOutputModeOp  = $67; // rcx2 & scout
  kRCX_GOutputDirOp	  = $77; // rcx2 & scout
  kRCX_LightOp        = $87; // scout
  kRCX_IncCounterOp   = $97; // rcx2 & scout
  kRCX_DecCounterOp   = $a7; // rcx2 & scout
  kRCX_ClearCounterOp = $b7; // rcx2 & scout
//  kRCX_UnknownOp      = $c7;
  kRCX_SetPriorityOp  = $d7; // rcx2 & scout (program)
//  kRCX_UnknownOp      = $e7;
  kRCX_Message        = $f7;

  // special
  kRCX_UnlockOp		     = $1d;
  kRCX_DownloadOp	     = $4d;

  // output mode
	kRCX_OutputFloat = 0;
	kRCX_OutputOff   = $40;
	kRCX_OutputOn    = $80;

  // output direction
	kRCX_OutputBackward = 0;
	kRCX_OutputToggle   = $40;
	kRCX_OutputForward  = $80;

type
  // value type
  TRcxValueType = 0..36;

const
  kRCX_VariableType          = 0;
  kRCX_TimerType             = 1;
  kRCX_ConstantType          = 2;
  kRCX_OutputStatusType      = 3;
  kRCX_RandomType            = 4;
  kRCX_TachCounterType       = 5; // cybermaster only
  kRCX_TachSpeedType         = 6; // cybermaster only
  kRCX_OutputCurrentType     = 7; // cybermaster only
  kRCX_ProgramSlotType       = 8; // RCX only
  kRCX_InputValueType        = 9;
  kRCX_InputTypeType         = 10;
  kRCX_InputModeType         = 11;
  kRCX_InputRawType          = 12;
  kRCX_InputBooleanType      = 13;
  kRCX_WatchType             = 14;
  kRCX_MessageType           = 15;
  kRCX_AGCType               = 16; // cybermaster only
  kRCX_GlobalMotorStatusType = 17;
  kRCX_ScoutRulesType        = 18; // scout only
  kRCX_ScoutLightParamsType  = 19; // scout only
  kRCX_ScoutTimerLimitType   = 20; // scout only
  kRCX_CounterType           = 21; // RCX2 & Scout only
  kRCX_ScoutCounterLimitType = 22; // scout only
  kRCX_TaskEventsType        = 23;
  kRCX_ScoutEventFBType      = 24; // scout only
  kRCX_EventStateType        = 25;
  kRCX_TenMSTimerType        = 26; // fast timer RCX2
  kRCX_ClickCounterType      = 27;
  kRCX_UpperThresholdType    = 28;
  kRCX_LowerThresholdType    = 29;
  kRCX_HysteresisType        = 30;
  kRCX_DurationType          = 31;
  kRCX_TypeUnused32          = 32;
  kRCX_UARTSetupType         = 33; // RCX2
  kRCX_BatteryLevelType      = 34;
  kRCX_FirmwareVersionType   = 35;
  kRCX_IndirectType          = 36;

const
//  kRCX_ValueUsesTemp = $1000000;

  // input mode
	kRCX_InputRaw             = 0;
	kRCX_InputBoolean         = $20;
	kRCX_InputEdgeCounter     = $40;
	kRCX_InputPeriodicCounter = $60;
	kRCX_InputPercentage      = $80;
	kRCX_InputCelcius         = $a0;
	kRCX_InputFahrenheit      = $c0;
	kRCX_InputAngle           = $e0;

type
  // input type
  TRcxInputType = (kRCX_InputNone, kRCX_InputSwitch, kRCX_InputTemp,
    kRCX_InputLight, kRCX_InputRotation, kRCX_InputID0, kRCX_InputID1,
    kRCX_InputID2);

  // rcx relation
  TRcxRelation = (kRCX_LessOrEqual, kRCX_GreaterOrEqual, kRCX_NotEqualTo,
    kRCX_EqualTo);

const
  kRCX_OK	             =  0;
  kRCX_OpenSerialError = -1;	// serial port could not be opened and/or configured
  kRCX_IREchoError     = -2;	// no echo received from IR tower
  kRCX_ReplyError      = -3;	// no (or invalid) reply from RCX
  kRCX_RequestError    = -4;	// attempt to send too much data
  kRCX_FileError       = -5;	// could not open/read/write file
  kRCX_FormatError     = -6;	// unknown file format
  kRCX_AbortError      = -7;	// canceled by RCX_Link::DownloadProgress()
  kRCX_MemFullError    = -8;	// not enough room in RCX program memory
  kRCX_LastError       = -8;	//	last error code
  
implementation

end.
