unit uMacroEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SynEditHighlighter, SynEdit, BricxccSynEdit, SynHighlighterNQC,
  SynCompletionProposal;

type
  TfrmMacroEditor = class(TForm)
    btnOK: TButton;
    btnCancel: TButton;
    TheEditor: TBricxccSynEdit;
    SynCompProp: TSynCompletionProposal;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    TheHighlighter: TSynNQCSyn;
    procedure SetMacroText(const Value: string);
    function GetMacroText: string;
    function GetMacroName: string;
    procedure AddCommand(const S: string);
  public
    { Public declarations }
    property MacroText : string read GetMacroText write SetMacroText;
    property MacroName : string read GetMacroName;
  end;

var
  frmMacroEditor: TfrmMacroEditor;

implementation

{$R *.DFM}

uses
  SynEditKeyCmds;

{ TfrmMacroEditor }

function TfrmMacroEditor.GetMacroName: string;
var
  s : string;
  i : Integer;
begin
  Result := '';
  if TheEditor.Lines.Count > 0 then
  begin
    s := Trim(TheEditor.Lines[0]);
    i := Pos('macro', s);
    if i = 1 then
    begin
      Delete(s, 1, 6);
      Result := Trim(s);
    end;
  end;
end;

function TfrmMacroEditor.GetMacroText: string;
begin
  Result := TheEditor.Text;
end;

procedure TfrmMacroEditor.SetMacroText(const Value: string);
begin
  TheEditor.Text := Value;
end;

procedure TfrmMacroEditor.FormCreate(Sender: TObject);
begin
  TheHighlighter := TSynNQCSyn.Create(Self);
  with TheHighlighter do
  begin
    Name := 'TheHighlighter';
    DetectPreprocessor := False;
    Left := 136;
    Top := 128;
    CommentAttri.Foreground := clSilver;
    CommandAttri.Foreground := clMaroon;
    PreprocessorAttri.Foreground := clNone;
    FieldAttri.Foreground := clBlue;
    FieldAttri.Style := [];
    FieldDelim := sdSingleQuote;
    KeyWords.Add('begin');
    KeyWords.Add('end');
    KeyWords.Add('macro');
  end;
  GetEditorCommandValues(AddCommand);
  SynCompProp.ItemList.Assign(TheHighlighter.Commands);
  TheEditor.Highlighter := TheHighlighter;
end;

procedure TfrmMacroEditor.AddCommand(const S: string);
begin
  TheHighlighter.Commands.Add(S);
end;

end.
