unit uWindowList;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrmWindowList = class(TForm)
    btnOK: TButton;
    btnCancel: TButton;
    btnHelp: TButton;
    lstWindows: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnHelpClick(Sender: TObject);
    procedure lstWindowsDblClick(Sender: TObject);
  private
    { Private declarations }
    procedure GotoSelectedWindow;
    procedure PopulateWindowList;
  public
    { Public declarations }
  end;

var
  frmWindowList: TfrmWindowList;

implementation

{$R *.DFM}

uses
  uCodeExplorer;

procedure TfrmWindowList.FormCreate(Sender: TObject);
begin
  PopulateWindowList;
end;

procedure TfrmWindowList.btnOKClick(Sender: TObject);
begin
  GotoSelectedWindow;
end;

procedure TfrmWindowList.GotoSelectedWindow;
var
  i : Integer;
  F : TForm;
begin
  i := lstWindows.ItemIndex;
  if i <> -1 then
  begin
    F := TForm(lstWindows.Items.Objects[i]);
    F.BringToFront;
    Windows.SetFocus(F.Handle);
  end;
  ModalResult := mrOk;
end;

procedure TfrmWindowList.btnHelpClick(Sender: TObject);
begin
  Application.HelpContext(HelpContext);
end;

procedure TfrmWindowList.PopulateWindowList;
var
  i : Integer;
  C : string;
  F : TForm;
begin
  lstWindows.Clear;
  for i := 0 to Screen.FormCount - 1 do
  begin
    F := Screen.Forms[i];
    if F.Visible and not (F is TfrmCodeExplorer) then
    begin
      C := F.Caption;
      lstWindows.Items.AddObject(C, F);
    end;
  end;
  if lstWindows.Items.Count > 0 then
    lstWindows.ItemIndex := 0;
end;

procedure TfrmWindowList.lstWindowsDblClick(Sender: TObject);
begin
  GotoSelectedWindow;
end;

end.
